/*
 * ConsultaMunicipi.java
 *
 * Created on 12 de junio de 2006, 10:50
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Panadero
 */
public class ConsultaMunicipi 
{
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    public  ResultSet    rSelectPublic;     // Lo utilizaremos para tirar adelante y atras los selects.
    
    // De la base de datos
    public  int          CDG_PRV;           // Nmero de identificacin de la provincia.        (Posat per nosaltres)
    public  int          CDG_MNC;           // Nmero que identifica la provincia.              (Posat per nosaltres)
    
    public  String       FFIN;              // Data que ens marca fins a on volen que busquem.  (Posat per l'usuari)
    
    // Contenedores de otras clases.
    public  PDREntColectiva  EntColectiva;  // Objecta Entitat Colectiva.                       (Posat per l'usuari)
    public  PDREntSingular   EntSingular;   // Objecta Entitat Singular.                        (Posat per l'usuari)
    public  PDRNucli         Nucli;         // Objecta Nucli.                                   (Posat per l'usuari)
    public  PDRPseudovia     Pseudovia;     // Objecta Pseudovia.                               (Posat per l'usuari)
    public  PDRVia           Via;           // Objecta Via.                                     (Posat per l'usuari)
    public  PDRTram          Tram;          // Objecta Tram.                                    (Posat per l'usuari)
    
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    // Dades del Usuari
    public  int        CDG_USR;         // Nmero que identifica al usuari que esta realitzan les accion (Posat per nosaltres)
    
    /** Creates a new instance of ConsultaMunicipi */
    public ConsultaMunicipi(int USR) 
    {
      // Relacionada con la base de datos
      BDConnexio   con;    
      ResultSet    rSelectPublic;
    
      // De la base de datos
      CDG_PRV = -1;          
      CDG_MNC = -1;         
    
      FFIN    = "";        
    
      // Contenedores de otras clases.
      EntColectiva = new PDREntColectiva(USR); 
      EntSingular  = new PDREntSingular(USR); 
      Nucli        = new PDRNucli(USR);       
      Pseudovia    = new PDRPseudovia(USR);   
      Via          = new PDRVia(USR);          
      Tram         = new PDRTram(USR);        
    
      // Relacionada con Errores
      sError = "";       
      // Dades del Usuari
      CDG_USR = -1;     
    }
    
    /** Creates a new instance of ConsultaMunicipi */
    public ConsultaMunicipi(BDConnexio conexion, int USR) 
    {
      // Relacionada con la base de datos
      con  =  conexion;    
      rSelectPublic = null;
    
      // De la base de datos
      CDG_PRV = -1;          
      CDG_MNC = -1;         
    
      FFIN    = "";        
    
      // Contenedores de otras clases.
      EntColectiva = new PDREntColectiva(conexion, USR); 
      EntSingular  = new PDREntSingular(conexion, USR); 
      Nucli        = new PDRNucli(conexion, USR);       
      Pseudovia    = new PDRPseudovia(conexion, USR);   
      Via          = new PDRVia(conexion, USR);          
      Tram         = new PDRTram(conexion, USR);        
    
      // Relacionada con Errores
      sError = "";       
      // Dades del Usuari
      CDG_USR = -1;     
    }
    
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    public void reiniciar()
    {              
      // Relacionada con la base de datos  
      rSelectPublic = null;
    
      // Contenedores de otras clases.
      EntColectiva.reiniciar();
      EntSingular.reiniciar();
      Nucli.reiniciar();
      Pseudovia.reiniciar();
      Via.reiniciar();
      Tram.reiniciar();
    
      // Relacionada con Errores
      sError = "";       
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {   
        String sData;
      try
      {
          // De la base de datos
          CDG_PRV     = Integer.parseInt(rSelect.getString("CDG_PRV")); 
          CDG_MNC     = Integer.parseInt(rSelect.getString("CDG_MNC"));
       
          CDG_USR         = Integer.parseInt(rSelect.getString("CDG_USR"));   

          // Carguem les dades de la Entitat Colectiva.
          if (Integer.parseInt(rSelect.getString("EntColectiva")) != -1)
          {
              EntColectiva.CDG_PRV = CDG_PRV;
              EntColectiva.CDG_MNC = CDG_MNC;
              EntColectiva.darEntColectiva(Integer.parseInt(rSelect.getString("EntColectiva")),"");
              // Intoduim el posibles error en els errors d'aquest objecte.
              if (EntColectiva.sError.compareTo("") != 0)
              {
                 sError = sError + EntColectiva.sError + "<br />"; 
              }
          }
          else
          {
            EntColectiva.reiniciar();
          }
          
          // Carguem les dades de la Entitat Singular.
          if (Integer.parseInt(rSelect.getString("EntSingular")) != -1)
          {
              EntSingular.CDG_PRV = CDG_PRV;
              EntSingular.CDG_MNC = CDG_MNC;
              EntSingular.darEntSingular(Integer.parseInt(rSelect.getString("EntSingular")),"");
              // Intoduim el posibles error en els errors d'aquest objecte.
              if (EntSingular.sError.compareTo("") != 0)
              {
                 sError = sError + EntSingular.sError + "<br />"; 
              }
          }
          else
          {
            EntSingular.reiniciar();
          }
          
          // Carguem les dades del Nucli.
          if (Integer.parseInt(rSelect.getString("Nucli")) != -1)
          {
              Nucli.CDG_PRV = CDG_PRV;
              Nucli.CDG_MNC = CDG_MNC;
              Nucli.darNucli(Integer.parseInt(rSelect.getString("Nucli")),"");
              // Intoduim el posibles error en els errors d'aquest objecte.
              if (Nucli.sError.compareTo("") != 0)
              {
                 sError = sError + Nucli.sError + "<br />"; 
              }
          }
          else
          {
            Nucli.reiniciar();
          }
          
          // Carguem les dades de la Pseudovia.
          if (Integer.parseInt(rSelect.getString("Pseudovia")) != -1)
          {
              Pseudovia.CDG_PRV = CDG_PRV;
              Pseudovia.CDG_MNC = CDG_MNC;
              Pseudovia.darPseudovia(Integer.parseInt(rSelect.getString("Pseudovia")),"");
              // Intoduim el posibles error en els errors d'aquest objecte.
              if (Pseudovia.sError.compareTo("") != 0)
              {
                 sError = sError + Pseudovia.sError + "<br />"; 
              }
          }
          else
          {
            Pseudovia.reiniciar();
          }
          
          // Carguem les dades de la Via.
          if (Integer.parseInt(rSelect.getString("Via")) != -1)
          {
              Via.CDG_PRV = CDG_PRV;
              Via.CDG_MNC = CDG_MNC;
              Via.darVia(Integer.parseInt(rSelect.getString("Via")),"");
              // Intoduim el posibles error en els errors d'aquest objecte.
              if (Via.sError.compareTo("") != 0)
              {
                 sError = sError + Via.sError + "<br />"; 
              }
          }
          else
          {
            Via.reiniciar();
          }
          
          // Carguem les dades del Tram.
          if (Integer.parseInt(rSelect.getString("Tram")) != -1)
          {
              Tram.CDG_PRV = CDG_PRV;
              Tram.CDG_MNC = CDG_MNC;
              Tram.darTram(Integer.parseInt(rSelect.getString("Tram")),"");
              // Intoduim el posibles error en els errors d'aquest objecte.
              if (Tram.sError.compareTo("") != 0)
              {
                 sError = sError + Tram.sError + "<br />"; 
              }
          }
          else
          {
            Tram.reiniciar();
          }
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Ens dona el Html per poder mostrar l'historial del Municipi per una web.
     public String MostrarhistorialMunicipi()
    {
     PDREntColectiva EntColectivaAux;  
     PDREntSingular  EntSingularAux; 
     
     StringBuffer    sResultat;
     ResultSet       rSelectPrincipal;
     ResultSet       rSelectSecundari;
     ResultSet       rSelectTerciari;
     
    
     boolean bVia;          
     boolean bPseudoVia;
     boolean bEntCol;
     boolean bNucli;      
     
     sResultat         = new StringBuffer("");
     EntColectivaAux   = new PDREntColectiva(con, CDG_USR);  
     EntSingularAux    = new PDREntSingular (con, CDG_USR);     
     rSelectPrincipal  = null;
     rSelectSecundari  = null;
     rSelectTerciari   = null; 
     
     bVia       = false;
     bPseudoVia = false;
     bEntCol    = false;
     bNucli     = false;
     
     // Si no hi ha ni nom de Ent. Colectiva, ni singular, ni nucli bNucli es true.
     bNucli = (!Nucli.NNUCLE.equals("")) || (!EntColectiva.NENTCO.equals("")) || (!EntSingular.NENTSI.equals(""));
     
     // Ens diu si tenim que mostrar els habitats referents a la via.
     bVia =  !(Via.CDG_VIA == -1);
     // Ens diu si tenim que mostrar els habitats referents a la pseudovia.
     bPseudoVia = !(Pseudovia.DPSVIA.equals(""));
     // Ens diu si tenim que mostrar els habitats referents al nucli (entitats).
     bEntCol = bNucli;
     
     
     
     // Si los tres estan a false (no han especificado nada), mostramos todos.
     if (! bVia && ! bPseudoVia && ! bEntCol)
     {
        bVia       = true;
        bPseudoVia = true;
        bEntCol    = true;
     }
     
     try{
         
         
          sResultat.append("<TABLE  ALIGN=center cellspacing='0' cellpadding='0' border='0' width='1110px'>");  
         
          if (bVia) 
          { 
            // Obtenim les Vies a Mostrar
            rSelectPrincipal = Via.DarVias(FFIN);
             sResultat.append( this.mostraHTML(rSelectPrincipal, true, false, false));
          }
          
          if (bPseudoVia)
          {
            // Obtenim les Pseudovies a Mostrar
            rSelectPrincipal = Pseudovia.DarPseudovias(FFIN);
            sResultat.append(this.mostraHTML(rSelectPrincipal, false, true, false));
          }
          
          if (bEntCol)
          {
            // Obtenim les Pseudovies a Mostrar
            rSelectPrincipal = EntColectiva.DarEntColectives(FFIN);
            
            while (rSelectPrincipal.next())
            {
            
              // Omplim la Entitat Colectiva auxiliar amb les dades que hem trobat. 
               EntColectivaAux.rellenar(rSelectPrincipal);
             
               // Mostrem la Entidad Colectiva
               sResultat.append("<TR>");
                 sResultat.append("<TD class='form1'> ");
                     sResultat.append("Nom de la Entitat Colectiva:");
                 sResultat.append(" </TD>");
                 sResultat.append("<TD class='form3'> ");
                     sResultat.append(EntColectivaAux.NENTCO);
                 sResultat.append(" </TD>");
               sResultat.append(" </TR>");
               
               // Obtenim les Entitats Singulars a Mostrar d'aquesta Entitat Colectiva.
               rSelectSecundari = EntSingular.DarEntSingulars(EntColectivaAux, FFIN);
              
               while (rSelectSecundari.next())
               {
                   
                 // Omplim la Entitat Singular auxiliar amb les dades que hem trobat. 
                 EntSingularAux.rellenar(rSelectSecundari);
             
                 // Mostrem la Entidad Singular
                 sResultat.append("<TR>");
                   sResultat.append("<TD class='form1'> ");
                       sResultat.append("Nom de la Entitat Singular:");
                   sResultat.append(" </TD>");
                   sResultat.append("<TD class='form3'> ");
                       sResultat.append(EntSingularAux.NENTSI);
                   sResultat.append(" </TD>");
                 sResultat.append(" </TR>");

                 // Obtenim els Nuclis a Mostrar d'aquesta Entitat Singular.
                 rSelectTerciari = Nucli.DarNuclis(EntSingularAux, FFIN);
                
                 sResultat.append(this.mostraHTML(rSelectTerciari, false, false, true));
              }
            }
          }
          
          
          sResultat.append("</TABLE>"); 
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
      return (sResultat.toString());
     }
    
    // Comprova que el historial es pugui du a terma.
    public void comprobacionHistorial()
    {
      String sResultado;
      sResultado = "";
      
      /*if (! existeHabitant() )// Problema 111
      {
        sResultado = sResultado + "e111: El Habitant no existeix. <br /> " ;
      }*/
      if (FFIN.compareTo("") == 0)// Problema 128
      {
          sResultado = sResultado + "e154: Falta posar la Data de finalitzaci. <br /> " ;
      } 
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Donan un  resulset amb dades de tram,
    // Returnem un String amb un codi HTML per ensea Els habitatges i habitants de tots els trams 
    // donats en arbre.
    // Lanza excepcion de SQL.
    private String mostraTramHTML (ResultSet rSelectSecundari)  throws SQLException 
    {
      StringBuffer    sResultat;    
      ResultSet       rSelectTerciari;
      PDRTram         TramAux; 
      PDRHabitatge    HabitatgeAux;
     
      sResultat         = new StringBuffer("");
      rSelectTerciari   = null; 
      TramAux           = new PDRTram(con, CDG_USR); 
      HabitatgeAux      = new PDRHabitatge(con, CDG_USR); 
      
      // Posem al Habitatge i al Habitant Auxiliars la provincia y municipis adecuats.
      HabitatgeAux.CDG_PRV = CDG_PRV;
      HabitatgeAux.CDG_MNC = CDG_MNC;
      
      while(rSelectSecundari.next())
      {
       // Omplim el Tram auxiliar amb les dades que hem trobat. 
       TramAux.rellenar(rSelectSecundari);

       // Mostrem el Tram
       sResultat.append("<TR>");
     sResultat.append("<TD class='form1'> ");
         sResultat.append("Tram:");
     sResultat.append(" </TD>");
         sResultat.append("<TD class='form3'> ");
             sResultat.append(TramAux.DIST);
           sResultat.append(" </TD>");
         sResultat.append("<TD class='form3'> ");
             sResultat.append(TramAux.SECC+"-"+TramAux.LSECC);
           sResultat.append(" </TD>");
         sResultat.append("<TD class='form3'> ");
             sResultat.append(TramAux.SUBSC);
           sResultat.append(" </TD>");
         sResultat.append("<TD class='form3'> ");
             sResultat.append(TramAux.CUN);
           sResultat.append(" </TD>");
         sResultat.append("<TD class='form3'> ");
             sResultat.append(TramAux.MANZ);
           sResultat.append(" </TD>");
         sResultat.append("<TD class='form3'> ");
             sResultat.append(TramAux.TINUM);
           sResultat.append(" </TD>");
         sResultat.append("<TD class='form3'> ");
             sResultat.append(TramAux.EIN +"-"+ TramAux.CEIN);
           sResultat.append(" </TD>");
         sResultat.append("<TD class='form3'> ");
             sResultat.append(TramAux.ESN +"-"+ TramAux.CESN);
           sResultat.append(" </TD>");
         sResultat.append("<TD class='form3'> ");
             sResultat.append(TramAux.CPOS);
           sResultat.append(" </TD>");
       sResultat.append(" </TR>");

       // Obtenim els Habitatges a Mostrar d'aquests Tram.
       rSelectTerciari = HabitatgeAux.DarHabitatgeDeTram(TramAux.CDG_CTRM, FFIN);

       sResultat.append(mostraHabitatgeHTML (rSelectTerciari));
       
      }

      return (sResultat.toString());
    }
    
    // Donan un  resulset amb dades de Habitatge,
    // Returnem un String amb un codi HTML per ensea els habitants de tots els Habitatges 
    // donats en arbre.
    // Lanza excepcion de SQL.
    private String mostraHabitatgeHTML (ResultSet rSelectTerciari)  throws SQLException 
    {
      StringBuffer    sResultat;    
      PDRHabitatge    HabitatgeAux;
      PDRHabitant     HabitantAux;
      ResultSet       rSelectQuaternari; 
    
      sResultat         = new StringBuffer("");
      rSelectQuaternari = null; 
      HabitatgeAux      = new PDRHabitatge(con, CDG_USR); 
      HabitantAux       = new PDRHabitant(con, CDG_USR); 
      
      // Posem al Habitatge i al Habitant Auxiliars la provincia y municipis adecuats.
      HabitatgeAux.CDG_PRV = CDG_PRV;
      HabitatgeAux.CDG_MNC = CDG_MNC;
      HabitantAux.CDG_PRV  = CDG_PRV;
      HabitantAux.CDG_MNC  = CDG_MNC;
      
      while (rSelectTerciari.next())
      {
          // Omplim el Habitatge auxiliar amb les dades que hem trobat. 
          HabitatgeAux.rellenar(rSelectTerciari);

          // Mostrem el Habitatge
           sResultat.append("<TR>");
             sResultat.append("<TD class='form1'> ");
                 sResultat.append("Habitatge:");
             sResultat.append(" </TD>");
             sResultat.append("<TD class='form3'> ");
                 sResultat.append(HabitatgeAux.NHOP);
               sResultat.append(" </TD>");
             sResultat.append("<TD class='form3'> ");
                 sResultat.append(HabitatgeAux.NUMER +""+ HabitatgeAux.CNUMER +""+ HabitatgeAux.NUMERS +""+ HabitatgeAux.CNUMERS);
               sResultat.append(" </TD>");
             sResultat.append("<TD class='form3'> ");
                 sResultat.append(HabitatgeAux.KMT+","+HabitatgeAux.HMT);
               sResultat.append(" </TD>");
             sResultat.append("<TD class='form3'> ");
                 sResultat.append(HabitatgeAux.BLOQ);
               sResultat.append(" </TD>");
             sResultat.append("<TD class='form3'> ");
                 sResultat.append(HabitatgeAux.PORT);
               sResultat.append(" </TD>");
             sResultat.append("<TD class='form3'> ");
                 sResultat.append(HabitatgeAux.ESCA);
               sResultat.append(" </TD>");
             sResultat.append("<TD class='form3'> ");
                 sResultat.append(HabitatgeAux.PLAN);
               sResultat.append(" </TD>");
             sResultat.append("<TD class='form3'> ");
                 sResultat.append(HabitatgeAux.PUER);
               sResultat.append(" </TD>");
             sResultat.append("<TD class='form3'> ");
                 sResultat.append(HabitatgeAux.TLOC);
               sResultat.append(" </TD>");
           sResultat.append(" </TR>");

         // Obtenim els Habitants a Mostrar d'aquest Habitatge.
         rSelectQuaternari = HabitantAux.DarHabitants(HabitatgeAux.CDG_CHBTG, FFIN);

         while(rSelectQuaternari.next())
         {
            // Omplim el Habitant auxiliar amb les dades que hem trobat. 
            HabitantAux.rellenar(rSelectQuaternari);

           sResultat.append("<TR>");
            sResultat.append("<TD class='form1'> ");
             sResultat.append("Habitant:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.NIA.compareTo("") != 0) {sResultat.append(HabitantAux.NIA);}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.NIE != -1) {sResultat.append(HabitantAux.NIE);}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.NOMB.compareTo("") != 0) {sResultat.append(HabitantAux.NOMB);}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.APE1.compareTo("") != 0) {sResultat.append(HabitantAux.PART1 +" "+ HabitantAux.APE1 );}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.APE2.compareTo("") != 0) {sResultat.append( HabitantAux.PART2 +" "+ HabitantAux.APE2);}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.TIPIDEN.NMB_TIDEN.compareTo("") != 0) {sResultat.append(HabitantAux.TIPIDEN.NMB_TIDEN);}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             sResultat.append(HabitantAux.IDEN +"-"+ HabitantAux.LIDEN);
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             sResultat.append(HabitantAux.NDOCU +"-"+ HabitantAux.LEXTR);
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if  (HabitantAux.SEXO == 1){sResultat.append("Home");}
             else {sResultat.append("Dona");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             sResultat.append(HabitantAux.FNAC);
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.ESTUDIOS.NMB_CNES.compareTo("") != 0) {sResultat.append(HabitantAux.ESTUDIOS.NMB_CNES);}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.NACIONALIDAD.NMB_NACI.compareTo("") != 0) {sResultat.append(HabitantAux.NACIONALIDAD.NMB_NACI);}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.PROVNACIMIENTO.NMB_PROV.compareTo("") != 0) {sResultat.append(HabitantAux.PROVNACIMIENTO.NMB_PROV);}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.MUNNACIMIENTO.NMB_MUNC.compareTo("") != 0) {sResultat.append(HabitantAux.MUNNACIMIENTO.NMB_MUNC);}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.PROVPROCEDENCIA.NMB_PROV.compareTo("") != 0) {sResultat.append(HabitantAux.PROVPROCEDENCIA.NMB_PROV);}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.MUNPROCEDENCIA.NMB_MUNC.compareTo("") != 0) {sResultat.append(HabitantAux.MUNPROCEDENCIA.NMB_MUNC);}
             else {sResultat.append("...");}
             sResultat.append(" </TD>");
            sResultat.append("<TD class='form3'> ");
             if (HabitantAux.CONSULADO.NMB_CODP.compareTo("") != 0) {sResultat.append(HabitantAux.CONSULADO.NMB_CODP);}
             else {sResultat.append("...");}
          sResultat.append(" </TR>");

         }

      }
    return (sResultat.toString());
   }
   
     private String mostraHTML (ResultSet rSelectPrincipal, boolean bVia, boolean bPseudoVia, boolean bColEnt)  throws SQLException 
    {
     StringBuffer    sResultat;    
     PDRPseudovia    PseudoviaAux;  
     PDRVia          ViaAux;  
     PDRHabitatge    HabitatgeAux;
     PDRNucli        NucliAux;  
     ResultSet       rSelectSecundari;
     ResultSet       rSelectSecundariosegundo;
     
     sResultat         = new StringBuffer("");
     PseudoviaAux      = new PDRPseudovia(con, CDG_USR);  
     ViaAux            = new PDRVia(con, CDG_USR);  
     HabitatgeAux      = new PDRHabitatge(con, CDG_USR);
     NucliAux          = new PDRNucli(con, CDG_USR);  
     rSelectSecundari  = null;
     rSelectSecundariosegundo = null;
     
     while (rSelectPrincipal.next())
          {
              if (bVia) 
             { 
               // Omplim la via auxiliar amb les dades que hem trobat. 
               ViaAux.rellenar(rSelectPrincipal);
             
               // Mostrem la Via
               sResultat.append("<TR>");
                 sResultat.append("<TD class='form1'> ");
                     sResultat.append("Nom de la Via:");
                 sResultat.append(" </TD>");
                 sResultat.append("<TD class='form3'> ");
                     sResultat.append(ViaAux.TPSVIA.TVIA +" "+ ViaAux.NVIA);
                 sResultat.append(" </TD>");
               sResultat.append(" </TR>");
               
               // Obtenim el Tram a Mostrar d'aquesta Via.
               rSelectSecundari = Tram.DarTramsDeVia(ViaAux.CDG_VIA ,FFIN);
              }
              
              if (bPseudoVia)
              {
                 // Omplim la Pseudovia auxiliar amb les dades que hem trobat. 
               PseudoviaAux.rellenar(rSelectPrincipal);
             
               // Mostrem la PseudoVia
               sResultat.append("<TR>");
                 sResultat.append("<TD class='form1'> ");
                     sResultat.append("Nom de la Pseudovia:");
                 sResultat.append(" </TD>");
                 sResultat.append("<TD class='form3'> ");
                     sResultat.append(PseudoviaAux.DPSVIA);
                 sResultat.append(" </TD>");
               sResultat.append(" </TR>");
               
               // Obtenim el Tram a Mostrar d'aquesta PseudoVia.
               rSelectSecundari = Tram.DarTramsDePseudovia(PseudoviaAux.CDG_CPSVIA ,FFIN);
               
               // Obtenim els habitatges a Mostrar d'aquesta Pseudovia que no estan lligats per tram sino directament.
               
               // Posem la Provincia i el municipis corresponents.
               HabitatgeAux.CDG_PRV = PseudoviaAux.CDG_PRV;
               HabitatgeAux.CDG_MNC = PseudoviaAux.CDG_MNC;
               
               rSelectSecundariosegundo = HabitatgeAux.DarHabitatgeDePseudovia(PseudoviaAux.CDG_CPSVIA, FFIN);
              }
              
               if (bColEnt)
              {
                // Omplim el Nucli auxiliar amb les dades que hem trobat. 
                NucliAux.rellenar(rSelectPrincipal);
             
                // Mostrem la Via
                sResultat.append("<TR>");
                  sResultat.append("<TD class='form1'> ");
                      sResultat.append("Nom del Nucli:");
                  sResultat.append(" </TD>");
                  sResultat.append("<TD class='form3'> ");
                      sResultat.append(NucliAux.NNUCLE);
                  sResultat.append(" </TD>");
                sResultat.append(" </TR>");
               
                // Obtenim el Tram a Mostrar d'aquest Nucli.
                rSelectSecundari = Tram.DarTramsDeNucli(NucliAux.CDG_CNCL ,FFIN);
              }
               
              
             sResultat.append(mostraTramHTML (rSelectSecundari));
             
             if (rSelectSecundariosegundo != null)
             {
               sResultat.append("<TR>");
                  sResultat.append("<TD class='form1'> ");
                      sResultat.append("No lligades a Tram:");
                  sResultat.append(" </TD>");
                  sResultat.append("<TD class='form3'> ");
                      sResultat.append(" ");
                  sResultat.append(" </TD>");
                sResultat.append(" </TR>");
               sResultat.append(mostraHabitatgeHTML(rSelectSecundariosegundo));
             }
             
          }
     return (sResultat.toString());
     }
}
