

package PDR;

import java.io.*;
import java.net.*;
import java.sql.*;
import java.util.GregorianCalendar;

/**
 *
 * @author Miguel Panadero
 */
public class Data
{
      
    // Variables
    private  BDConnexio con; 
    private  String dia;
    private  String mes;
    private  String anyo;
    private  String hora;
    private  String min;
    private  String seg;
    public   String sError;
    
    /** Creates a new instance of Data */
    public Data(BDConnexio conexion) 
    {
        // Conexio
        con  = conexion;
        
        // Inicializacion
        dia    = "1";
        mes    = "1";
        anyo   = "0";
        hora   = "0";
        min    = "0";
        seg    = "0";
        sError = "";
    }
    
    // Da la fecha y la hora de la base de datos.
    public String darFecha() throws Exception
    {
      String dResultado;
      
      // Variables para la Conexio
      Statement stmt; 
      ResultSet  rs;
      StringBuffer sbSql;
      
      sbSql = null;
        stmt = con.cnPrincipal.createStatement();
       
        // Preparem la sentncia SQL per inseri en PDR_DDSVIA
        sbSql = new StringBuffer("");
        sbSql.append(" select to_char(now(),   'DD') as dia, ");
        sbSql.append("        to_char(now(),   'MM') as mes, ");
        sbSql.append("        to_char(now(), 'YYYY') as anyo,");
        sbSql.append("        to_char(now(), 'HH24') as hora,");
        sbSql.append("        to_char(now(),   'MI') as min, ");
        sbSql.append("        to_char(now(),   'SS') as seg  ");
       
        rs = stmt.executeQuery(sbSql.toString());
        
        if (rs.next())
        {
          dia  = rs.getString("dia"); 
          mes  = rs.getString("mes"); 
          anyo = rs.getString("anyo"); 
          hora = rs.getString("hora");
          min  = rs.getString("min");
          seg  = rs.getString("seg");
        }
        stmt.close();
        
     
      dResultado = dia +"/"+ mes +"/"+ anyo +":"+ hora +":"+ min +":"+ seg;
      return(dResultado);
    }
    
    // Da la fecha de la base de datos.
    public String darFechaReducida() throws Exception
    {
      String dResultado;
      
      // Variables para la Conexio
      Statement stmt; 
      ResultSet  rs;
      StringBuffer sbSql;
      
      sbSql = null;
        stmt = con.cnPrincipal.createStatement();
       
        // Preparem la sentncia SQL per inseri en PDR_DDSVIA
        sbSql = new StringBuffer("");
        sbSql.append(" select to_char(now(),   'DD') as dia, ");
        sbSql.append("        to_char(now(),   'MM') as mes, ");
        sbSql.append("        to_char(now(), 'YYYY') as anyo,");
        sbSql.append("        to_char(now(), 'HH24') as hora,");
        sbSql.append("        to_char(now(),   'MI') as min, ");
        sbSql.append("        to_char(now(),   'SS') as seg  ");
       
        rs = stmt.executeQuery(sbSql.toString());
        
        if (rs.next())
        {
          dia  = rs.getString("dia"); 
          mes  = rs.getString("mes"); 
          anyo = rs.getString("anyo"); 
          hora = rs.getString("hora");
          min  = rs.getString("min");
          seg  = rs.getString("seg");
        }
        stmt.close();
        
     
      dResultado = dia +"/"+ mes +"/"+ anyo;
      return(dResultado);
    }
    
    // Ens dona una caixa amb la data de avui.
    // Si la data es null retorna el dia de avui.
    public String MostrarData (String sNom, String sData)
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        
        sResultat = new StringBuffer("");
        
        try
        {
            if (sData.compareTo("") == 0)
            {
               sData = darFechaReducida();
            }

            sResultat.append("<INPUT TYPE=TEXT NAME=\""+ sNom +"\" ");
            sResultat.append(" onblur=\"valFecha(this)\" MAXLENGTH=10 SIZE=20 ");
            sResultat.append(" VALUE=\""+sData+"\">");
        } catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
            {con.cnPrincipal.rollback();
            }catch (Exception e2)
            {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
           
        
       return(sResultat.toString());
    }
}
