/*
 * PDRConsulado.java
 *
 * Created on 2 de abril de 2006, 15:49
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Panadero
 */

public class PDRConsulado
{
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    // De la base de datos
    public  int          CODP;              // Nmero del Consulat.                        (Posat per l'usuari)
    public  String       NMB_CODP;          // Nom de la Consulat.                         (Posat per l'usuari)
    
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    
    // Creates a new instance of PDRConsulado 
    public PDRConsulado() 
    {
        con             = null;    
        // De la base de datos
        CODP     = -1;       
        NMB_CODP = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
    
    // Creates a new instance of PDRConsulado 
    public PDRConsulado(BDConnexio conexion) 
    {
        con             = conexion;   
        // De la base de datos
        CODP     = -1;       
        NMB_CODP = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
     
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion.
    public void reiniciar()
    {              
        // De la base de datos
        CODP     = -1;       
        NMB_CODP = "";       
             
        // Relacionada con Errores
        sError          = "";          
        
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {   
      try
      {
        // Dades de PDR_CNS
        CODP     = Integer.parseInt(rSelect.getString("CODP"));       
        NMB_CODP = rSelect.getString ("NMB_CODP");     
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Fa un select d'un CODPonalidad
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{ 
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_CNS CNS");
        sbSql.append(" where ");
        sbSql.append("  ( CNS.CODP ='"+ CODP +"' or ");
        sbSql.append(   "'"+CODP            +"'  = -1) and");
        sbSql.append("  ( CNS.NMB_CODP ='"+ NMB_CODP +"' or ");
        sbSql.append(   "'"+NMB_CODP           +"'  = '')   ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "84: No existeix Consulat amb aquestes caracterstiques." +"<br />";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Carrega el Consulat en el objecte que la cridat.
    public void darConsulat(int CODPaux, String NMB_CODPaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_CNS CNS");
        sbSql.append(" where ");
        sbSql.append("  CNS.CODP ='"+ CODPaux +"' or ");
        sbSql.append("  CNS.NMB_CODP ='"+ NMB_CODPaux +"' ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "85: El Consulat no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Comproba si el CODPonalidad existeix.
    public boolean existeConsulat()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
             // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_CNS CNS");
            sbSql.append(" where ");
            sbSql.append("  CNS.CODP ='"+ CODP +"' or ");
            sbSql.append("  CNS.NMB_CODP ='"+ NMB_CODP +"' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset tots els Consulats que no estiguin donats de baixa.
    public ResultSet TotsConsulat()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_CNS ");
        sbSql.append(" where ");
        sbSql.append(" CODP != -2");
        sbSql.append(" Order by ");
        sbSql.append(" NMB_CODP ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per Consulat.
    public String MostrarConsulat ()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRConsulado oCon;
        int          i;
        
        sResultat = new StringBuffer("");
        oCon      = new PDRConsulado(con);
        i = 0;
        
        try
        {            
            // obtenim els Tots els Consulats
            rSelect = oCon.TotsConsulat();
            
            sResultat.append("<SELECT NAME=\"CONSULADO\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oCon.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oCon.NMB_CODP +"\"");
                if (NMB_CODP.compareTo(oCon.NMB_CODP) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oCon.NMB_CODP+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
}
