/*
 * PDREntColectiva.java
 *
 * Created on 8 de marzo de 2006, 11:05
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;

import java.io.*;
import java.net.*;
import java.sql.*;
//import java.util.GregorianCalendar;

/**
 *
 * @author Miguel Angel Panadero
 */

public class PDREntColectiva {
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio con;                 // Nos permite conectarnos con la base de datos.
    public  ResultSet  rSelectPublic;       // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int        CDG_PRV;             // Nmero de identificacin de la provincia.                        (Posat per nosaltres)
    public  int        CDG_MNC;             // Nmero que identifica la provincia.                              (Posat per nosaltres)
    public  int        CDG_CCLC;            // Nmero que indentifica la Entitat Colectiva                      (Posat per nosaltres)
    public  int        DDSENTCLC_CCLC;      // Nmero de identificacin de las dades de la Entitat Colectiva.   (Posat per nosaltres)
    public  int        CUN;                 // Cdi Unitat Poblacional                                          (Posat per l'Ine) 
    public  String     NENTCO;              // Nom de la Entitat Colectiva.                                     (Posat per l'usuari)
    public  String     NENTCO50;            // Nom de la Entitat Colectiva de 50 caracters.                     (Posat per l'usuari)
    public  String     NENTCOC;             // Nom de la Entitat Colectiva corto.                               (Posat per l'usuari)
    private String     FVAR;                // Data del cambi.                                                  (Posat per nosaltres)
    public  String     CVAR;                // Codi de Variacio                                                 (Posat per nosaltres)
    private String     Envio;               // Ens indica si esta enviat al Ine.                                (Posat per nosaltres)
    // Relacionada con Errores
    public  String     sError;        // Guardamos todos los errores generados.
    // Dades del Usuari
    public  int        CDG_USR;       // Nmero que identifica al usuari que esta realitzan les accion (Posat per nosaltres)
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    // Constructor
    public PDREntColectiva(int USR) 
    {
        
        // Relacionada con la base de datos
        con                 = null;               
        rSelectPublic       = null;     
        // De la base de datos
        CDG_PRV             = -1;             
        CDG_MNC             = -1;             
        CDG_CCLC            = -1;          
        DDSENTCLC_CCLC      = -1;  
        CUN                 = -1;                  
        NENTCO              = "";         
        NENTCO50            = "";           
        NENTCOC             = "";     
        FVAR                = "";        
        CVAR                = "";          
        Envio               = "";      
        // Relacionada con Errores
        sError              = "";     
        // Dades del Usuari
        CDG_USR             = USR;      
        // Relacionadas con estado de los botones.
        sSiguiente          = "disabled";
        sAnterior           = "disabled";
        
    }
    
    // Constructor con conexion
    public PDREntColectiva(BDConnexio conexion, int USR) 
    {
        // Relacionada con la base de datos
        con                 = conexion;               
        rSelectPublic       = null;     
        // De la base de datos
        CDG_PRV             = -1;             
        CDG_MNC             = -1;             
        CDG_CCLC            = -1;          
        DDSENTCLC_CCLC      = -1;  
        CUN                 = -1;                  
        NENTCO              = "";         
        NENTCO50            = "";           
        NENTCOC             = "";     
        FVAR                = "";        
        CVAR                = "";          
        Envio               = "";      
        // Relacionada con Errores
        sError              = "";     
        // Dades del Usuari
        CDG_USR             = USR;      
        // Relacionadas con estado de los botones.
        sSiguiente          = "disabled";
        sAnterior           = "disabled";
    }
    
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    public void reiniciar()
    {       
        // Relacionada con la base de datos              
        rSelectPublic       = null;     
        // De la base de datos            
        CDG_CCLC            = -1;          
        DDSENTCLC_CCLC      = -1;  
        CUN                 = -1;                  
        NENTCO              = "";         
        NENTCO50            = "";           
        NENTCOC             = "";     
        FVAR                = "";        
        CVAR                = "";          
        Envio               = "";      
        // Relacionada con Errores
        sError              = "";       
        // Relacionadas con estado de los botones.
        sSiguiente          = "disabled";
        sAnterior           = "disabled";  
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {
        try
        {
            // Dades de PDR_DDSENTCLC
            CDG_PRV             = Integer.parseInt(rSelect.getString("CDG_PRV"));     
            CDG_MNC             = Integer.parseInt(rSelect.getString("CDG_MNC"));       
            DDSENTCLC_CCLC      = Integer.parseInt(rSelect.getString("DDSENTCLC_CCLC")); 
            CUN                 = Integer.parseInt(rSelect.getString("CUN"));       
            NENTCO              = rSelect.getString ("NENTCO");        
            NENTCO50            = rSelect.getString ("NENTCO50");      
            NENTCOC             = rSelect.getString ("NENTCOC");      
               
            // Dades de PDR_PSD_has_DDSPSD que no estan en l'altre.
            CDG_CCLC            = Integer.parseInt(rSelect.getString("CDG_CCLC")); 
            FVAR                = rSelect.getString ("FVAR");        
            CVAR                = rSelect.getString ("CVAR");      
            Envio               = rSelect.getString ("Envio");
        }   catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
            {con.cnPrincipal.rollback();
            }catch (Exception e2)
            {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Inserta los datos de la Entitat Colectiva en la taula de PDR_DDSENTCLC.
    // Inserta la Entitat Colectiva en la taula de PDR_ENTCLC.
    // Inserta la relaci Entitat Colectiva-dades en la taula de PDR_ENTCLC_has_DDSENTCLC.
    public void insert()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador EntClcNum;
      
      //Date
      Data dFecha;
      
      EntClcNum = new PDRNumerador(con); 
      try
      {
          // Possem un numero a les dades de la Entitat Colectiva.
          EntClcNum.NMR_NOM = "NMR_DDSENTCLC";
          EntClcNum.select();
          DDSENTCLC_CCLC = EntClcNum.NMR_VLR;
      
          sbSql = null;
      
          stmt = con.cnPrincipal.createStatement();
          // Preparem la sentncia SQL per inseri en PDR_DDSENTCLC
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_DDSENTCLC ");
          sbSql.append(" (CDG_PRV, CDG_MNC, DDSENTCLC_CCLC, CUN, NENTCO, NENTCO50, NENTCOC) ");
          sbSql.append(" values ");
          sbSql.append("('"+  CDG_PRV +"', '"+ CDG_MNC  +"', '"+ DDSENTCLC_CCLC+"', -1, '");
          sbSql.append(       NENTCO  +"', '"+ NENTCO50 +"', '"+ NENTCOC       +"')");
          
          stmt.executeUpdate(sbSql.toString());
          
          // Posem un numero intern a la Entitta Colectiva
          EntClcNum.NMR_NOM = "NMR_ENTCLC";
          EntClcNum.select();
          CDG_CCLC = EntClcNum.NMR_VLR;
          
          // Preparem la sentncia SQL per inseri en PDR_ENTCLC
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_ENTCLC ");
          sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CCLC) ");
          sbSql.append(" values ");
          sbSql.append("('"+ CDG_PRV +"', '"+ CDG_MNC +"', '"+ CDG_CCLC+"')");
          
          stmt.executeUpdate(sbSql.toString());
          
          // obtenim el dia al que estem.
          dFecha = new Data (con);
          
          FVAR = dFecha.darFecha();
          
          // Preparem la sentncia SQL per inseri en PDR_ENTCLCL_has_DDSENTCCLC
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_ENTCLC_has_DDSENTCLC ");
          sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CCLC, DDSENTCLC_CCLC, CDG_USR, FVAR, CVAR, Envio) ");
          sbSql.append(" values ");
          sbSql.append("('"+ CDG_PRV        +"', '"+ CDG_MNC +"', '"+ CDG_CCLC+"', '");
          sbSql.append(      DDSENTCLC_CCLC +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'A', 'N')");
          
          
        stmt.executeUpdate(sbSql.toString());
        
        stmt.close();
        con.cnPrincipal.commit();
      } catch (Exception e)
      {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
      
    }
    
    // Fa un insert de les dades d'una Entitat Colectiva en la taula PDR_DDSENTCLC
    // Fa un insert en la taulta PDR_ENTCLC_has_DDSENTCLC enllaant Entitat Colectiva-dades.
    // Es pot updateixa en nom, el nom de 50 carters i el nom curt de la Entitat Colectiva.
    public void update()
    {
        // Conexio
        Statement stmt;
        StringBuffer sbSql;
        PDRNumerador EntClcNum;
        
        //Date
        Data dFecha;
        
        EntClcNum = new PDRNumerador(con);
        
        try
        {
            
            // Possem un numero a les dades de la Entitat Colectiva.
            EntClcNum.NMR_NOM = "NMR_DDSENTCLC";
            EntClcNum.select();
            DDSENTCLC_CCLC = EntClcNum.NMR_VLR;
        
            sbSql = null;
        
            stmt = con.cnPrincipal.createStatement();
            
            // Preparem la sentncia SQL per inseri en PDR_DDSENTCLC
            sbSql = new StringBuffer("");
            sbSql.append("Insert into  ");
            sbSql.append( " PDR_DDSENTCLC ");
            sbSql.append(" (CDG_PRV, CDG_MNC, DDSENTCLC_CCLC, CUN, NENTCO, NENTCO50, NENTCOC) ");
            sbSql.append(" values ");
            sbSql.append("('"+  CDG_PRV +"', '"+ CDG_MNC  +"', '"+ DDSENTCLC_CCLC+"', '"+ CUN + "','");
            sbSql.append(       NENTCO  +"', '"+ NENTCO50 +"', '"+ NENTCOC       +"')");
        
            stmt.executeUpdate(sbSql.toString());
        
            // obtenim el dia al que estem.
            dFecha = new Data (con);
          
            FVAR = dFecha.darFecha(); 
            
            // Preparem la sentncia SQL per inseri en PDR_ENTCLCL_has_DDSENTCCLC
            sbSql = new StringBuffer("");
            sbSql.append("Insert into  ");
            sbSql.append( " PDR_ENTCLC_has_DDSENTCLC ");
            sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CCLC, DDSENTCLC_CCLC, CDG_USR, FVAR, CVAR, Envio) ");
            sbSql.append(" values ");
            sbSql.append("('"+ CDG_PRV        +"', '"+ CDG_MNC +"', '"+ CDG_CCLC+"', '");
            sbSql.append(      DDSENTCLC_CCLC +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'M', 'N')");
            
            stmt.executeUpdate(sbSql.toString());
            stmt.close();
            con.cnPrincipal.commit();

        }catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
            {con.cnPrincipal.rollback();
            }catch (Exception e2)
            {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
     
    // Fa un Insert a la taula PDR_ENTCLC_has_DDSENTCLC enllaant Entitat Colectiva-dades, inserim en motiu envia a Ine Baixa
    public void delete()
    {
        // Conexio 
        Statement stmt; 
        StringBuffer sbSql;
        sbSql = null;
        
        //Date
        Data dFecha;
          
        try{
            stmt = con.cnPrincipal.createStatement();
        
            // obtenim el dia al que estem.
            dFecha = new Data (con);
          
            FVAR = dFecha.darFecha();
        
             // Preparem la sentncia SQL per inseri en PDR_ENTCLCL_has_DDSENTCCLC
            sbSql = new StringBuffer("");
            sbSql.append("Insert into  ");
            sbSql.append( " PDR_ENTCLC_has_DDSENTCLC ");
            sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CCLC, DDSENTCLC_CCLC, CDG_USR, FVAR, CVAR, Envio) ");
            sbSql.append(" values ");
            sbSql.append("('"+ CDG_PRV        +"', '"+ CDG_MNC +"', '"+ CDG_CCLC+"', ");
            sbSql.append(      "'-1', '" + CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'B', 'N')");
            
            stmt.executeUpdate(sbSql.toString());
            stmt.close();
            con.cnPrincipal.commit();
        
    }   catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'una o un grup de Entitats Colectives
    public void select()
    {
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        ResultSet rSelect;
      
        sbSql = null;
        try
        {
            // Cerramos el select anterior
            if (rSelectPublic != null){rSelectPublic.close();} 
            
            stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );
            
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_ENTCLC_has_DDSENTCLC EHD,PDR_DDSENTCLC DEC1");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DEC1.CDG_PRV        = EHD.CDG_PRV     and ");
            sbSql.append("   DEC1.CDG_MNC        = EHD.CDG_MNC     and ");
            sbSql.append("   DEC1.DDSENTCLC_CCLC = EHD.DDSENTCLC_CCLC  ");
            sbSql.append("  ) and ");
            sbSql.append("  DEC1.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DEC1.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  ( DEC1.CUN  ='"+ CUN    +"' or ");
            sbSql.append(   "'"+CUN +"'  = -1) and");
            sbSql.append("  ( DEC1.NENTCO   LIKE'%"+ NENTCO +"%' or ");
            sbSql.append(   "'"+NENTCO           +"'    = '') and");
            sbSql.append("  ( DEC1.NENTCO50 LIKE'%"+ NENTCO50 +"%' or ");
            sbSql.append(   "'"+NENTCO50           +"'  = '') and");
            sbSql.append("  ( DEC1.NENTCOC  LIKE'%"+ NENTCOC +"%' or ");
            sbSql.append(   "'"+NENTCOC           +"'   = '') and");
            sbSql.append("  EHD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_ENTCLC_has_DDSENTCLC EHD2,PDR_DDSENTCLC DEC2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DEC2.CDG_PRV        = EHD2.CDG_PRV     and ");
            sbSql.append("      DEC2.CDG_MNC        = EHD2.CDG_MNC     and ");
            sbSql.append("      DEC2.DDSENTCLC_CCLC = EHD2.DDSENTCLC_CCLC  ");
            sbSql.append("    ) and "); 
            sbSql.append("    EHD.CDG_CCLC = EHD2.CDG_CCLC ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DEC1.DDSENTCLC_CCLC < DEC2.DDSENTCLC_CCLC  or ");
            sbSql.append("    DEC2.DDSENTCLC_CCLC = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            sbSql.append("  order by DEC1.NENTCO ");
        
            rSelect = stmt.executeQuery(sbSql.toString());
        
            if (rSelect.next())
            {
                rellenar(rSelect);
                rSelectPublic = rSelect;
           
                // Desbloqueamos o bloqueamos los botones que haga falta.
                if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
                if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
            }
            else
            {
               sError = sError + "e52: No existeixen Entitats Colectives amb aquestes caracterstiques." +"<br />";
               rSelectPublic = null;
               // Desactivamos los botones de siguiente y anteriror.
               sSiguiente    = "disabled";
               sAnterior     = "disabled";
            }

        } catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
            {con.cnPrincipal.rollback();
            }catch (Exception e2)
            {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }

    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }

    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }

    // Carrega la Entitat Colectiva en el objecte que la cridat.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public void darEntColectiva(int CDG_CCLCaux, String NENTCOaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_ENTCLC_has_DDSENTCLC EHD,PDR_DDSENTCLC DEC1");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DEC1.CDG_PRV        = EHD.CDG_PRV     and ");
        sbSql.append("   DEC1.CDG_MNC        = EHD.CDG_MNC     and ");
        sbSql.append("   DEC1.DDSENTCLC_CCLC = EHD.DDSENTCLC_CCLC  ");
        sbSql.append("  ) and ");
        sbSql.append("  DEC1.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DEC1.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( EHD.CDG_CCLC  ='"+ CDG_CCLCaux    +"' or ");
        sbSql.append(   "'"+CDG_CCLCaux +"'  = -1) and");
        sbSql.append("  ( DEC1.NENTCO ='"+ NENTCOaux +"' or ");
        sbSql.append(   "'"+NENTCOaux           +"'    = '') and");
        sbSql.append("  EHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_ENTCLC_has_DDSENTCLC EHD2,PDR_DDSENTCLC DEC2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DEC2.CDG_PRV        = EHD2.CDG_PRV     and ");
        sbSql.append("      DEC2.CDG_MNC        = EHD2.CDG_MNC     and ");
        sbSql.append("      DEC2.DDSENTCLC_CCLC = EHD2.DDSENTCLC_CCLC  ");
        sbSql.append("    ) and "); 
        sbSql.append("    EHD.CDG_CCLC = EHD2.CDG_CCLC ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DEC1.DDSENTCLC_CCLC < DEC2.DDSENTCLC_CCLC  or ");
        sbSql.append("    DEC2.DDSENTCLC_CCLC = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e32: La Pseudovia no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
           try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Carrega la Entitat Colectiva en el objecte que la cridat, te encompte la data que li passem.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public void darEntColectiva(int CDG_CCLCaux, String NENTCOaux, String Data)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_ENTCLC_has_DDSENTCLC EHD,PDR_DDSENTCLC DEC1");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DEC1.CDG_PRV        = EHD.CDG_PRV     and ");
        sbSql.append("   DEC1.CDG_MNC        = EHD.CDG_MNC     and ");
        sbSql.append("   DEC1.DDSENTCLC_CCLC = EHD.DDSENTCLC_CCLC  ");
        sbSql.append("  ) and ");
        sbSql.append("  DEC1.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DEC1.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( EHD.CDG_CCLC  ='"+ CDG_CCLCaux    +"' or ");
        sbSql.append(   "'"+CDG_CCLCaux +"'  = -1) and");
        sbSql.append("  ( DEC1.NENTCO ='"+ NENTCOaux +"' or ");
        sbSql.append(   "'"+NENTCOaux           +"'    = '') and");
        sbSql.append("  EHD.CVAR <> 'B' and ");
        sbSql.append("  EHD.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_ENTCLC_has_DDSENTCLC EHD2,PDR_DDSENTCLC DEC2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DEC2.CDG_PRV        = EHD2.CDG_PRV     and ");
        sbSql.append("      DEC2.CDG_MNC        = EHD2.CDG_MNC     and ");
        sbSql.append("      DEC2.DDSENTCLC_CCLC = EHD2.DDSENTCLC_CCLC  ");
        sbSql.append("    ) and "); 
        sbSql.append("    EHD.CDG_CCLC = EHD2.CDG_CCLC and");
        sbSql.append("    EHD2.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and  ");
        sbSql.append("    (");
        sbSql.append("    DEC1.DDSENTCLC_CCLC < DEC2.DDSENTCLC_CCLC  or ");
        sbSql.append("    DEC2.DDSENTCLC_CCLC = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e32: La Pseudovia no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
           try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Recopera la Entitat Colectiva que ens han marcat a una data o ens retorna totes les d'una data si no ens han marcat cap.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarEntColectives (String sData)
    {    
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_ENTCLC_has_DDSENTCLC EHD,PDR_DDSENTCLC DEC1");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DEC1.CDG_PRV        = EHD.CDG_PRV     and ");
        sbSql.append("   DEC1.CDG_MNC        = EHD.CDG_MNC     and ");
        sbSql.append("   DEC1.DDSENTCLC_CCLC = EHD.DDSENTCLC_CCLC  ");
        sbSql.append("  ) and ");
        sbSql.append("  DEC1.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DEC1.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( EHD.CDG_CCLC  ='"+ CDG_CCLC    +"' or ");
        sbSql.append(   "'"+CDG_CCLC +"'  = -1) and");
        sbSql.append("  ( DEC1.NENTCO ='"+ NENTCO +"' or ");
        sbSql.append(   "'"+NENTCO           +"'    = '') and");
        sbSql.append("  EHD.CVAR <> 'B' and ");
        sbSql.append("  EHD.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_ENTCLC_has_DDSENTCLC EHD2,PDR_DDSENTCLC DEC2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DEC2.CDG_PRV        = EHD2.CDG_PRV     and ");
        sbSql.append("      DEC2.CDG_MNC        = EHD2.CDG_MNC     and ");
        sbSql.append("      DEC2.DDSENTCLC_CCLC = EHD2.DDSENTCLC_CCLC  ");
        sbSql.append("    ) and "); 
        sbSql.append("    EHD.CDG_CCLC = EHD2.CDG_CCLC and");
        sbSql.append("    EHD2.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and  ");
        sbSql.append("    (");
        sbSql.append("    DEC1.DDSENTCLC_CCLC < DEC2.DDSENTCLC_CCLC  or ");
        sbSql.append("    DEC2.DDSENTCLC_CCLC = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Comprueba si la Entitat Colectiva existeix.
    public boolean existeEntColectiva()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_ENTCLC_has_DDSENTCLC EHD,PDR_DDSENTCLC DEC1");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DEC1.CDG_PRV        = EHD.CDG_PRV     and ");
            sbSql.append("   DEC1.CDG_MNC        = EHD.CDG_MNC     and ");
            sbSql.append("   DEC1.DDSENTCLC_CCLC = EHD.DDSENTCLC_CCLC  ");
            sbSql.append("  ) and ");
            sbSql.append("  DEC1.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DEC1.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  ( EHD.CDG_CCLC  ='"+ CDG_CCLC    +"' or ");
            sbSql.append(   "'"+CDG_CCLC +"'  = -1) and");
            sbSql.append("  ( DEC1.NENTCO ='"+ NENTCO +"' or ");
            sbSql.append(   "'"+NENTCO           +"'    = '') and");
            sbSql.append("  EHD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_ENTCLC_has_DDSENTCLC EHD2,PDR_DDSENTCLC DEC2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DEC2.CDG_PRV        = EHD2.CDG_PRV     and ");
            sbSql.append("      DEC2.CDG_MNC        = EHD2.CDG_MNC     and ");
            sbSql.append("      DEC2.DDSENTCLC_CCLC = EHD2.DDSENTCLC_CCLC  ");
            sbSql.append("    ) and "); 
            sbSql.append("    EHD.CDG_CCLC = EHD2.CDG_CCLC ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DEC1.DDSENTCLC_CCLC < DEC2.DDSENTCLC_CCLC  or ");
            sbSql.append("    DEC2.DDSENTCLC_CCLC = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }

    // Comprova si el cod existeix.
    public boolean existeCDGCCLC()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_ENTCLC_has_DDSENTCLC EHD,PDR_DDSENTCLC DEC1");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DEC1.CDG_PRV        = EHD.CDG_PRV     and ");
            sbSql.append("   DEC1.CDG_MNC        = EHD.CDG_MNC     and ");
            sbSql.append("   DEC1.DDSENTCLC_CCLC = EHD.DDSENTCLC_CCLC  ");
            sbSql.append("  ) and ");
            sbSql.append("  DEC1.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DEC1.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  EHD.CDG_CCLC  ='"+ CDG_CCLC    +"' and");
            sbSql.append("  EHD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_ENTCLC_has_DDSENTCLC EHD2,PDR_DDSENTCLC DEC2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DEC2.CDG_PRV        = EHD2.CDG_PRV     and ");
            sbSql.append("      DEC2.CDG_MNC        = EHD2.CDG_MNC     and ");
            sbSql.append("      DEC2.DDSENTCLC_CCLC = EHD2.DDSENTCLC_CCLC  ");
            sbSql.append("    ) and "); 
            sbSql.append("    EHD.CDG_CCLC = EHD2.CDG_CCLC ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DEC1.DDSENTCLC_CCLC < DEC2.DDSENTCLC_CCLC  or ");
            sbSql.append("    DEC2.DDSENTCLC_CCLC = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprova si el nom ya existeix.
    public boolean existeNENTCO()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_ENTCLC_has_DDSENTCLC EHD,PDR_DDSENTCLC DEC1");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DEC1.CDG_PRV        = EHD.CDG_PRV     and ");
            sbSql.append("   DEC1.CDG_MNC        = EHD.CDG_MNC     and ");
            sbSql.append("   DEC1.DDSENTCLC_CCLC = EHD.DDSENTCLC_CCLC  ");
            sbSql.append("  ) and ");
            sbSql.append("  DEC1.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DEC1.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  DEC1.NENTCO ='"+ NENTCO +"' and");
            sbSql.append("  EHD.CDG_CCLC !='"+ CDG_CCLC +"' and ");
            sbSql.append("  EHD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_ENTCLC_has_DDSENTCLC EHD2,PDR_DDSENTCLC DEC2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DEC2.CDG_PRV        = EHD2.CDG_PRV     and ");
            sbSql.append("      DEC2.CDG_MNC        = EHD2.CDG_MNC     and ");
            sbSql.append("      DEC2.DDSENTCLC_CCLC = EHD2.DDSENTCLC_CCLC  ");
            sbSql.append("    ) and "); 
            sbSql.append("    EHD.CDG_CCLC = EHD2.CDG_CCLC ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DEC1.DDSENTCLC_CCLC < DEC2.DDSENTCLC_CCLC  or ");
            sbSql.append("    DEC2.DDSENTCLC_CCLC = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprova si te asignat alguna Entitat Singular.
    public boolean teEntSng()
    {
        boolean bResultado;
        bResultado = false;
       
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_ENTSNG_has_DDSENTSNG EHS,PDR_DDSENTSNG DES");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DES.CDG_PRV        = EHS.CDG_PRV     and ");
            sbSql.append("   DES.CDG_MNC        = EHS.CDG_MNC     and ");
            sbSql.append("   DES.DDSENTSNG_CSNG = EHS.DDSENTSNG_CSNG  ");
            sbSql.append("  ) and ");
            sbSql.append("  DES.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DES.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  CDG_CCLC  = '"+ CDG_CCLC + "' and ");
            sbSql.append("  EHS.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_ENTSNG_has_DDSENTSNG EHS2,PDR_DDSENTSNG DES2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DES2.CDG_PRV        = EHS2.CDG_PRV     and ");
            sbSql.append("      DES2.CDG_MNC        = EHS2.CDG_MNC     and ");
            sbSql.append("      DES2.DDSENTSNG_CSNG = EHS2.DDSENTSNG_CSNG  ");
            sbSql.append("    ) and "); 
            sbSql.append("    EHS.CDG_CSNG = EHS2.CDG_CSNG ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DES.DDSENTSNG_CSNG < DES2.DDSENTSNG_CSNG  or ");
            sbSql.append("    DES2.DDSENTSNG_CSNG = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset totes les Entitats Colectives que no estiguin donats de baixa.
    public ResultSet TotsEntColectiva()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_ENTCLC_has_DDSENTCLC EHD,PDR_DDSENTCLC DEC1");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DEC1.CDG_PRV        = EHD.CDG_PRV     and ");
        sbSql.append("   DEC1.CDG_MNC        = EHD.CDG_MNC     and ");
        sbSql.append("   DEC1.DDSENTCLC_CCLC = EHD.DDSENTCLC_CCLC  ");
        sbSql.append("  ) and ");
        sbSql.append("  DEC1.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DEC1.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  EHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_ENTCLC_has_DDSENTCLC EHD2,PDR_DDSENTCLC DEC2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DEC2.CDG_PRV        = EHD2.CDG_PRV     and ");
        sbSql.append("      DEC2.CDG_MNC        = EHD2.CDG_MNC     and ");
        sbSql.append("      DEC2.DDSENTCLC_CCLC = EHD2.DDSENTCLC_CCLC  ");
        sbSql.append("    ) and "); 
        sbSql.append("    EHD.CDG_CCLC = EHD2.CDG_CCLC ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DEC1.DDSENTCLC_CCLC < DEC2.DDSENTCLC_CCLC  or ");
        sbSql.append("    DEC2.DDSENTCLC_CCLC = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
        sbSql.append("  order by DEC1.NENTCO ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per Entitat Colectiva d'una provincia i un Municipi.
    public String MostrarEntColectiva (int PRV, int MNC)
    {
        StringBuffer    sResultat;
        ResultSet       rSelect; 
        PDREntColectiva oEntCol;
        int          i;
        
        sResultat = new StringBuffer("");
        oEntCol   = new PDREntColectiva(con, CDG_USR);
        i = 0;
        
        try
        {
            // Coloquem en el objecta les Provincia y Municipi corresponent.
            oEntCol.CDG_PRV = PRV;
            oEntCol.CDG_MNC = MNC;
            
            // obtenim els Tots els Tipus de Via
            rSelect = oEntCol.TotsEntColectiva();
            
            sResultat.append("<SELECT NAME=\"EntColectiva\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oEntCol.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\"" + oEntCol.NENTCO + "\"");
                if (NENTCO.compareTo(oEntCol.NENTCO) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(">"+oEntCol.NENTCO+"</OPTION>");
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Comprova si la Entitat Colectiva es correcta per inserir-la.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      
      // Posem perque funcioni la comprovacio de si existeix el nom.
      CDG_CCLC = -1;
      
      // El nombre ens indica el problema. 
      if (NENTCO.compareTo("")==0)// Problema 53
      {
          sResultado = sResultado + "e53: Falta posar el nom de la Entitat Colectiva. <br /> " ;
      }
      if (NENTCO50.compareTo("")==0)// Problema 54
      {
          sResultado = sResultado + "e54: Faltar posar el nom de com a molt 50 carcters de la Entitat Colectiva. <br /> " ;
      }
      if (NENTCOC.compareTo("")==0)// Problema 55
      {
          sResultado = sResultado + "e55: Falta posar el nom curt de la Entitat Colectiva. <br /> " ;
      }
         
      // Comprova si las dades se adecuan a las de la base de dades.
      if (existeNENTCO())// Problema 56
      {
          sResultado = sResultado + "e56: El nom de la Entitat Colectiva existeix. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
      
    }
    
    // Comprueba si la Entitat Singular es pot updatear
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
              
      // El nombre ens indica el problema. 
      if (CDG_CCLC == -1)// Problema 16
      {
          sResultado = sResultado + "e16: El update requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      
      if (! existeCDGCCLC())// Problema 57
      {
        sResultado = sResultado + "e57: La Entitat Colectiva no existeix. <br /> " ;
      }
       
      if (NENTCO.compareTo("")==0)// Problema 53
      {
          sResultado = sResultado + "e53: Falta posar el nom de la Entitat Colectiva. <br /> " ;
      }
      if (NENTCO50.compareTo("")==0)// Problema 54
      {
          sResultado = sResultado + "e54: Faltar posar el nom de com a molt 50 carcters de la Entitat Colectiva. <br /> " ;
      }
      if (NENTCOC.compareTo("")==0)// Problema 55
      {
          sResultado = sResultado + "e55: Falta posar el nom curt de la Entitat Colectiva. <br /> " ;
      }
         
      // Comprova si las dades se adecuan a las de la base de dades.
      if (existeNENTCO())// Problema 56
      {
          sResultado = sResultado + "e56: El nom de la Entitat Colectiva existeix. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la provincia se puede borrar.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (CDG_CCLC == -1)// Problema 16
      {
          sResultado = sResultado + "e138: El delete requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      
      if (! existeCDGCCLC())// Problema 57
      {
        sResultado = sResultado + "e57: La Entitat Colectiva no existeix. <br /> " ;
      }
      
      if ( teEntSng())
      {
        sResultado = sResultado + "e58: La Entitat Colectiva esta relacionada amb Entitats Singulars. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprova si podem fer el select.
    
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hi ha comprovacions.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
}