/*
 * PDRHabitant.java
 *
 * Created on 30 de marzo de 2006, 10:11
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Panadero
 */

public class PDRHabitant {
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    public  ResultSet    rSelectPublic;     // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int          CDG_PRV;           // Nmero de identificacin de la provincia.        (Posat per nosaltres)
    public  int          CDG_MNC;           // Nmero que identifica la provincia.              (Posat per nosaltres)
    public  int          DDSHBT_CHBT;       // Cdi de les dades del Habitant.                  (Posat per nosaltres)
    public  int          CDG_CHBT;          // Cdi del Habitant.                               (Posat per nosaltres)
    public  String       NIA;               // Nmero de identificaci del Ayuntament           (Posat per l'usuari)
    public  int          NIE;               // Nmero de identificaci electoral                (Posat per l'usuari)
    public  String       NOMB;              // Nom.                                             (Posat per l'usuari)
    public  String       PART1;             // Particula del Primer Cognom.                     (Posat per l'usuari)
    public  String       APE1;              // Primer Cognom.                                   (Posat per l'usuari)
    public  String       PART2;             // Particula del Segon Cognom.                      (Posat per l'usuari)
    public  String       APE2;              // Segon Cognom.                                    (Posat per l'usuari)
    public  String       FNAC;              // Data de Naixement.                               (Posat per l'usuari)
    public  String       LEXTR;             // Lletra del Document Extranye.                    (Posat per l'usuari)
    public  String       CAUV;              // Cod acurat de Variaci                          (Posat per l'usuari)
    public  int          IDEN;              // Identificador.                                   (Posat per l'usuari)
    public  String       LIDEN;             // Cdi de control del Identificador.               (Posat per l'usuari)
    public  String       NDOCU;             // Nmero de Document.                              (Posat per l'usuari)
    public  int          SEXO;              // Ens indica el tipus de Sexa.                     (Posat per l'usuari)
    
    public  String       FFIN;              // Data que ens marca fins a on volen que busquem.  (Posat per l'usuari)
    private String       FVAR;              // Data del cambi.                                  (Posat per nosaltres)
    public  String       CVAR;              // Codi de Variacio                                 (Posat per nosaltres)
    private String       Envio;             // Ens indica si esta enviat al Ine.                (Posat per nosaltres)
    
    // Contenedores de otras clases.
    public  PDRTipusIden    TIPIDEN;            // Objecta Tipus Identificador                  (Posat per l'usuari)
    public  PDREstudios     ESTUDIOS;           // Objecta Estudios                             (Posat per l'usuari)
    public  PDRNacionalidad NACIONALIDAD;       // Objecta Nacionalidad                         (Posat per l'usuari)
    public  PDRProv         PROVNACIMIENTO;     // Objecta Prov (Provincia)                     (Posat per l'usuari)
    public  PDRMunc         MUNNACIMIENTO;      // Objecta Mun  (Municipi)                      (Posat per l'usuari)
    public  PDRProv         PROVPROCEDENCIA;    // Objecta Prov (Provincia)                     (Posat per l'usuari)
    public  PDRMunc         MUNPROCEDENCIA;     // Objecta Mun  (Municipi)                      (Posat per l'usuari)
    public  PDRConsulado    CONSULADO;          // Objecta Consulado                            (Posat per l'usuari)
    
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    // Dades del Usuari
    public  int        CDG_USR;         // Nmero que identifica al usuari que esta realitzan les accion (Posat per nosaltres)
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    
    // Creates a new instance of PDRHabitant 
    public PDRHabitant(int USR) 
    {
        // Relacionada con la base de datos
        con = null;               
        rSelectPublic = null;     
        // De la base de datos
        CDG_PRV     = -1;           
        CDG_MNC     = -1;         
        DDSHBT_CHBT = -1;       
        CDG_CHBT    = -1;       
        NIA         = "";            
        NIE         = -1;             
        NOMB        = "";           
        PART1       = "";            
        APE1        = "";             
        PART2       = "";            
        APE2        = "";              
        FNAC        = "";           
        LEXTR       = ""; 
        CAUV        = ""; 
        FFIN        = "";
        IDEN        = -1;           
        LIDEN       = "";           
        NDOCU       = ""; 
        SEXO        = -1;
        FVAR        = "";             
        CVAR        = ""; 
        Envio       = "";            
    
        // Contenedores de otras clases.          
        TIPIDEN         = new PDRTipusIden();           
        ESTUDIOS        = new PDREstudios();       
        NACIONALIDAD    = new PDRNacionalidad();    
        PROVNACIMIENTO  = new PDRProv();   
        MUNNACIMIENTO   = new PDRMunc();    
        PROVPROCEDENCIA = new PDRProv();   
        MUNPROCEDENCIA  = new PDRMunc();   
        CONSULADO       = new PDRConsulado();          
    
        // Relacionada con Errores
        sError = "";         
        // Dades del Usuari
        CDG_USR = USR;       
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
    }
    
    // Creates a new instance of PDRHabitant 
     public PDRHabitant(BDConnexio conexion, int USR) 
    {
        // Relacionada con la base de datos
        con = conexion;               
        rSelectPublic = null;     
        // De la base de datos
        CDG_PRV     = -1;           
        CDG_MNC     = -1;         
        DDSHBT_CHBT = -1;       
        CDG_CHBT    = -1;       
        NIA         = "";            
        NIE         = -1;             
        NOMB        = "";           
        PART1       = "";            
        APE1        = "";             
        PART2       = "";            
        APE2        = "";              
        FNAC        = "";           
        LEXTR       = "";   
        CAUV        = ""; 
        FFIN        = "";
        IDEN        = -1;           
        LIDEN       = "";           
        NDOCU       = ""; 
        SEXO        = -1;
        FVAR        = "";             
        CVAR        = ""; 
        Envio       = "";            
    
        // Contenedores de otras clases.           
        TIPIDEN         = new PDRTipusIden(conexion);           
        ESTUDIOS        = new PDREstudios(conexion);       
        NACIONALIDAD    = new PDRNacionalidad(conexion);    
        PROVNACIMIENTO  = new PDRProv(conexion);   
        MUNNACIMIENTO   = new PDRMunc(conexion);    
        PROVPROCEDENCIA = new PDRProv(conexion);   
        MUNPROCEDENCIA  = new PDRMunc(conexion);   
        CONSULADO       = new PDRConsulado(conexion);          
    
        // Relacionada con Errores
        sError = "";         
        // Dades del Usuari
        CDG_USR = USR;        
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
        
    }
    
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    public void reiniciar()
    {              
        // De la base de datos       
        DDSHBT_CHBT = -1;       
        CDG_CHBT    = -1;       
        NIA         = "";            
        NIE         = -1;             
        NOMB        = "";           
        PART1       = "";            
        APE1        = "";             
        PART2       = "";            
        APE2        = "";              
        FNAC        = "";           
        LEXTR       = ""; 
        CAUV        = ""; 
        FFIN        = "";
        IDEN        = -1;           
        LIDEN       = "";           
        NDOCU       = "";   
        SEXO        = -1;
        FVAR        = "";             
        CVAR        = ""; 
        Envio       = "";            
    
        // Contenedores de otras clases.            
        TIPIDEN         = new PDRTipusIden(con);           
        ESTUDIOS        = new PDREstudios(con);       
        NACIONALIDAD    = new PDRNacionalidad(con);    
        PROVNACIMIENTO  = new PDRProv(con);   
        MUNNACIMIENTO   = new PDRMunc(con);    
        PROVPROCEDENCIA = new PDRProv(con);   
        MUNPROCEDENCIA  = new PDRMunc(con);   
        CONSULADO       = new PDRConsulado(con);          
    
        // Relacionada con Errores
        sError = "";          // Guardamos todos los errores generados.
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {   
        String sData;
      try
      {
            CDG_PRV     = Integer.parseInt(rSelect.getString("CDG_PRV")); 
            CDG_MNC     = Integer.parseInt(rSelect.getString("CDG_MNC"));
            // De la base de datos       
            DDSHBT_CHBT = Integer.parseInt(rSelect.getString("DDSHBT_CHBT"));   
            CDG_CHBT    = Integer.parseInt(rSelect.getString("CDG_CHBT"));     
            NIA         = rSelect.getString ("NIA");       
            NIE         = Integer.parseInt(rSelect.getString("NIE"));         
            NOMB        = rSelect.getString ("NOMB");     
            PART1       = rSelect.getString ("PART1");        
            APE1        = rSelect.getString ("APE1");         
            PART2       = rSelect.getString ("PART2");         
            APE2        = rSelect.getString ("APE2");  
            LEXTR       = rSelect.getString ("LEXTR");           
            CAUV        = "";
            FFIN        = "";
            IDEN        = Integer.parseInt(rSelect.getString("IDEN"));    
            LIDEN       = rSelect.getString ("LIDEN");         
            NDOCU       = rSelect.getString ("NDOCU");          
            SEXO        = Integer.parseInt(rSelect.getString("SEXO"));    
            CVAR        = rSelect.getString ("CVAR"); 
            Envio       = rSelect.getString ("Envio");          
    
            // Coloquem la data en el format DD/MM/AAAA
            sData       = rSelect.getString ("FNAC");
            FNAC        = sData.substring(8,10) +"/"+ sData.substring(5,7) +"/"+ sData.substring(0,4) ;  
            
            // Dades de PDR_VIA_has_DDSVIA que no estan en l'altre.
            CDG_USR         = Integer.parseInt(rSelect.getString("CDG_USR")); 
            
            // Coloquem la data en el format DD/MM/AAAA
            sData       = rSelect.getString ("FVAR");
            FVAR        = sData.substring(8,10) +"/"+ sData.substring(5,7) +"/"+ sData.substring(0,4) ; 
            
            CVAR        = rSelect.getString ("CVAR");            
            Envio       = rSelect.getString ("Envio");   
          
            // Carguem les dades del Tipus de Identificador.
            if (Integer.parseInt(rSelect.getString("TIDEN")) != -1)
            {
                TIPIDEN.darTipusIden(Integer.parseInt(rSelect.getString("TIDEN")),"");
                // Intoduim el posibles error en els errors d'aquest objecte.
                if (TIPIDEN.sError.compareTo("") != 0)
                {
                    sError = sError + TIPIDEN.sError + "<br />"; 
                }
            }
            else
            {
              TIPIDEN.reiniciar();
            }
            // Carguem les dades del Nivell de Estudis.
            if (Integer.parseInt(rSelect.getString("CNES")) != -1)
            {
                ESTUDIOS.darEstudis(Integer.parseInt(rSelect.getString("CNES")),"");
                // Intoduim el posibles error en els errors d'aquest objecte.
                if (ESTUDIOS.sError.compareTo("") != 0)
                {
                    sError = sError + ESTUDIOS.sError + "<br />"; 
                }
            }
            else
            {
              ESTUDIOS.reiniciar();
            }
            // Carguem les dades de la Nacionalitat de Naixement.
            if (Integer.parseInt(rSelect.getString("NACI")) != -1)
            {
                NACIONALIDAD.darNacionalitat(Integer.parseInt(rSelect.getString("NACI")),"");
                // Intoduim el posibles error en els errors d'aquest objecte.
                if (ESTUDIOS.sError.compareTo("") != 0)
                {
                    sError = sError + NACIONALIDAD.sError + "<br />"; 
                }
            }
            else
            {
              NACIONALIDAD.reiniciar();
            }
            // Carguem les dades de la Provincia de Naixement.
            if (Integer.parseInt(rSelect.getString("CPRON")) != -1)
            {
                PROVNACIMIENTO.darProv(Integer.parseInt(rSelect.getString("CPRON")),"");
                // Intoduim el posibles error en els errors d'aquest objecte.
                if (PROVNACIMIENTO.sError.compareTo("") != 0)
                {
                    sError = sError + PROVNACIMIENTO.sError + "<br />"; 
                }
            }
            else
            {
              PROVNACIMIENTO.reiniciar();
            }
            // Carguem les dades del Municipi de Naixement.
            if (Integer.parseInt(rSelect.getString("CMUNN")) != -1)
            {
                MUNNACIMIENTO.darMunc(Integer.parseInt(rSelect.getString("CMUNN")),"");
                // Intoduim el posibles error en els errors d'aquest objecte.
                if (MUNNACIMIENTO.sError.compareTo("") != 0)
                {
                    sError = sError + MUNNACIMIENTO.sError + "<br />"; 
                }
            }
            else
            {
              MUNNACIMIENTO.reiniciar();
            }
            // Carguem les dades de la Provincia de Procedencia o Desti.
            if (Integer.parseInt(rSelect.getString("PRDP")) != -1)
            {
                PROVPROCEDENCIA.darProv(Integer.parseInt(rSelect.getString("PRDP")),"");
                // Intoduim el posibles error en els errors d'aquest objecte.
                if (PROVPROCEDENCIA.sError.compareTo("") != 0)
                {
                    sError = sError + PROVPROCEDENCIA.sError + "<br />"; 
                }
            }
            else
            {
              PROVPROCEDENCIA.reiniciar();
            }
            // Carguem les dades del Municipi de Procedencia o Desti.
            if (Integer.parseInt(rSelect.getString("MUDP")) != -1)
            {
                MUNPROCEDENCIA.darMunc(Integer.parseInt(rSelect.getString("MUDP")),"");
                // Intoduim el posibles error en els errors d'aquest objecte.
                if (MUNPROCEDENCIA.sError.compareTo("") != 0)
                {
                    sError = sError + MUNPROCEDENCIA.sError + "<br />"; 
                }
            }
            else
            {
              MUNPROCEDENCIA.reiniciar();
            }
            // Carguem les dades del Consulado.
            if (Integer.parseInt(rSelect.getString("CODP")) != -1)
            {
                CONSULADO.darConsulat(Integer.parseInt(rSelect.getString("CODP")),"");
                // Intoduim el posibles error en els errors d'aquest objecte.
                if (CONSULADO.sError.compareTo("") != 0)
                {
                    sError = sError + CONSULADO.sError + "<br />"; 
                }
            }
            else
            {
              CONSULADO.reiniciar();
            }
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Inserta los datos del Habitant en la taula de PDR_DDSHBT.
    // Inserta el  en taula de PDR_HBT.
    // Inserta la relaci Habitant-dades en la taula de PDR_HBT_has_DDSHBT.
    public void insert()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador HbtNum;
      
      // Date
      Data dFecha;
      
      HbtNum = new PDRNumerador(con);
      try
      {
        // Possem un numero a les dades del Habitant.
        HbtNum.NMR_NOM = "NMR_DDSHBT";
        HbtNum.select();
        DDSHBT_CHBT = HbtNum.NMR_VLR;
            
        sbSql = null;
      
        stmt = con.cnPrincipal.createStatement();

        // Preparem la sentncia SQL per inseri en PDR_DDSHBT
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_DDSHBT ");
        sbSql.append(" (CDG_PRV, CDG_MNC, DDSHBT_CHBT, SEXO, CPRON, CMUNN, TIDEN, CNES, NACI, PRDP,  ");
        sbSql.append("  MUDP, CODP, NIA, NIE, NOMB, PART1, APE1, PART2, APE2, FNAC, LEXTR, IDEN, LIDEN,");
        sbSql.append("  NDOCU)");
        sbSql.append(" values ");
        sbSql.append("('"+  CDG_PRV             +"', '"+ CDG_MNC             +"', '"+ DDSHBT_CHBT        +"', '");
        sbSql.append(       SEXO                +"', '"+ PROVNACIMIENTO.PROV +"', '"+ MUNNACIMIENTO.MUNC +"', '");
        sbSql.append(       TIPIDEN.TIDEN       +"', '"+ ESTUDIOS.CNES       +"', '"+ NACIONALIDAD.NACI  +"', '");
        sbSql.append(       PROVPROCEDENCIA.PROV+"', '"+ MUNPROCEDENCIA.MUNC +"', '"+ CONSULADO.CODP     +"', '");
        sbSql.append(       NIA                 +"', '"+ NIE                 +"', '"+ NOMB               +"', '");
        sbSql.append(       PART1               +"', '"+ APE1                +"', '"+ PART2              +"', '");
        sbSql.append(       APE2                +"', to_timestamp('"+ FNAC +"23:59:59','DD/MM/YYYY:HH24:MI:SS') , '"+ LEXTR  +"', '");
        sbSql.append(       IDEN                +"', '"+ LIDEN               +"', '"+ NDOCU              +"')");

        stmt.executeUpdate(sbSql.toString());
                
        // Possem un numero al Habitant.
        HbtNum.NMR_NOM = "NMR_HAB";
        HbtNum.select();
        CDG_CHBT = HbtNum.NMR_VLR;
        
        // Preparem la sentncia SQL per inseri en PDR_TRM
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_HBT ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CHBT) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV +"', '"+ CDG_MNC +"', '"+ CDG_CHBT+"')");
        
        stmt.executeUpdate(sbSql.toString());
        
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha();
        
        // Preparem la sentncia SQL per inseri en PDR_HBT_has_DDSHBT
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_HBT_has_DDSHBT ");
        sbSql.append(" (CDG_PRV, CDG_MNC, DDSHBT_CHBT, CDG_CHBT, CDG_USR, FVAR, CVAR, CAUV, Envio) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV  +"', '"+ CDG_MNC +"', '"+ DDSHBT_CHBT+"', '");
        sbSql.append(      CDG_CHBT +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'A'"+", '"+ CAUV +"',");
        sbSql.append(      "'N')");
        
        stmt.executeUpdate(sbSql.toString());
        
        stmt.close();
        con.cnPrincipal.commit();
        
    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un Insert de las dades de Habitant en la taula de PDR_DDSHBT.
    // Fa un Insert en la taula PDR_HBT_has_DDSHBT enllaant HBT-Dades Noves.
    // Es pot updateixa tot menys Provincia i Municipi.
    public void update()
    {
      // Conexio
      Statement    stmt; 
      StringBuffer sbSql;
      PDRNumerador HbtNum;
      
      // Date
      Data dFecha;
      
      HbtNum = new PDRNumerador(con);
      try{
        // Possem un numero a les dades del Tram.
        HbtNum.NMR_NOM = "NMR_DDSHBT";
        HbtNum.select();
        DDSHBT_CHBT = HbtNum.NMR_VLR;
      
        sbSql = null;
      
        stmt = con.cnPrincipal.createStatement();
       
        // Preparem la sentncia SQL per inseri en PDR_DDSHBT
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_DDSHBT ");
        sbSql.append(" (CDG_PRV, CDG_MNC, DDSHBT_CHBT, SEXO, CPRON, CMUNN, TIDEN, CNES, NACI, PRDP,  ");
        sbSql.append("  MUDP, CODP, NIA, NIE, NOMB, PART1, APE1, PART2, APE2, FNAC, LEXTR, IDEN, LIDEN,");
        sbSql.append("  NDOCU)");
        sbSql.append(" values ");
        sbSql.append("('"+  CDG_PRV             +"', '"+ CDG_MNC             +"', '"+ DDSHBT_CHBT        +"', '");
        sbSql.append(       SEXO                +"', '"+ PROVNACIMIENTO.PROV +"', '"+ MUNNACIMIENTO.MUNC +"', '");
        sbSql.append(       TIPIDEN.TIDEN       +"', '"+ ESTUDIOS.CNES       +"', '"+ NACIONALIDAD.NACI  +"', '");
        sbSql.append(       PROVPROCEDENCIA.PROV+"', '"+ MUNPROCEDENCIA.MUNC +"', '"+ CONSULADO.CODP     +"', '");
        sbSql.append(       NIA                 +"', '"+ NIE                 +"', '"+ NOMB               +"', '");
        sbSql.append(       PART1               +"', '"+ APE1                +"', '"+ PART2              +"', '");
        sbSql.append(       APE2                +"', to_timestamp('"+ FNAC +"23:59:59','DD/MM/YYYY:HH24:MI:SS') , '"+ LEXTR  +"', '");
        sbSql.append(       IDEN                +"', '"+ LIDEN               +"', '"+ NDOCU              +"')");
        
        stmt.executeUpdate(sbSql.toString());
        
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha(); 
        
        // Preparem la sentncia SQL per inseri en PDR_HBT_has_DDSHBT
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_HBT_has_DDSHBT ");
        sbSql.append(" (CDG_PRV, CDG_MNC, DDSHBT_CHBT, CDG_CHBT, CDG_USR, FVAR, CVAR, CAUV, Envio) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV  +"', '"+ CDG_MNC +"', '"+ DDSHBT_CHBT+"', '");
        sbSql.append(      CDG_CHBT +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'M'"+", '");
        sbSql.append(      CAUV +"', 'N')");
        
        stmt.executeUpdate(sbSql.toString());
        
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un Insert en la taula PDR_HBT_has_DDSHBT enllaant HBT-Dades, inserim en motiu envia a Ine Baixa.
    public void delete()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      
      // Date
      Data dFecha;
      
      sbSql = null;
      try{
        stmt = con.cnPrincipal.createStatement();
       
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha();
        
        // Preparem la sentncia SQL per inseri en PDR_HBT_has_DDSHBT
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_HBT_has_DDSHBT ");
        sbSql.append(" (CDG_PRV, CDG_MNC, DDSHBT_CHBT, CDG_CHBT, CDG_USR, FVAR, CVAR, Envio, CAUV) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV  +"', '"+ CDG_MNC +"', '-1', '");
        sbSql.append(      CDG_CHBT +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'B'"+",");
        sbSql.append(      "'N', '"+ CAUV  +"' )");
        
        stmt.executeUpdate(sbSql.toString());
        
        if (habitantTeHabitatge())
        {
            // Preparem la sentncia SQL per inseri en PDR_HBT_has_HABITATGE
            sbSql = new StringBuffer("");
            sbSql.append("Insert into  ");
            sbSql.append( " PDR_habitant_has_habitatge ");
            sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CHBT, CDG_CHBTG, CDG_USR, FVAR, CVAR, CAUV, Envio) ");
            sbSql.append(" values ");
            sbSql.append("('"+ CDG_PRV +"', '"+ CDG_MNC +"', '"+ CDG_CHBT+"', ");
            sbSql.append(   "'-1', '"  + CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'A', '"+ CAUV + "' , 'N')");
            
            stmt.executeUpdate(sbSql.toString());
            
        }
        
        
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'un Habitant
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{
        // Cerramos el select anterior
        if (rSelectPublic != null){rSelectPublic.close();}  
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HBT_has_DDSHBT HHD,PDR_DDSHBT DHB");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DHB.CDG_PRV     = HHD.CDG_PRV     and ");
        sbSql.append("   DHB.CDG_MNC     = HHD.CDG_MNC     and ");
        sbSql.append("   DHB.DDSHBT_CHBT = HHD.DDSHBT_CHBT     ");
        sbSql.append("  ) and ");
        sbSql.append("  DHB.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DHB.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( HHD.CDG_CHBT ='"+ CDG_CHBT +"' or ");
        sbSql.append(   "'"+CDG_CHBT +"'  = -1) and");
        sbSql.append("  ( DHB.NIA ='"+ NIA +"' or ");
        sbSql.append(   "'"+NIA           +"'  = '') and");  
        sbSql.append("  ( DHB.NIE ='"+ NIE +"' or ");
        sbSql.append(   "'"+NIE +"'  = -1) and");
        sbSql.append("  ( DHB.NOMB LIKE'%"+ NOMB +"%' or ");
        sbSql.append(   "'"+NOMB           +"'  = '') and"); 
        sbSql.append("  ( DHB.PART1 ='"+ PART1 +"' or ");
        sbSql.append(   "'"+PART1           +"'  = '') and"); 
        sbSql.append("  ( DHB.APE1 LIKE '%"+ APE1 +"%' or ");
        sbSql.append(   "'"+APE1           +"'  = '') and"); 
        sbSql.append("  ( DHB.PART2 ='"+ PART2 +"' or ");
        sbSql.append(   "'"+PART2           +"'  = '') and"); 
        sbSql.append("  ( DHB.APE2 LIKE '%"+ APE2 +"%' or ");
        sbSql.append(   "'"+APE2           +"'  = '') and"); 
        sbSql.append("  ( DHB.FNAC = to_timestamp('"+ FNAC +"23:59:59','DD/MM/YYYY:HH24:MI:SS') or ");
        sbSql.append(   "'"+FNAC           +"'  = '') and"); 
        sbSql.append("  ( DHB.LEXTR ='"+ LEXTR +"' or ");
        sbSql.append(   "'"+LEXTR           +"'  = '') and"); 
        sbSql.append("  ( DHB.IDEN ='"+ IDEN +"' or ");
        sbSql.append(   "'"+IDEN +"'  = -1) and");
        sbSql.append("  ( DHB.LIDEN ='"+ LIDEN +"' or ");
        sbSql.append(   "'"+LIDEN           +"'  = '') and"); 
        sbSql.append("  ( DHB.NDOCU ='"+ NDOCU +"' or ");
        sbSql.append(   "'"+NDOCU           +"'  = '') and"); 
        sbSql.append("  ( DHB.SEXO ='"+ SEXO +"' or ");
        sbSql.append(   "'"+SEXO           +"'  = -1) and");     
        sbSql.append("  ( DHB.TIDEN ='"+ TIPIDEN.TIDEN +"' or ");
        sbSql.append(   "'"+TIPIDEN.TIDEN  +"'  = -1) and");    
        sbSql.append("  ( DHB.CNES ='"+ ESTUDIOS.CNES +"' or ");
        sbSql.append(   "'"+ESTUDIOS.CNES  +"'  = -1) and");    
        sbSql.append("  ( DHB.NACI ='"+ NACIONALIDAD.NACI +"' or ");
        sbSql.append(   "'"+NACIONALIDAD.NACI +"'  = -1) and");    
        sbSql.append("  ( DHB.CPRON ='"+ PROVNACIMIENTO.PROV +"' or ");
        sbSql.append(   "'"+PROVNACIMIENTO.PROV +"'  = -1) and");    
        sbSql.append("  ( DHB.CMUNN ='"+ MUNNACIMIENTO.MUNC +"' or ");
        sbSql.append(   "'"+MUNNACIMIENTO.MUNC +"'  = -1) and");    
        sbSql.append("  ( DHB.PRDP ='"+ PROVPROCEDENCIA.PROV +"' or ");
        sbSql.append(   "'"+PROVPROCEDENCIA.PROV +"'  = -1) and"); 
        sbSql.append("  ( DHB.MUDP ='"+ MUNPROCEDENCIA.MUNC +"' or ");
        sbSql.append(   "'"+MUNPROCEDENCIA.MUNC +"'  = -1) and");  
        sbSql.append("  ( DHB.CODP ='"+ PROVPROCEDENCIA.PROV +"' or ");
        sbSql.append(   "'"+PROVPROCEDENCIA.PROV +"'  = -1) and");          
        sbSql.append("  HHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_HBT_has_DDSHBT HHD2, PDR_DDSHBT DHB2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DHB2.CDG_PRV     = HHD2.CDG_PRV     and ");
        sbSql.append("      DHB2.CDG_MNC     = HHD2.CDG_MNC     and ");
        sbSql.append("      DHB2.DDSHBT_CHBT = HHD2.DDSHBT_CHBT ");
        sbSql.append("    ) and "); 
        sbSql.append("    HHD.CDG_CHBT = HHD2.CDG_CHBT ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DHB.DDSHBT_CHBT < DHB2.DDSHBT_CHBT  or ");
        sbSql.append("    DHB2.DDSHBT_CHBT =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
        sbSql.append("  order by HHD.CDG_CHBT ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
           rSelectPublic = rSelect;
           
           // Desbloqueamos o bloqueamos los botones que haga falta.
           if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
           if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
        }
        else
        {
           sError = sError + "e74: No existeixen Habitants amb aquestes caracterstiques." +"<br />";
           rSelectPublic = null;
           // Desactivamos los botones de siguiente y anteriror.
           sSiguiente    = "disabled";
           sAnterior     = "disabled";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'un Habitant incluient els que estan donats de baixa
    public void selectAmbBaixa()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{
        // Cerramos el select anterior
        if (rSelectPublic != null){rSelectPublic.close();}  
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HBT_has_DDSHBT HHD,PDR_DDSHBT DHB");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DHB.CDG_PRV     = HHD.CDG_PRV     and ");
        sbSql.append("   DHB.CDG_MNC     = HHD.CDG_MNC     and ");
        sbSql.append("   DHB.DDSHBT_CHBT = HHD.DDSHBT_CHBT     ");
        sbSql.append("  ) and ");
        sbSql.append("  DHB.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DHB.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( HHD.CDG_CHBT ='"+ CDG_CHBT +"' or ");
        sbSql.append(   "'"+CDG_CHBT +"'  = -1) and");
        sbSql.append(   " HHD.CDG_CHBT   <> -1 and ");
        sbSql.append("  ( DHB.NIA ='"+ NIA +"' or ");
        sbSql.append(   "'"+NIA           +"'  = '') and");  
        sbSql.append("  ( DHB.NIE ='"+ NIE +"' or ");
        sbSql.append(   "'"+NIE +"'  = -1) and");
        sbSql.append("  ( DHB.NOMB LIKE '%"+ NOMB +"%' or ");
        sbSql.append(   "'"+NOMB           +"'  = '') and"); 
        sbSql.append("  ( DHB.PART1 ='"+ PART1 +"' or ");
        sbSql.append(   "'"+PART1           +"'  = '') and"); 
        sbSql.append("  ( DHB.APE1 LIKE '%"+ APE1 +"%' or ");
        sbSql.append(   "'"+APE1           +"'  = '') and"); 
        sbSql.append("  ( DHB.PART2 ='"+ PART2 +"' or ");
        sbSql.append(   "'"+PART2           +"'  = '') and"); 
        sbSql.append("  ( DHB.APE2 LIKE '%"+ APE2 +"%' or ");
        sbSql.append(   "'"+APE2           +"'  = '') and"); 
        sbSql.append("  ( DHB.FNAC = to_timestamp('"+ FNAC +"23:59:59','DD/MM/YYYY:HH24:MI:SS') or ");
        sbSql.append(   "'"+FNAC           +"'  = '') and"); 
        sbSql.append("  ( DHB.LEXTR ='"+ LEXTR +"' or ");
        sbSql.append(   "'"+LEXTR           +"'  = '') and"); 
        sbSql.append("  ( DHB.IDEN ='"+ IDEN +"' or ");
        sbSql.append(   "'"+IDEN +"'  = -1) and");
        sbSql.append("  ( DHB.LIDEN ='"+ LIDEN +"' or ");
        sbSql.append(   "'"+LIDEN           +"'  = '') and"); 
        sbSql.append("  ( DHB.NDOCU ='"+ NDOCU +"' or ");
        sbSql.append(   "'"+NDOCU           +"'  = '') and"); 
        sbSql.append("  ( DHB.SEXO ='"+ SEXO +"' or ");
        sbSql.append(   "'"+SEXO           +"'  = -1) and");     
        sbSql.append("  ( DHB.TIDEN ='"+ TIPIDEN.TIDEN +"' or ");
        sbSql.append(   "'"+TIPIDEN.TIDEN  +"'  = -1) and");    
        sbSql.append("  ( DHB.CNES ='"+ ESTUDIOS.CNES +"' or ");
        sbSql.append(   "'"+ESTUDIOS.CNES  +"'  = -1) and");    
        sbSql.append("  ( DHB.NACI ='"+ NACIONALIDAD.NACI +"' or ");
        sbSql.append(   "'"+NACIONALIDAD.NACI +"'  = -1) and");    
        sbSql.append("  ( DHB.CPRON ='"+ PROVNACIMIENTO.PROV +"' or ");
        sbSql.append(   "'"+PROVNACIMIENTO.PROV +"'  = -1) and");    
        sbSql.append("  ( DHB.CMUNN ='"+ MUNNACIMIENTO.MUNC +"' or ");
        sbSql.append(   "'"+MUNNACIMIENTO.MUNC +"'  = -1) and");    
        sbSql.append("  ( DHB.PRDP ='"+ PROVPROCEDENCIA.PROV +"' or ");
        sbSql.append(   "'"+PROVPROCEDENCIA.PROV +"'  = -1) and"); 
        sbSql.append("  ( DHB.MUDP ='"+ MUNPROCEDENCIA.MUNC +"' or ");
        sbSql.append(   "'"+MUNPROCEDENCIA.MUNC +"'  = -1) and");  
        sbSql.append("  ( DHB.CODP ='"+ PROVPROCEDENCIA.PROV +"' or ");
        sbSql.append(   "'"+PROVPROCEDENCIA.PROV +"'  = -1) and"); ;
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_HBT_has_DDSHBT HHD2, PDR_DDSHBT DHB2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DHB2.CDG_PRV     = HHD2.CDG_PRV     and ");
        sbSql.append("      DHB2.CDG_MNC     = HHD2.CDG_MNC     and ");
        sbSql.append("      DHB2.DDSHBT_CHBT = HHD2.DDSHBT_CHBT ");
        sbSql.append("    ) and "); 
        sbSql.append("    HHD.CDG_CHBT = HHD2.CDG_CHBT ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DHB.DDSHBT_CHBT < DHB2.DDSHBT_CHBT ");
        sbSql.append("    )");
        sbSql.append("  ) ");
        sbSql.append("  order by HHD.CDG_CHBT ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
           rSelectPublic = rSelect;
           
           // Desbloqueamos o bloqueamos los botones que haga falta.
           if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
           if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
        }
        else
        {
           sError = sError + "e74: No existeixen Habitants amb aquestes caracterstiques." +"<br />";
           rSelectPublic = null;
           // Desactivamos los botones de siguiente y anteriror.
           sSiguiente    = "disabled";
           sAnterior     = "disabled";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Recopera l'historial d'un Habitant fins a una date referinsa a les dades del habitant.
    public ResultSet historialDDSHabitant()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HBT_has_DDSHBT HHD,PDR_DDSHBT DHB");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DHB.CDG_PRV     = HHD.CDG_PRV     and ");
        sbSql.append("   DHB.CDG_MNC     = HHD.CDG_MNC     and ");
        sbSql.append("   DHB.DDSHBT_CHBT = HHD.DDSHBT_CHBT     ");
        sbSql.append("  ) and ");
        sbSql.append("  DHB.CDG_PRV  ='"+ CDG_PRV +"' and ");
        sbSql.append("  DHB.CDG_MNC  ='"+ CDG_MNC +"' and ");
        sbSql.append("  HHD.CDG_CHBT ='"+ CDG_CHBT +"' and");        
        sbSql.append("  HHD.FVAR < to_timestamp('"+ FFIN +"23:59:59','DD/MM/YYYY:HH24:MI:SS')");
        sbSql.append("  order by HHD.FVAR ");      
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Recopera l'historial d'un Habitant del habitatges on ha viscut ins a una date.
    public ResultSet historialDDSHabitantHabitatge()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_Habitant_has_Habitatge HHH,PDR_HABITATGE HAB");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   HHH.CDG_PRV   = HAB.CDG_PRV     and ");
        sbSql.append("   HHH.CDG_MNC   = HAB.CDG_MNC     and ");
        sbSql.append("   HHH.CDG_CHBTG = HAB.CDG_CHBTG     ");
        sbSql.append("  ) and ");
        sbSql.append("  HHH.CDG_PRV  ='"+ CDG_PRV +"' and ");
        sbSql.append("  HHH.CDG_MNC  ='"+ CDG_MNC +"' and ");
        sbSql.append("  HHH.CDG_CHBT ='"+ CDG_CHBT +"' and");        
        sbSql.append("  HHH.FVAR < to_timestamp('"+ FFIN +"23:59:59','DD/MM/YYYY:HH24:MI:SS')");
        sbSql.append("  order by HHH.FVAR ");      
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs. " + "<br />";}
    }
    
    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs. " + "<br />";}
    }
    
    // Carrega el Habitant en el objecte que la cridat.
    // Requereix que tingui posada la provincia y el municipi de busqueda
    public void darHabitant(int CDG_CHBTaux, String NIAaux, String NOMBaux, String PART1aux, String APE1aux, String PART2aux, String APE2aux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        
        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HBT_has_DDSHBT HHD,PDR_DDSHBT DHB");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DHB.CDG_PRV     = HHD.CDG_PRV     and ");
        sbSql.append("   DHB.CDG_MNC     = HHD.CDG_MNC     and ");
        sbSql.append("   DHB.DDSHBT_CHBT = HHD.DDSHBT_CHBT     ");
        sbSql.append("  ) and ");
        sbSql.append("  DHB.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DHB.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( HHD.CDG_CHBT ='"+ CDG_CHBTaux +"' or ");
        sbSql.append("    DHB.NIA      ='"+ NIAaux +"' or ");
        sbSql.append("    ( DHB.NOMB  ='"+ NOMBaux   +"' and ");
        sbSql.append("      DHB.PART1 ='"+ PART1aux +"' and "); 
        sbSql.append("      DHB.APE1  ='"+ APE1aux   +"' and ");
        sbSql.append("      DHB.PART2 ='"+ PART2aux +"' and ");
        sbSql.append("      DHB.APE2  ='"+ APE2aux   +"') ");
        sbSql.append("  ) and");  
        sbSql.append("  HHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_HBT_has_DDSHBT HHD2, PDR_DDSHBT DHB2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DHB2.CDG_PRV     = HHD2.CDG_PRV     and ");
        sbSql.append("      DHB2.CDG_MNC     = HHD2.CDG_MNC     and ");
        sbSql.append("      DHB2.DDSHBT_CHBT = HHD2.DDSHBT_CHBT ");
        sbSql.append("    ) and "); 
        sbSql.append("    HHD.CDG_CHBT = HHD2.CDG_CHBT ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DHB.DDSHBT_CHBT < DHB2.DDSHBT_CHBT  or ");
        sbSql.append("    DHB2.DDSHBT_CHBT =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
           
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {  // Esta en comentari perque no surti a la hora de busca gent als habitatges, les persones donades de baixa donan aquest resultat.
           //sError = sError + "e111: El Habitant no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Carrega el Habitant en el objecte que la cridat.
    // Requereix que tingui posada la provincia y el municipi de busqueda
    public void darHabitant(int CDG_CHBTaux, String NIAaux, String NOMBaux, String PART1aux, String APE1aux, String PART2aux, String APE2aux, String Data)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        
        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HBT_has_DDSHBT HHD,PDR_DDSHBT DHB");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DHB.CDG_PRV     = HHD.CDG_PRV     and ");
        sbSql.append("   DHB.CDG_MNC     = HHD.CDG_MNC     and ");
        sbSql.append("   DHB.DDSHBT_CHBT = HHD.DDSHBT_CHBT     ");
        sbSql.append("  ) and ");
        sbSql.append("  DHB.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DHB.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( HHD.CDG_CHBT ='"+ CDG_CHBTaux +"' or ");
        sbSql.append("    DHB.NIA      ='"+ NIAaux +"' or ");
        sbSql.append("    ( DHB.NOMB  ='"+ NOMBaux   +"' and ");
        sbSql.append("      DHB.PART1 ='"+ PART1aux +"' and "); 
        sbSql.append("      DHB.APE1  ='"+ APE1aux   +"' and ");
        sbSql.append("      DHB.PART2 ='"+ PART2aux +"' and ");
        sbSql.append("      DHB.APE2  ='"+ APE2aux   +"') ");
        sbSql.append("  ) and");  
        sbSql.append("  HHD.CVAR <> 'B' and ");
        sbSql.append("  HHD.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_HBT_has_DDSHBT HHD2, PDR_DDSHBT DHB2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DHB2.CDG_PRV     = HHD2.CDG_PRV     and ");
        sbSql.append("      DHB2.CDG_MNC     = HHD2.CDG_MNC     and ");
        sbSql.append("      DHB2.DDSHBT_CHBT = HHD2.DDSHBT_CHBT ");
        sbSql.append("    ) and "); 
        sbSql.append("    HHD.CDG_CHBT = HHD2.CDG_CHBT and ");
        sbSql.append("    HHD2.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("    (");
        sbSql.append("    DHB.DDSHBT_CHBT < DHB2.DDSHBT_CHBT  or ");
        sbSql.append("    DHB2.DDSHBT_CHBT =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
           
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {  // Esta en comentari perque no surti a la hora de busca gent als habitatges, les persones donades de baixa donan aquest resultat.
           //sError = sError + "e111: El Habitant no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Recopera el Habitant Singular que ens han marcat (d'un habitatge) a una data o ens retorna totes les d'una data si no ens han marcat cap.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarHabitants (int iCDG_CHBTG, String sData)
    {    
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HBT_has_DDSHBT HHD,PDR_DDSHBT DHB, PDR_Habitant_has_Habitatge HHH");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DHB.CDG_PRV     = HHD.CDG_PRV     and ");
        sbSql.append("   DHB.CDG_MNC     = HHD.CDG_MNC     and ");
        sbSql.append("   DHB.DDSHBT_CHBT = HHD.DDSHBT_CHBT     ");
        sbSql.append("  ) and ");
        sbSql.append("  ( ");
        sbSql.append("   HHH.CDG_PRV  = HHD.CDG_PRV     and ");
        sbSql.append("   HHH.CDG_MNC  = HHD.CDG_MNC     and ");
        sbSql.append("   HHH.CDG_CHBT = HHD.CDG_CHBT     ");
        sbSql.append("  ) and ");
        sbSql.append("  DHB.CDG_PRV   ='"+ CDG_PRV +"' and ");
        sbSql.append("  DHB.CDG_MNC   ='"+ CDG_MNC +"' and ");
        sbSql.append("  (HHH.CDG_CHBTG     ='"+ iCDG_CHBTG +"' or ");
        sbSql.append("  '"+ iCDG_CHBTG +"' = -1) and ");
        sbSql.append("  HHD.CVAR <> 'B' and ");
        sbSql.append("  HHD.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_HBT_has_DDSHBT HHD2, PDR_DDSHBT DHB2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DHB2.CDG_PRV     = HHD2.CDG_PRV     and ");
        sbSql.append("      DHB2.CDG_MNC     = HHD2.CDG_MNC     and ");
        sbSql.append("      DHB2.DDSHBT_CHBT = HHD2.DDSHBT_CHBT ");
        sbSql.append("    ) and "); 
        sbSql.append("    HHD.CDG_CHBT = HHD2.CDG_CHBT and ");
        sbSql.append("    HHD2.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("    (");
        sbSql.append("    DHB.DDSHBT_CHBT < DHB2.DDSHBT_CHBT  or ");
        sbSql.append("    DHB2.DDSHBT_CHBT =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Comproba si el Habitant existeix.
    public boolean existeHabitant()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
             // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HBT_has_DDSHBT HHD,PDR_DDSHBT DHB");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DHB.CDG_PRV     = HHD.CDG_PRV     and ");
        sbSql.append("   DHB.CDG_MNC     = HHD.CDG_MNC     and ");
        sbSql.append("   DHB.DDSHBT_CHBT = HHD.DDSHBT_CHBT     ");
        sbSql.append("  ) and ");
        sbSql.append("  DHB.CDG_PRV  ='"+ CDG_PRV  +"' and ");
        sbSql.append("  DHB.CDG_MNC  ='"+ CDG_MNC  +"' and ");
        sbSql.append("  ( HHD.CDG_CHBT ='"+ CDG_CHBT +"' or "); 
        sbSql.append("    DHB.NIA ='"+ NIA +"' ) and "); 
        sbSql.append("  HHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_HBT_has_DDSHBT HHD2, PDR_DDSHBT DHB2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DHB2.CDG_PRV     = HHD2.CDG_PRV     and ");
        sbSql.append("      DHB2.CDG_MNC     = HHD2.CDG_MNC     and ");
        sbSql.append("      DHB2.DDSHBT_CHBT = HHD2.DDSHBT_CHBT ");
        sbSql.append("    ) and "); 
        sbSql.append("    HHD.CDG_CHBT = HHD2.CDG_CHBT ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DHB.DDSHBT_CHBT < DHB2.DDSHBT_CHBT  or ");
        sbSql.append("    DHB2.DDSHBT_CHBT =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comproba si el Nia ya existeix.
    public boolean existeNIA()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
             // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HBT_has_DDSHBT HHD,PDR_DDSHBT DHB");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DHB.CDG_PRV     = HHD.CDG_PRV     and ");
        sbSql.append("   DHB.CDG_MNC     = HHD.CDG_MNC     and ");
        sbSql.append("   DHB.DDSHBT_CHBT = HHD.DDSHBT_CHBT     ");
        sbSql.append("  ) and ");
        sbSql.append("  DHB.CDG_PRV   ='"+ CDG_PRV  +"' and ");
        sbSql.append("  DHB.CDG_MNC   ='"+ CDG_MNC  +"' and ");
        sbSql.append("  DHB.NIA       ='"+ NIA +"' and "); 
        sbSql.append("  HHD.CDG_CHBT !='"+ CDG_CHBT +"' and");
        sbSql.append("  HHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_HBT_has_DDSHBT HHD2, PDR_DDSHBT DHB2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DHB2.CDG_PRV     = HHD2.CDG_PRV     and ");
        sbSql.append("      DHB2.CDG_MNC     = HHD2.CDG_MNC     and ");
        sbSql.append("      DHB2.DDSHBT_CHBT = HHD2.DDSHBT_CHBT ");
        sbSql.append("    ) and "); 
        sbSql.append("    HHD.CDG_CHBT = HHD2.CDG_CHBT ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DHB.DDSHBT_CHBT < DHB2.DDSHBT_CHBT  or ");
        sbSql.append("    DHB2.DDSHBT_CHBT =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
             
    // Ens diu si un habitant te habitatge asignat en aquest moment.
    public boolean habitantTeHabitatge()
    {
        boolean bResultado;
        bResultado = false;
       
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HABITANT_has_HABITATGE HHH");
        sbSql.append(" where ");
        sbSql.append("  HHH.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  HHH.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  HHH.CDG_CHBT  ='"+ CDG_CHBT  +"' and ");
        sbSql.append("  HHH.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_HABITANT_has_HABITATGE HHH2");
        sbSql.append("    where");
        sbSql.append("    HHH.CDG_CHBT = HHH2.CDG_CHBT ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    HHH.FVAR < HHH2.FVAR ");
        sbSql.append("    )");
        sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    public String MostrarhistorialDDSHabitant()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        
        sResultat = new StringBuffer("");
        try
        {            
            sResultat.append("<TABLE  ALIGN=center cellspacing='0' cellpadding='0' border='0' width='600px'>");
            sResultat.append("<TR>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" NIA");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" NIE");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='300px' > ");
            sResultat.append(" Nom        ");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='20px' > ");
            sResultat.append(" Primer Codnom       ");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='20px' > ");
            sResultat.append(" Segon Cognom");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Tipus Identificador:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Identificador:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Document:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Sexe:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Data Naixament:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Estudis:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Nacionalitat:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Provincia Naixement:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Municipi Naixement:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Provincia Procedencia o Desti:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Municipi Procedencia o Desti:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Consulat:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Data de Modificaci:");
            sResultat.append(" </TD>");
            sResultat.append(" </TR>");
            
            rSelect = historialDDSHabitant();
            
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {
              rellenar(rSelect);  
              
              // Posem els if per si algun camp esta buit que no sorti el -1, i a tambe perque no dongui problemas a
              // l'hora de mostra la taula que si no hi ha res no surt el recuadre.
              
              sResultat.append("<TR>");
                sResultat.append("<TD class='form3'> ");
                 if (NIA.compareTo("") != 0) {sResultat.append(NIA);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (NIE != -1) {sResultat.append(NIE);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (NOMB.compareTo("") != 0) {sResultat.append(NOMB);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (APE1.compareTo("") != 0) {sResultat.append(PART1 +" "+ APE1 );}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (APE2.compareTo("") != 0) {sResultat.append( PART2 +" "+ APE2);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (TIPIDEN.NMB_TIDEN.compareTo("") != 0) {sResultat.append(TIPIDEN.NMB_TIDEN);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 sResultat.append(IDEN +"-"+ LIDEN);
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 sResultat.append(NDOCU +"-"+ LEXTR);
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if  (SEXO == 1){sResultat.append("Home");}
                 else {sResultat.append("Dona");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 sResultat.append(FNAC);
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (ESTUDIOS.NMB_CNES.compareTo("") != 0) {sResultat.append(ESTUDIOS.NMB_CNES);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (NACIONALIDAD.NMB_NACI.compareTo("") != 0) {sResultat.append(NACIONALIDAD.NMB_NACI);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (PROVNACIMIENTO.NMB_PROV.compareTo("") != 0) {sResultat.append(PROVNACIMIENTO.NMB_PROV);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (MUNNACIMIENTO.NMB_MUNC.compareTo("") != 0) {sResultat.append(MUNNACIMIENTO.NMB_MUNC);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (PROVPROCEDENCIA.NMB_PROV.compareTo("") != 0) {sResultat.append(PROVPROCEDENCIA.NMB_PROV);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (MUNPROCEDENCIA.NMB_MUNC.compareTo("") != 0) {sResultat.append(MUNPROCEDENCIA.NMB_MUNC);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (CONSULADO.NMB_CODP.compareTo("") != 0) {sResultat.append(CONSULADO.NMB_CODP);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 sResultat.append(FVAR);
                 sResultat.append(" </TD>");
              sResultat.append(" </TR>");
            }
            
            sResultat.append("</TABLE>");
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Ens dona el Html per poder mostrar l'historial del habitatge per una web.
     public String MostrarhistorialDDSHabitantHabitatge()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRHabitatge oHbtg;
        
        sResultat = new StringBuffer("");
        oHbtg     = new PDRHabitatge(con, CDG_USR);
        
        try
        {            
            sResultat.append("<TABLE  ALIGN=center cellspacing='0' cellpadding='0' border='0' width='1110px'>");
            sResultat.append("<TR>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" NIA:" + NIA);
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" NIE:" + NIE);
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='20px' > ");
            sResultat.append(" Nom:" + NOMB);
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='20px' > ");
            sResultat.append(" Primer Codnom:" + PART1 +" "+ APE1);
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='20px' > ");
            sResultat.append(" Segon Cognom:" +  PART2 +" "+ APE2);
            sResultat.append(" </TD>");
            sResultat.append("<TABLE  ALIGN=center cellspacing='0' cellpadding='0' border='0' width='1110px'>");
            sResultat.append(" </TR>");
            sResultat.append("<TR>");
            sResultat.append("<TD class='form1' width='20px'> ");
            sResultat.append(" Tram:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='20px'> ");
            sResultat.append(" Pseudovia:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Nmero:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Calificador de Nmero:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Nmero Superior:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Calificador de Nmero Superior:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Kilmetre:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Hectmetre:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Bloc:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Portal:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Escala:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Planta:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Porta:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Tipus Local:");
            sResultat.append(" </TD>");
            sResultat.append("<TD class='form1' width='10px'> ");
            sResultat.append(" Data de Modificaci:");
            sResultat.append(" </TD>");
            sResultat.append(" </TR>");
            
            rSelect = historialDDSHabitantHabitatge();
            
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {
              oHbtg.rellenar(rSelect);  
              // Omplim la data de variacio
              oHbtg.rellenarFVAR(rSelect);
              
              // Posem els if per si algun camp esta buit que no sorti el -1, i a tambe perque no dongui problemas a
              // l'hora de mostra la taula que si no hi ha res no surt el recuadre.
              if (oHbtg.CDG_CHBTG == -1)
              {
                sResultat.append("<TABLE  ALIGN=center cellspacing='0' cellpadding='0' border='0' width='1110px'>");   
                 sResultat.append("<TR>");
                   sResultat.append("<TD class='form3'> ");
                     sResultat.append(" No te Habitatge.");
                   sResultat.append(" </TD>");
                   sResultat.append("<TD class='form3'> ");
                     sResultat.append(oHbtg.getFVAR());
                   sResultat.append(" </TD>");
                 sResultat.append(" </TR>");
                sResultat.append("</TABLE>"); 
              }
              else
              {
               sResultat.append("<TR>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.TRAM.CDG_CTRM != -1){sResultat.append(oHbtg.TRAM.CDG_CTRM);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.PSEUDOVIA.DPSVIA.compareTo("") != 0) {sResultat.append(oHbtg.PSEUDOVIA.DPSVIA);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.NUMER != -1) {sResultat.append(oHbtg.NUMER);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.CNUMER.compareTo("") != 0) {sResultat.append(oHbtg.CNUMER);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.NUMERS != -1) {sResultat.append(oHbtg.NUMERS);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.CNUMERS.compareTo("") != 0) {sResultat.append(oHbtg.CNUMERS);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.KMT != -1) {sResultat.append(oHbtg.KMT);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.HMT != -1) {sResultat.append(oHbtg.HMT);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.BLOQ.compareTo("") != 0) {sResultat.append(oHbtg.BLOQ);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.PORT.compareTo("") != 0) {sResultat.append(oHbtg.PORT);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.ESCA.compareTo("") != 0) {sResultat.append(oHbtg.ESCA);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.PLAN.compareTo("") != 0) {sResultat.append(oHbtg.PLAN);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.PUER.compareTo("") != 0) {sResultat.append(oHbtg.PUER);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 if (oHbtg.TLOC.compareTo("") != 0) {sResultat.append(oHbtg.TLOC);}
                 else {sResultat.append("...");}
                 sResultat.append(" </TD>");
                sResultat.append("<TD class='form3'> ");
                 sResultat.append(oHbtg.getFVAR());
                 sResultat.append(" </TD>");
               sResultat.append(" </TR>");
              }
            }
            
            sResultat.append("</TABLE>");
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Comprova si el Habitant es correcta per inserir-lo.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      CDG_CHBT   = -1;
      
      // El nombre ens indica el problema. 
      if (NIA.compareTo("") == 0)// Problema 86
      {
          sResultado = sResultado + "e86: Falta posar el nmero de Identificaci del Ajuntament. <br /> " ;
      }
      if (existeNIA())//132
      {
          sResultado = sResultado + "e132: El Habitant existeix. <br /> " ;
      }
      if (NIE == -1)// Problema 87
      {
          sResultado = sResultado + "e87: Falta posar el nmero de Identificaci Electoral. <br /> " ;
      }
      if (NOMB.compareTo("") == 0)// Problema 88
      {
          sResultado = sResultado + "e88: Falta posar el nom. <br /> " ;
      }
      /*
      if (PART1.compareTo("") == 0)// Problema 89
      {
          sResultado = sResultado + "e89: Falta posar la Partcula del Primer Cognom. <br /> " ;
      }*/
      if (APE1.compareTo("") == 0)// Problema 90
      {
          sResultado = sResultado + "e90: Falta posar el Primer Cognom. <br /> " ;
      }
      /*
      if (PART2.compareTo("") == 0)// Problema 91
      {
          sResultado = sResultado + "e91: Falta posar la Partcula del Segon Cognom. <br /> " ;
      }*/
      if (APE2.compareTo("") == 0)// Problema 92
      {
          sResultado = sResultado + "e92: Falta posar el Segon Cognom. <br /> " ;
      }
      if (FNAC.compareTo("") == 0)// Problema 93
      {
          sResultado = sResultado + "e93: Falta posar la Data de Naixement. <br /> " ;
      }
      if (CAUV.compareTo("") == 0)// Problema 128
      {
          sResultado = sResultado + "e128: Falta posar la Causa de la Variaci. <br /> " ;
      } 
      /*
       if (LEXTR.compareTo("") == 0)// Problema 94
      {
          sResultado = sResultado + "e94: Falta posar la lletra del Document Estranger.  <br /> " ;
      }
      if (IDEN == -1)// Problema 95
      {
          sResultado = sResultado + "e95: Falta posar el Identificador. <br /> " ;
      }
      if (LIDEN.compareTo("") == 0)// Problema 96
      {
          sResultado = sResultado + "e96: Falta posar el codi de Control del Identificador. <br /> " ;
      }
      if (NDOCU.compareTo("") == 0)// Problema 97
      {
          sResultado = sResultado + "e97: Falta posar el nmero de Document. <br /> " ;
      }*/   
      if (SEXO == -1)// Problema 87
      {
          sResultado = sResultado + "e98: Falta posar el tipus de Sexe. <br /> " ;
      }
      if (SEXO != 1 && SEXO != 6)// Problema 87
      {
          sResultado = sResultado + "e77: El Tipus de Sexe no existeix. <br /> " ;
      }
      if (!(
              (   
                (IDEN != -1 && LIDEN.compareTo("") != 0)    ||   
                (LEXTR.compareTo("") != 0 && NDOCU.compareTo("") != 0) 
              ) &&
              !(
                (IDEN != -1 && LIDEN.compareTo("") != 0 && LEXTR.compareTo("") != 0) ||
                (IDEN != -1 && LIDEN.compareTo("") != 0 && NDOCU.compareTo("") != 0) ||
                (LEXTR.compareTo("") != 0 && NDOCU.compareTo("") != 0 && IDEN != -1) ||
                (LEXTR.compareTo("") != 0 && NDOCU.compareTo("") != 0 && LIDEN.compareTo("") != 0)
                
              )
           )
         )
      {
          sResultado = sResultado + "e142: Els codis del tipus de identificador no son correctes. <br /> " ;
      }
      
      // Comprova si las dades se adecuan a las de la base de dades.
      
      if (TIPIDEN.NMB_TIDEN.compareTo("") != 0)// Problema 79
      {
          if (! TIPIDEN.existeTipusIden())
          {
            sResultado = sResultado + "e79: El tipus de Identificador no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e99: Falta posar el Tipus de Identificador. <br /> " ;
      }
      if (ESTUDIOS.NMB_CNES.compareTo("") != 0)// Problema 77
      {
          if (! ESTUDIOS.existeEstudis())
          {
            sResultado = sResultado + "e81: El Estudi no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e100: Falta posar el Estudi. <br /> " ;
      }
      if (NACIONALIDAD.NMB_NACI.compareTo("") != 0)// Problema 83
      {
          if (! NACIONALIDAD.existeNacionalitat())
          {
            sResultado = sResultado + "e83: La Nacionalitat no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e101: Falta posar la Nacionalitat. <br /> " ;
      }
      if (PROVPROCEDENCIA.NMB_PROV.compareTo("") != 0)// Problema 4
      {
          if (! PROVPROCEDENCIA.existeProv())
          {
            sResultado = sResultado + "e107: La Provncia de Dest o Procedncia no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e102: Falta posar la Provncia de Dest o Procedncia. <br /> " ;
      }
      if (MUNPROCEDENCIA.NMB_MUNC.compareTo("") != 0)// Problema 17
      {
          if (! MUNPROCEDENCIA.existeMunc())
          {
            sResultado = sResultado + "e108: El Municipi de Dest o Procedncia no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e103: Falto posar el Municipi de Dest o Procedncia. <br /> " ;
      }
      if (PROVNACIMIENTO.NMB_PROV.compareTo("") != 0)// Problema 4
      {
          if (! PROVNACIMIENTO.existeProv())
          {
            sResultado = sResultado + "e109: La Provncia de Naixement no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e104: Falta posar la Provncia de Naixement. <br /> " ;
      }
      if (MUNNACIMIENTO.NMB_MUNC.compareTo("") != 0)// Problema 17
      {
          if (! MUNNACIMIENTO.existeMunc())
          {
            sResultado = sResultado + "e110: El Municipi de Naixement no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e105: Falta posar el Municipi de Naixement. <br /> " ;
      }
      if (CONSULADO.NMB_CODP.compareTo("") != 0)// Problema 85
      {
          if (! CONSULADO.existeConsulat())
          {
            sResultado = sResultado + "e85: El Consulat no existeix. <br /> " ;
          }
      }  
      else
      {
        //sResultado = sResultado + "e106: Falta posar el Consulat. <br /> " ;
      }    
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si el Habitant es pot updateixar
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
              
      // El nombre ens indica el problema. 
      if (DDSHBT_CHBT == -1 && CDG_CHBT == -1)// Problema 16
      {
          sResultado = sResultado + "e16: El update requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      if (NIA.compareTo("") == 0)// Problema 86
      {
          sResultado = sResultado + "e86: Falta posar el nmero de Identificaci del Ajuntament. <br /> " ;
      }
      if (existeNIA())//132
      {
          sResultado = sResultado + "e132: El Habitant existeix. <br /> " ;
      }
      if (NIE == -1)// Problema 87
      {
          sResultado = sResultado + "e87: Falta posar el nmero de Identificaci Electoral. <br /> " ;
      }
      if (NOMB.compareTo("") == 0)// Problema 88
      {
          sResultado = sResultado + "e88: Falta posar el nom. <br /> " ;
      }
      /*
      if (PART1.compareTo("") == 0)// Problema 89
      {
          sResultado = sResultado + "e89: Falta posar la Partcula del Primer Cognom.  <br /> " ;
      }*/
      if (APE1.compareTo("") == 0)// Problema 90
      {
          sResultado = sResultado + "e90: Falta posar el Primer Cognom. <br /> " ;
      }/*
      if (PART2.compareTo("") == 0)// Problema 91
      {
          sResultado = sResultado + "e91: Falta posar la Partcula del Segon Cognom. <br /> " ;
      }*/
      if (APE2.compareTo("") == 0)// Problema 92
      {
          sResultado = sResultado + "e92: Falta posar el Segon Cognom. <br /> " ;
      }
      if (FNAC.compareTo("") == 0)// Problema 93
      {
          sResultado = sResultado + "e93: Falta posar la Data de Naixement. <br /> " ;
      }
      if (CAUV.compareTo("") == 0)// Problema 128
      {
          sResultado = sResultado + "e128: Falta posar la Causa de la Variaci. <br /> " ;
      } 
      /*
       if (LEXTR.compareTo("") == 0)// Problema 94
      {
          sResultado = sResultado + "e94: Falta posar la lletra del Document Estranger.  <br /> " ;
      }
      if (IDEN == -1)// Problema 95
      {
          sResultado = sResultado + "e95: Falta posar el Identificador. <br /> " ;
      }
      if (LIDEN.compareTo("") == 0)// Problema 96
      {
          sResultado = sResultado + "e96: Falta posar el codi de Control del Identificador. <br /> " ;
      }
      if (NDOCU.compareTo("") == 0)// Problema 97
      {
          sResultado = sResultado + "e97: Falta posar el nmero de Document. <br /> " ;
      }   
      */
      if (SEXO == -1)// Problema 98
      {
          sResultado = sResultado + "e98: Falta posar el tipus de Sexe. <br /> " ;
      }
      if (SEXO != 1 && SEXO != 6)// Problema 77
      {
          sResultado = sResultado + "e77: El Tipus de Sexe no existeix. <br /> " ;
      }
      
      if (!(
              (   
                (IDEN != -1 && LIDEN.compareTo("") != 0)    ||   
                (LEXTR.compareTo("") != 0 && NDOCU.compareTo("") != 0) 
              ) &&
              !(
                (IDEN != -1 && LIDEN.compareTo("") != 0 && LEXTR.compareTo("") != 0) ||
                (IDEN != -1 && LIDEN.compareTo("") != 0 && NDOCU.compareTo("") != 0) ||
                (LEXTR.compareTo("") != 0 && NDOCU.compareTo("") != 0 && IDEN != -1) ||
                (LEXTR.compareTo("") != 0 && NDOCU.compareTo("") != 0 && LIDEN.compareTo("") != 0)
                
              )
           )
         )
      {
          sResultado = sResultado + "e142: Els codis del tipus de identificador no son correctes. <br /> " ;
      }
      
      // Comprova si las dades se adecuan a las de la base de dades.
      if (TIPIDEN.NMB_TIDEN.compareTo("") != 0)// Problema 79
      {
          if (! TIPIDEN.existeTipusIden())
          {
            sResultado = sResultado + "e79: El tipus de Identificador no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e99: Falta posar el Tipus de Identificador. <br /> " ;
      }
      if (ESTUDIOS.NMB_CNES.compareTo("") != 0)// Problema 77
      {
          if (! ESTUDIOS.existeEstudis())
          {
            sResultado = sResultado + "e81: El Estudi no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e100: Falta posar el Estudi. <br /> " ;
      }
      if (NACIONALIDAD.NMB_NACI.compareTo("") != 0)// Problema 83
      {
          if (! NACIONALIDAD.existeNacionalitat())
          {
            sResultado = sResultado + "e83: La Nacionalitat no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e101: Falta posar la Nacionalitat. <br /> " ;
      }
      if (PROVPROCEDENCIA.NMB_PROV.compareTo("") != 0)// Problema 4
      {
          if (! PROVPROCEDENCIA.existeProv())
          {
            sResultado = sResultado + "e107: La Provncia de Dest o Procedncia no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e102: Falta posar la Provncia de Dest o Procedncia. <br /> " ;
      }
      if (MUNPROCEDENCIA.NMB_MUNC.compareTo("") != 0)// Problema 17
      {
          if (! MUNPROCEDENCIA.existeMunc())
          {
            sResultado = sResultado + "e108: El Municipi de Dest o Procedncia no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e103: Falta posar el Municipi de Dest o Procedncia. <br /> " ;
      }
      if (PROVNACIMIENTO.NMB_PROV.compareTo("") != 0)// Problema 4
      {
          if (! PROVNACIMIENTO.existeProv())
          {
            sResultado = sResultado + "e109: La Provncia de Naixement no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e104: Falta posar la Provncia de Naixement. <br /> " ;
      }
      if (MUNNACIMIENTO.NMB_MUNC.compareTo("") != 0)// Problema 17
      {
          if (! MUNNACIMIENTO.existeMunc())
          {
            sResultado = sResultado + "e110: El Municipi de Naixement no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e105: Falta posar el Municipi de Naixement. <br /> " ;
      }
      if (CONSULADO.NMB_CODP.compareTo("") != 0)// Problema 85
      {
          if (! CONSULADO.existeConsulat())
          {
            sResultado = sResultado + "e85: El Consulat no existeix. <br /> " ;
          }
      }  
      else
      {
        //sResultado = sResultado + "e106: Falta posar el Consulat. <br /> " ;
      } 
      if (! existeHabitant() )// Problema 111
      {
        sResultado = sResultado + "e111: El Habitant no existeix. <br /> " ;
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la provincia se puede borrar.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (CAUV.compareTo("") == 0)// Problema 128
      {
          sResultado = sResultado + "e128: Falta posar la Causa de la Variaci. <br /> " ;
      } 
      if (! existeHabitant() )// Problema 111
      {
        sResultado = sResultado + "e111: El Habitant no existeix. <br /> " ;
      }
      if (DDSHBT_CHBT == -1 && CDG_CHBT == -1)// Problema 16
      {
          sResultado = sResultado + "e138: El delete requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      } 
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprova si podem fer el select.
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hi ha comprovacions.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    } 
    
    // Comprova que el historial es pugui du a terma.
    public void comprobacionHistorial()
    {
      String sResultado;
      sResultado = "";
      
      /*if (! existeHabitant() )// Problema 111
      {
        sResultado = sResultado + "e111: El Habitant no existeix. <br /> " ;
      }*/
      if (FFIN.compareTo("") == 0)// Problema 128
      {
          sResultado = sResultado + "e154: Falta posar la Data de finalitzaci. <br /> " ;
      } 
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
     
    
}
