/*
 * PDRHabitatge.java
 *
 * Created on 31 de marzo de 2006, 10:28
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Panadero
 */
public class PDRHabitatge {
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    public  ResultSet    rSelectPublic;     // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int          CDG_PRV;           // Nmero de identificacin de la provincia.        (Posat per nosaltres)
    public  int          CDG_MNC;           // Nmero que identifica la provincia.              (Posat per nosaltres)
    public  int          CDG_CHBTG;         // Cdi del Tram.                                   (Posat per nosaltres)
    public  int          CDG_CHBT;          // Cdi del Habitant.                               (Posat per nosaltres)
    public  String       NHOP;              // Numero de Full Padronal.                         (Posat per l'usuari)
    public  int          NUMER;             // Nmero.                                          (Posat per l'usuari)
    public  String       CNUMER;            // Calificador de NUMER.                            (Posat per l'usuari)
    public  int          NUMERS;            // Nmero Superior.                                 (Posat per l'usuari)
    public  String       CNUMERS;           // Calificador de NUMERS Superior.                  (Posat per l'usuari)
    public  int          KMT;               // Kilometre.                                       (Posat per l'usuari)
    public  int          HMT;               // Hectometre.                                      (Posat per l'usuari)
    public  String       BLOQ;              // Bloque.                                          (Posat per l'usuari)
    public  String       PORT;              // Portal.                                          (Posat per l'usuari)
    public  String       ESCA;              // Escala.                                          (Posat per l'usuari)
    public  String       PLAN;              // Planta.                                          (Posat per l'usuari)
    public  String       PUER;              // Porta.                                           (Posat per l'usuari)
    public  String       TLOC;              // Tipus de Local.                                  (Posat per l'usuari)
    private String       FVAR;              // Data del cambi.                                  (Posat per nosaltres)
    public  String       CVAR;              // Codi de Variacio                                 (Posat per nosaltres)
    public  String       CAUV;              // Motiu de variaci de les dades.                  (Posat per l'usuari)
    private String       Envio;             // Ens indica si esta enviat al Ine.                (Posat per nosaltres)
    
    // Contenedores de otras clases.
    public  PDRTram      TRAM;              // Objecta Tram.                                    (Posat per l'usuari)
    public  PDRPseudovia PSEUDOVIA;         // Objecta Pseudovia                                (Posat per l'usuari)
    
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    // Dades del Usuari
    public  int        CDG_USR;         // Nmero que identifica al usuari que esta realitzan les accion (Posat per nosaltres)
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    // Creates a new instance of PDRHabitatge 
    public PDRHabitatge(int USR)  
    {
        // Relacionada con la base de datos
        con           = null;               
        rSelectPublic = null;  
        // De la base de datos
        CDG_PRV   = -1;           
        CDG_MNC   = -1;     
        CDG_CHBTG = -1; 
        CDG_CHBT  = -1; 
        NHOP      = "";       
        NUMER     = -1;          
        CNUMER    = "";       
        NUMERS    = -1;     
        CNUMERS   = "";         
        KMT       = -1;      
        HMT       = -1;        
        BLOQ      = "";   
        PORT      = "";             
        ESCA      = "";            
        PLAN      = "";              
        PUER      = "";             
        TLOC      = "";             
        FVAR      = "";            
        CVAR      = ""; 
        CAUV      = "";          
        Envio     = "";            
    
        // Contenedores de otras clases.
        TRAM      = new PDRTram(USR);            
        PSEUDOVIA = new PDRPseudovia(USR);       
    
        // Relacionada con Errores
        sError   = "";         
        // Dades del Usuari
        CDG_USR  = USR;    
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
    }
    
    // Creates a new instance of PDRHabitatge 
    public PDRHabitatge(BDConnexio conexion, int USR) 
    {
        // Relacionada con la base de datos
        con           = conexion;               
        rSelectPublic = null;  
        // De la base de datos
        CDG_PRV   = -1;           
        CDG_MNC   = -1;     
        CDG_CHBTG = -1;  
        CDG_CHBT  = -1; 
        NHOP      = "";        
        NUMER     = -1;          
        CNUMER    = "";       
        NUMERS    = -1;     
        CNUMERS   = "";         
        KMT       = -1;      
        HMT       = -1;        
        BLOQ      = "";   
        PORT      = "";             
        ESCA      = "";            
        PLAN      = "";              
        PUER      = "";             
        TLOC      = "";             
        FVAR      = "";            
        CVAR      = ""; 
        CAUV      = "";            
        Envio     = "";            
     
        // Contenedores de otras clases.
        TRAM      = new PDRTram(conexion, USR);            
        PSEUDOVIA = new PDRPseudovia(conexion, USR);       
    
        // Relacionada con Errores
        sError   = "";         
        // Dades del Usuari
        CDG_USR  = USR;    
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
    }
     
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    public void reiniciar()
    {            
        // Relacionada con la base de datos               
        rSelectPublic = null;  
        // De la base de datos     
        CDG_CHBTG = -1;  
        CDG_CHBT  = -1;
        NHOP      = "";          
        NUMER     = -1;          
        CNUMER    = "";       
        NUMERS    = -1;     
        CNUMERS   = "";         
        KMT       = -1;      
        HMT       = -1;        
        BLOQ      = "";   
        PORT      = "";             
        ESCA      = "";            
        PLAN      = "";              
        PUER      = "";             
        TLOC      = "";             
        FVAR      = "";            
        CVAR      = ""; 
        CAUV      = "";            
        Envio     = "";            
     
        // Contenedores de otras clases.
        TRAM      = new PDRTram(con, CDG_USR);            
        PSEUDOVIA = new PDRPseudovia(con, CDG_USR);       
    
        // Relacionada con Errores
        sError   = "";   
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {   
      try
      {
        // Dades de PDR_DDSTRM
        CDG_PRV   = Integer.parseInt(rSelect.getString("CDG_PRV")); 
        CDG_MNC   = Integer.parseInt(rSelect.getString("CDG_MNC"));
        CDG_CHBTG = Integer.parseInt(rSelect.getString("CDG_CHBTG"));
        NHOP      = rSelect.getString ("NHOP");       ;
        NUMER     = Integer.parseInt(rSelect.getString("NUMER"));          
        CNUMER    = rSelect.getString ("CNUMER");       
        NUMERS    = Integer.parseInt(rSelect.getString("NUMERS"));     
        CNUMERS   = rSelect.getString ("CNUMERS");         
        KMT       = Integer.parseInt(rSelect.getString("KMT"));      
        HMT       = Integer.parseInt(rSelect.getString("HMT"));        
        BLOQ      = rSelect.getString ("BLOQ");   
        PORT      = rSelect.getString ("PORT");             
        ESCA      = rSelect.getString ("ESCA");            
        PLAN      = rSelect.getString ("PLAN");              
        PUER      = rSelect.getString ("PUER");             
        TLOC      = rSelect.getString ("TLOC");            
        
        // Carguem les dades del Tram.
        if (Integer.parseInt(rSelect.getString("CDG_CTRM")) != -1)
        {
            TRAM.CDG_PRV = CDG_PRV;
            TRAM.CDG_MNC = CDG_MNC;
            TRAM.darTram(Integer.parseInt(rSelect.getString("CDG_CTRM")));
            // Intoduim el posibles error en els errors d'aquest objecte.
            if (TRAM.sError.compareTo("") != 0)
            {
                sError = sError + TRAM.sError + "<br />"; 
            }
        }
        else
        {
           TRAM.reiniciar();
        }
        // Carguem les dades de la Pseudovia.
        if (Integer.parseInt(rSelect.getString("CDG_CPSVIA")) != -1)
        {
            PSEUDOVIA.CDG_PRV = CDG_PRV;
            PSEUDOVIA.CDG_MNC = CDG_MNC;
            PSEUDOVIA.darPseudovia(Integer.parseInt(rSelect.getString("CDG_CPSVIA")),"");
            // Intoduim el posibles error en els errors d'aquest objecte.
            if (PSEUDOVIA.sError.compareTo("") != 0)
            {
                sError = sError + PSEUDOVIA.sError + "<br />"; 
            }
        }
        else
        {
          PSEUDOVIA.reiniciar();
        }
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
            
    // Omple las variable de habitant amb les dades del resulset (rSelect)
    public void rellenarHabitant(ResultSet rSelect)
    {   
      try
      {   
        CDG_CHBT  = Integer.parseInt(rSelect.getString("CDG_CHBT"));               
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Omple las variable de habitant amb les dades del resulset (rSelect)
    public void rellenarFVAR(ResultSet rSelect)
    {
        String sData;
      try
      {   
        // Coloquem la data en el format DD/MM/AAAA
        sData       = rSelect.getString ("FVAR");
        FVAR        = sData.substring(8,10) +"/"+ sData.substring(5,7) +"/"+ sData.substring(0,4) ; 
        
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Tornar la data de Variacio
    public String getFVAR()
    {
      return (FVAR);
    }
    
    // Inserta los datos del Habitage en la taula de PDR_HABITATGE.
    public void insert()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador HbtgNum;
      
      HbtgNum = new PDRNumerador(con);
      try
      {
        // Possem un numero a les dades del Tram.
        HbtgNum.NMR_NOM = "NMR_HBTG";
        HbtgNum.select();
        CDG_CHBTG = HbtgNum.NMR_VLR;
            
        sbSql = null;
      
        stmt = con.cnPrincipal.createStatement();

        // Preparem la sentncia SQL per inseri en PDR_HABITATGE
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_HABITATGE ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CHBTG, CDG_CTRM, CDG_CPSVIA, NHOP, Estado, NUMER, CNUMER, NUMERS,  ");
        sbSql.append("  CNUMERS, KMT, HMT, BLOQ, PORT, ESCA, PLAN, PUER, TLOC)");
        sbSql.append(" values ");
        sbSql.append("('"+  CDG_PRV       +"', '"+ CDG_MNC              +"', '"+ CDG_CHBTG +"', '");
        sbSql.append(       TRAM.CDG_CTRM +"', '"+ PSEUDOVIA.CDG_CPSVIA +"', '"+ NHOP      +"', 'Alta', '");
        sbSql.append(       NUMER         +"', '"+ CNUMER               +"', '"+ NUMERS    +"', '");
        sbSql.append(       CNUMERS       +"', '"+ KMT                  +"', '"+ HMT       +"', '");
        sbSql.append(       BLOQ          +"', '"+ PORT                 +"', '"+ ESCA      +"', '");
        sbSql.append(       PLAN          +"', '"+ PUER                 +"', '"+ TLOC      +"')");

        stmt.executeUpdate(sbSql.toString());    
        
        stmt.close();
        con.cnPrincipal.commit();
        
    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un Insert de Habitage en la taula de PDR_HABITATGE.
    // Fa tans Inserts en la taula PDR_HBT_has_HABITATGE enllaant Habitant-Habitatge com habitants hi han en la casa.
    // Es pot updateixa tot menys Provincia i Municipi.
    public void update()
    {
      // Conexio
      Statement    stmt; 
      StringBuffer sbSql;
      int          CDG_CHBTGaux;
      PDRNumerador HbtgNum;
      ResultSet    rSelect;
      
      
      // Date
      Data dFecha;
      
      HbtgNum = new PDRNumerador(con);
      try{       
          
        // Possem un numero a les dades del Tram.
        HbtgNum.NMR_NOM = "NMR_HBTG";
        HbtgNum.select();
        CDG_CHBTGaux = HbtgNum.NMR_VLR;
      
        sbSql = null;
      
        stmt = con.cnPrincipal.createStatement();
       
        // Preparem la sentncia SQL per inseri en PDR_HABITATGE
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_HABITATGE ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CHBTG, CDG_CTRM, CDG_CPSVIA, NHOP, Estado, NUMER, CNUMER, NUMERS,  ");
        sbSql.append("  CNUMERS, KMT, HMT, BLOQ, PORT, ESCA, PLAN, PUER, TLOC)");
        sbSql.append(" values ");
        sbSql.append("('"+  CDG_PRV       +"', '"+ CDG_MNC              +"', '"+ CDG_CHBTGaux +"', '");
        sbSql.append(       TRAM.CDG_CTRM +"', '"+ PSEUDOVIA.CDG_CPSVIA +"', '"+ NHOP         +"','Alta', ' ");
        sbSql.append(       NUMER         +"', '"+ CNUMER               +"', '"+ NUMERS    +"', '");
        sbSql.append(       CNUMERS       +"', '"+ KMT                  +"', '"+ HMT       +"', '");
        sbSql.append(       BLOQ          +"', '"+ PORT                 +"', '"+ ESCA      +"', '");
        sbSql.append(       PLAN          +"', '"+ PUER                 +"', '"+ TLOC      +"')");
        
        stmt.executeUpdate(sbSql.toString());
        
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha(); 
        
        if (teHabitantHistoric())
        {
            // obtenim els habitants que viuen a aquesta casa
            rSelect = habitantsdelHabitatge();
            // fem tants inserts en PDR_habitant_has_HABITATGE com habitatns hi han.
            while (rSelect.next())
            {
                rellenarHabitant(rSelect);

                // Preparem la sentncia SQL per inseri en PDR_habitant_has_HABITATGE
                sbSql = new StringBuffer("");
                sbSql.append("Insert into  ");
                sbSql.append( " PDR_Habitant_has_habitatge ");
                sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CHBT, CDG_CHBTG, CDG_USR, FVAR, CVAR, CAUV, Envio) ");
                sbSql.append(" values ");
                sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ CDG_CHBT+"', '");
                sbSql.append(      CDG_CHBTGaux +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'M', '"+ CAUV +"', 'N')");

                stmt.executeUpdate(sbSql.toString());
            }
            // Preparem la sentncia SQL per updateixa el habitatge en PDR_HABITATGE
            // Per donarlo de baixa.
                sbSql = new StringBuffer("");
                sbSql.append("UPDATE ");
                sbSql.append(" PDR_HABITATGE ");
                sbSql.append(" SET ");
                sbSql.append("  Estado = 'Baja'");
                sbSql.append(" WHERE ");
                sbSql.append("  CDG_CHBTG = '"+ CDG_CHBTG +"'");
                
                stmt.executeUpdate(sbSql.toString());
        }
        else
        {
                // Preparem la sentncia SQL per inseri en PDR_HBT_has_HABITATGE
                sbSql = new StringBuffer("");
                sbSql.append("DELETE FROM  ");
                sbSql.append(" PDR_HABITATGE ");
                sbSql.append(" Where ");
                sbSql.append(" CDG_CHBTG = '"+ CDG_CHBTG +"'");
                
                stmt.executeUpdate(sbSql.toString());
        }
        
        CDG_CHBTG = CDG_CHBTGaux;
        
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un Insert en la taula PDR_HBT_has_HABITATGE enllaant HABITANT-HABITATGE, inserim en motiu envia a Ine Baixa.
    public void delete()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet    rSelect;
      
      // Date
      Data dFecha;
      
      sbSql = null;
      try{
        stmt = con.cnPrincipal.createStatement();
       
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha();
        
        
        if (teHabitantHistoric())
        {
            // obtenim els habitants que viuen a aquesta casa
            rSelect =  habitantsdelHabitatge();
            // fem tants inserts en PDR_habitant_has_HABITATGE com habitatns hi han.
            while (rSelect.next())
            {
                rellenarHabitant(rSelect);
                // Preparem la sentncia SQL per inseri en PDR_HBT_has_HABITATGE
                sbSql = new StringBuffer("");
                sbSql.append("Insert into  ");
                sbSql.append(" PDR_Habitant_has_habitatge ");
                sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CHBT, CDG_CHBTG, CDG_USR, FVAR, CVAR, CAUV, Envio) ");
                sbSql.append(" values ");
                sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ CDG_CHBT+"', ");
                sbSql.append(   " '-1', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'B','" + CAUV + "', 'N')");

                stmt.executeUpdate(sbSql.toString());
            }
            // Preparem la sentncia SQL per updateixa el habitatge en PDR_HABITATGE
                sbSql = new StringBuffer("");
                sbSql.append("UPDATE ");
                sbSql.append(" PDR_HABITATGE ");
                sbSql.append(" SET ");
                sbSql.append("  Estado = 'Baja'");
                sbSql.append(" WHERE ");
                sbSql.append("  CDG_CHBTG = '"+ CDG_CHBTG +"'");
                
                stmt.executeUpdate(sbSql.toString());
        }
        else
        {
                // Preparem la sentncia SQL per inseri en PDR_HBT_has_HABITATGE
                sbSql = new StringBuffer("");
                sbSql.append("DELETE FROM  ");
                sbSql.append(" PDR_HABITATGE ");
                sbSql.append(" Where ");
                sbSql.append(" CDG_CHBTG = '"+ CDG_CHBTG +"'");
                
                stmt.executeUpdate(sbSql.toString());
        }

        
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'un Habitatge que no estigui de baixa.
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{
        // Cerramos el select anterior
        if (rSelectPublic != null){rSelectPublic.close();}  
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HABITATGE HBTG");
        sbSql.append(" where ");
        sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( HBTG.CDG_CTRM ='"+ TRAM.CDG_CTRM +"' or ");
        sbSql.append(   "'"+TRAM.CDG_CTRM +"'  = -1) and");
        sbSql.append("  ( HBTG.CDG_CPSVIA ='"+ PSEUDOVIA.CDG_CPSVIA +"' or ");
        sbSql.append(   "'"+PSEUDOVIA.CDG_CPSVIA +"'  = -1) and");
        sbSql.append("  ( HBTG.CDG_CHBTG ='"+ CDG_CHBTG +"' or ");
        sbSql.append(   "'"+CDG_CHBTG           +"'  = -1) and");
        sbSql.append("  ( HBTG.NHOP ='"+ NHOP +"' or ");
        sbSql.append(   "'"+NHOP           +"'  = '' ) and");
        sbSql.append("  ( HBTG.NUMER ='"+ NUMER +"' or ");
        sbSql.append(   "'"+NUMER           +"'  = -1) and");
        sbSql.append("  ( HBTG.CNUMER ='"+ CNUMER +"' or ");
        sbSql.append(   "'"+CNUMER           +"'  = '' ) and");
        sbSql.append("  ( HBTG.NUMERS ='"+ NUMERS +"' or ");
        sbSql.append(   "'"+NUMERS           +"'  = -1) and");
        sbSql.append("  ( HBTG.CNUMERS ='"+ CNUMERS +"' or ");
        sbSql.append(   "'"+CNUMERS           +"'  = '' ) and");
        sbSql.append("  ( HBTG.KMT ='"+ KMT +"' or ");
        sbSql.append(   "'"+KMT           +"'  = -1) and");
        sbSql.append("  ( HBTG.HMT ='"+ HMT +"' or ");
        sbSql.append(   "'"+HMT           +"'  = -1) and");
        sbSql.append("  ( HBTG.BLOQ ='"+ BLOQ +"' or ");
        sbSql.append(   "'"+BLOQ           +"'  = '' ) and");
        sbSql.append("  ( HBTG.PORT ='"+ PORT +"' or ");
        sbSql.append(   "'"+PORT           +"'  = '' ) and");
        sbSql.append("  ( HBTG.ESCA ='"+ ESCA +"' or ");
        sbSql.append(   "'"+ESCA           +"'  = '' ) and");
        sbSql.append("  ( HBTG.PLAN ='"+ PLAN +"' or ");
        sbSql.append(   "'"+PLAN           +"'  = '' ) and");
        sbSql.append("  ( HBTG.PUER ='"+ PUER +"' or ");
        sbSql.append(   "'"+PUER           +"'  = '' ) and");
        sbSql.append("  ( HBTG.TLOC ='"+ TLOC +"' or ");
        sbSql.append(   "'"+TLOC           +"'  = '' ) and");
        sbSql.append("  HBTG.Estado <> 'Baja' ");
        sbSql.append("  order by HBTG.CDG_CHBTG ");

        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
           rSelectPublic = rSelect;
           
           // Desbloqueamos o bloqueamos los botones que haga falta.
           if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
           if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
        }
        else
        {
           sError = sError + "e75: No existeixen Habitatges amb aquestes  caracterstiques." +"<br />";
           rSelectPublic = null;
           // Desactivamos los botones de siguiente y anteriror.
           sSiguiente    = "disabled";
           sAnterior     = "disabled";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select del habitants que hi han en un habitatge.
    public ResultSet habitantsdelHabitatge()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_habitant_has_habitatge HHH, PDR_HABITATGE HBTG");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   HBTG.CDG_PRV  = HHH.CDG_PRV     and ");
        sbSql.append("   HBTG.CDG_MNC  = HHH.CDG_MNC     and ");
        sbSql.append("   HBTG.CDG_CHBTG = HHH.CDG_CHBTG     ");
        sbSql.append("  ) and ");
        sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  HBTG.CDG_CHBTG ='"+ CDG_CHBTG +"' and ");
        sbSql.append("  HHH.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_habitant_has_habitatge HHH2, PDR_HABITATGE HBTG2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      HBTG2.CDG_PRV   = HHH2.CDG_PRV     and ");
        sbSql.append("      HBTG2.CDG_MNC   = HHH2.CDG_MNC     and ");
        sbSql.append("      HBTG2.CDG_CHBTG = HHH2.CDG_CHBTG ");
        sbSql.append("    ) and "); 
        sbSql.append("    HHH.CDG_CHBT  = HHH2.CDG_CHBT  and");
        sbSql.append("    (");
        sbSql.append("    HHH.FVAR < HHH2.FVAR ");
        sbSql.append("    )");
        sbSql.append("  ) ");
        sbSql.append("  order by HBTG.CDG_CHBTG ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Selecciona el habitants que hi han en un habitatge i ens dona el numero.
    public int numeroHabitants()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      int iResultat;
      
      rSelect   = null;
      sbSql     = null;
      iResultat = 0;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select count(HHH.CDG_CHBT) From ");
        sbSql.append(" PDR_habitant_has_habitatge HHH, PDR_HABITATGE HBTG");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   HBTG.CDG_PRV  = HHH.CDG_PRV     and ");
        sbSql.append("   HBTG.CDG_MNC  = HHH.CDG_MNC     and ");
        sbSql.append("   HBTG.CDG_CHBTG = HHH.CDG_CHBTG     ");
        sbSql.append("  ) and ");
        sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  HBTG.CDG_CHBTG ='"+ CDG_CHBTG +"' and ");
        sbSql.append("  HHH.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_habitant_has_habitatge HHH2, PDR_HABITATGE HBTG2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      HBTG2.CDG_PRV   = HHH2.CDG_PRV     and ");
        sbSql.append("      HBTG2.CDG_MNC   = HHH2.CDG_MNC     and ");
        sbSql.append("      HBTG2.CDG_CHBTG = HHH2.CDG_CHBTG ");
        sbSql.append("    ) and "); 
        sbSql.append("    HHH.CDG_CHBT  = HHH2.CDG_CHBT  and");
        sbSql.append("    HHH.CDG_CHBTG = HHH2.CDG_CHBTG and ");
        sbSql.append("    (");
        sbSql.append("    HHH.FVAR < HHH2.FVAR ");
        sbSql.append("    )");
        sbSql.append("  ) ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
            iResultat     = Integer.parseInt(rSelect.getString("count"));
        }
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (iResultat);
    }
    
    
    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs. " + "<br />";}
    }
    
    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs. " + "<br />";}
    }
    
    // Carrega el Habitatge en el objecte que la cridat.
    // Requereix que tingui posada la provincia y el municipi de busqueda
    public void darHabitatge(int CDG_CHBTGaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HABITATGE HBTG");
        sbSql.append(" where ");
        sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  HBTG.CDG_CHBTG ='"+ CDG_CHBTGaux +"' and");
        sbSql.append("  HBTG.Estado <> 'Baja' ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
           
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e126: El Habitatge no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Recopera els Habitatges d'una Tram.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarHabitatgeDeTram(int iTram, String sData)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HABITATGE HBTG");
        sbSql.append(" where ");
        sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  HBTG.CDG_CTRM ='"+ iTram +"' and");
        sbSql.append("  HBTG.Estado <> 'Baja' ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
      
        return (rSelect);
    }
    
    // Recopera els Habitatges d'una Pseudovia.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarHabitatgeDePseudovia(int iPseudovia, String sData)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HABITATGE HBTG");
        sbSql.append(" where ");
        sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  HBTG.CDG_CPSVIA ='"+ iPseudovia +"' and");
        sbSql.append("  HBTG.Estado <> 'Baja' ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
      
        return (rSelect);
    }
    
    // Comproba si el Habitatge existeix.
    public boolean existeHabitatge()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HABITATGE HBTG");
        sbSql.append(" where ");
        sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  HBTG.CDG_CHBTG ='"+ CDG_CHBTG +"'  and ");
        sbSql.append("  HBTG.Estado <> 'Baja' ");
        
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comproba si hi ha un habitatge amb les mateixes dades. Que no siguin aquet
    public boolean existeHabitatgeSemblant()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HABITATGE HBTG");
        sbSql.append(" where ");
        sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( HBTG.CDG_CHBTG !='"+ CDG_CHBTG +"')  and ");
        
        sbSql.append("  ( ");
        sbSql.append("      ( HBTG.NHOP ='"+ NHOP +"' or ");
        sbSql.append(        "'"+NHOP           +"'  = -1) or");
        sbSql.append("      ( ");
        sbSql.append("          HBTG.NUMER ='"+ NUMER +"' and ");
        sbSql.append("          HBTG.CNUMER ='"+ CNUMER +"' and ");
        sbSql.append("          HBTG.NUMERS ='"+ NUMERS +"' and ");
        sbSql.append("          HBTG.CNUMERS ='"+ CNUMERS +"' and ");
        sbSql.append("          HBTG.KMT ='"+ KMT +"' and ");
        sbSql.append("          HBTG.HMT ='"+ HMT +"' and ");
        sbSql.append("          HBTG.BLOQ ='"+ BLOQ +"' and ");
        sbSql.append("          HBTG.PORT ='"+ PORT +"' and ");
        sbSql.append("          HBTG.ESCA ='"+ ESCA +"' and ");
        sbSql.append("          HBTG.PLAN ='"+ PLAN +"' and ");
        sbSql.append("          HBTG.PUER ='"+ PUER +"' and ");
        sbSql.append("          HBTG.TLOC ='"+ TLOC +"'  ");
        sbSql.append("      )  ");
        sbSql.append("  ) and ");
        sbSql.append("  HBTG.Estado <> 'Baja' ");
        
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    
    // Comproba si hi ha un habitatge amb les mateixes dades.
    public boolean existeHabitatgeSemblantInsert()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HABITATGE HBTG");
        sbSql.append(" where ");
        sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( ");
        sbSql.append("      ( HBTG.NHOP ='"+ NHOP +"' or ");
        sbSql.append(        "'"+NHOP           +"'  = -1) or");
        sbSql.append("      ( ");
        sbSql.append("          HBTG.NUMER ='"+ NUMER +"' and ");
        sbSql.append("          HBTG.CNUMER ='"+ CNUMER +"' and ");
        sbSql.append("          HBTG.NUMERS ='"+ NUMERS +"' and ");
        sbSql.append("          HBTG.CNUMERS ='"+ CNUMERS +"' and ");
        sbSql.append("          HBTG.KMT ='"+ KMT +"' and ");
        sbSql.append("          HBTG.HMT ='"+ HMT +"' and ");
        sbSql.append("          HBTG.BLOQ ='"+ BLOQ +"' and ");
        sbSql.append("          HBTG.PORT ='"+ PORT +"' and ");
        sbSql.append("          HBTG.ESCA ='"+ ESCA +"' and ");
        sbSql.append("          HBTG.PLAN ='"+ PLAN +"' and ");
        sbSql.append("          HBTG.PUER ='"+ PUER +"' and ");
        sbSql.append("          HBTG.TLOC ='"+ TLOC +"'  ");
        sbSql.append("      )  ");
        sbSql.append("  ) and ");
        sbSql.append("  HBTG.Estado <> 'Baja' ");
        
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprova si existeix l'Habitant.
    // Mira si l'Habitant esta donat de baixa.
    public boolean existeHabitant()
    {
        boolean bResultado;
        bResultado = false;
       
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_HBT_has_DDSHBT HHD,PDR_DDSHBT DHB");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DHB.CDG_PRV     = HHD.CDG_PRV     and ");
            sbSql.append("   DHB.CDG_MNC     = HHD.CDG_MNC     and ");
            sbSql.append("   DHB.DDSHBT_CHBT = HHD.DDSHBT_CHBT     ");
            sbSql.append("  ) and ");
            sbSql.append("  DHB.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DHB.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  DHB.CDG_CHBT ='"+ CDG_CHBT +"' and ");
            sbSql.append("  HHD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_HBT_has_DDSHBT HHD2, PDR_DDSHBT DHB2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DHB2.CDG_PRV     = HHD2.CDG_PRV     and ");
            sbSql.append("      DHB2.CDG_MNC     = HHD2.CDG_MNC     and ");
            sbSql.append("      DHB2.DDSHBT_CHBT = HHD2.DDSHBT_CHBT ");
            sbSql.append("    ) and "); 
            sbSql.append("    HHD.CDG_CHBT = HHD2.CDG_CHBT ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    HHH.DDSHBT_CHBT < HHH2.DDSHBT_CHBT or ");
            sbSql.append("    HHH2.DDSHBT_CHBT == -1 ");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Ens diu si el habitant te un habitatge.
    // Esta repetida ha habitant ho aixo crec.
    public boolean habitantTeHabitatge()
    {
        boolean bResultado;
        bResultado = false;
       
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HBT_has_HABITATGE HHH");
        sbSql.append(" where ");
        sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  HBTG.CDG_CHBT  ='"+ CDG_CHBT  +"' and ");
        sbSql.append("  HHH.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_HBT_has_HBTG HHH2, PDR_HABITATGE HBTG2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      HBTG2.CDG_PRV  = HHH2.CDG_PRV     and ");
        sbSql.append("      HBTG2.CDG_MNC  = HHH2.CDG_MNC     and ");
        sbSql.append("      HBTG2.CDG_HBTG = HHH2.CDG_CHBTG ");
        sbSql.append("    ) and "); 
        sbSql.append("    HHH.CDG_CHBT  = HHH2.CDG_CHBT  and");
        sbSql.append("    HHH.CDG_CHBTG = HHH2.CDG_CHBTG and ");
        sbSql.append("    (");
        sbSql.append("    HHH.FVAR < HHH2.FVAR ");
        sbSql.append("    )");
        sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    
    // Comprova si te asignat algn Habitant o si na tingut alguna vegada.
    // Mira si el habitatge esta en alguna relacio de PDR_HBT_has_DDSHBT.
    public boolean teHabitantHistoric()
    {
        boolean bResultado;
        bResultado = false;
       
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_Habitant_has_Habitatge HHH");
            sbSql.append(" where ");
            sbSql.append("  HHH.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  HHH.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  HHH.CDG_CHBTG ='"+ CDG_CHBTG +"' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprova si el Habitatge es correcta per inserir-la.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema.
      if (CAUV.compareTo("") == 0)// Problema 16
      {
          sResultado = sResultado + "e128: Falta posar la Causa de la Variaci. <br /> " ;
      }
      if (NHOP.compareTo("") == 0)// Problema 112
      {
          sResultado = sResultado + "e112: Falta posar el nmero del Full Padronal.  <br /> " ;
      } 
      /* Pot ser opcional pero putser en algun ayuntament volen posar lo obligatori.
      if (NUMER == -1)// Problema 113
      {
          sResultado = sResultado + "e113: Falta posar el nmero. <br /> " ;
      }
      if (CNUMER.compareTo("") == 0)// Problema 114
      {
          sResultado = sResultado + "e114: Falta posar el Calificador del Nmero. <br /> " ;
      }
      if (NUMERS == -1)// Problema 115
      {
          sResultado = sResultado + "e115: Falta posar el Nmero (Superior). <br /> " ;
      }
      if (CNUMERS.compareTo("") == 0)// Problema 116
      {
          sResultado = sResultado + "e116: Falta posar el Calificador del Nmero (Superior). <br /> " ;
      }
      if (KMT == -1)// Problema 117
      {
          sResultado = sResultado + "e117: Falta posar el Kilmetre. <br /> " ;
      }
      if (HMT == -1)// Problema 118
      {
          sResultado = sResultado + "e118: Falta posar el Hectmetre. <br /> " ;
      }
      if (BLOQ.compareTo("") == 0)// Problema 119
      {
          sResultado = sResultado + "e119: Falta posar el Bloc. <br /> " ;
      }
      if (PORT.compareTo("") == 0)// Problema 120
      {
          sResultado = sResultado + "e120: Falta posar el Portal. <br /> " ;
      }
      if (ESCA.compareTo("") == 0)// Problema 121
      {
          sResultado = sResultado + "e121: Falta posar la Escala. <br /> " ;
      }
      if (PLAN.compareTo("") == 0)// Problema 122
      {
          sResultado = sResultado + "e122: Falta posar la Planta. <br /> " ;
      }
      if (PUER.compareTo("") == 0)// Problema 123
      {
          sResultado = sResultado + "e123: Falta posar la Porta. <br /> " ;
      }
      if (TLOC.compareTo("") == 0)// Problema 124
      {
          sResultado = sResultado + "e124: Falta posar el Tipus de Local. <br /> " ;
      }*/
      // Comprova si las dades se adecuan a las de la base de dades.
      if (TRAM.CDG_CTRM != -1)// Problema 32
      {
          if (! TRAM.existeTram())
          {
            sResultado = sResultado + "e51: El Tram no existeix. <br /> " ;
          }
      }
      if (PSEUDOVIA.DPSVIA.compareTo("") != 0)// Problema 32
      {
          if (! PSEUDOVIA.existePseudovia())
          {
            sResultado = sResultado + "e32: La Pseudovia no existeix. <br /> " ;
          }
      }
      if (existeHabitatgeSemblantInsert())// Problema 133
      {
          sResultado = sResultado + "e133: El Habitatge existeix. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si el Habitatge se puede updatear
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
            
      // El nombre ens indica el problema. 
      if (CDG_CHBTG == -1)// Problema 16
      {
          sResultado = sResultado + "e16: El update requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      if (CAUV.compareTo("") == 0)// Problema 16
      {
          sResultado = sResultado + "e128: Falta posar la Causa de la Variaci. <br /> " ;
      }
      if (NHOP.compareTo("") == 0)// Problema 128
      {
          sResultado = sResultado + "e112: Falta posar el nmero del Full Padronal.  <br /> " ;
      } 
      /* Pot ser opcional pero putser en algun ayuntament volen posar lo obligatori.
      if (NUMER == -1)// Problema 113
      {
          sResultado = sResultado + "e113: Falta posar el nmero. <br /> " ;
      }
      if (CNUMER.compareTo("") == 0)// Problema 114
      {
          sResultado = sResultado + "e114: Falta posar el Calificador del Nmero. <br /> " ;
      }
      if (NUMERS == -1)// Problema 115
      {
          sResultado = sResultado + "e115: Falta posar el Nmero (Superior).<br /> " ;
      }
      if (CNUMERS.compareTo("") == 0)// Problema 116
      {
          sResultado = sResultado + "e116: Falta posar el Calificador del Nmero (Superior). " ;
      }
      if (KMT == -1)// Problema 117
      {
          sResultado = sResultado + "e117: Falta posar el Kilmetre. <br /> " ;
      }
      if (HMT == -1)// Problema 118
      {
          sResultado = sResultado + "e118: Falta posar el Hectmetre. <br /> " ;
      }
      if (BLOQ.compareTo("") == 0)// Problema 119
      {
          sResultado = sResultado + "e119: Falta posar el Bloc. <br /> " ;
      }
      if (PORT.compareTo("") == 0)// Problema 120
      {
          sResultado = sResultado + "e120: Falta posar el Portal. <br /> " ;
      }
      if (ESCA.compareTo("") == 0)// Problema 121
      {
          sResultado = sResultado + "e121: Falta posar la Escala. <br /> " ;
      }
      if (PLAN.compareTo("") == 0)// Problema 122
      {
          sResultado = sResultado + "e122: Falta posar la Planta. <br /> " ;
      }
      if (PUER.compareTo("") == 0)// Problema 123
      {
          sResultado = sResultado + "e123: Falta posar la Porta. <br /> " ;
      }
      if (TLOC.compareTo("") == 0)// Problema 124
      {
          sResultado = sResultado + "e124: Falta posar el Tipus de Local. <br /> " ;
      }*/
      // Comprova si las dades se adecuan a las de la base de dades.
      if (TRAM.CUN != -1)// Problema 32
      {
          if (! TRAM.existeTram())
          {
            sResultado = sResultado + "e51: El Tram no existeix. <br /> " ;
          }
      }
      if (PSEUDOVIA.DPSVIA.compareTo("") != 0)// Problema 32
      {
          if (! PSEUDOVIA.existePseudovia())
          {
            sResultado = sResultado + "e32: La Pseudovia no existeix. <br /> " ;
          }
      }
      if (! existeHabitatge() )// Problema 126
      {
        sResultado = sResultado + "e126: El Habitatge no existeix. <br /> " ;
      }
      if (existeHabitatgeSemblant())// Problema 133
      {
          sResultado = sResultado + "e133: El Habitatge existeix. <br /> " ;
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    // Comprueba si el habitatge es pot esborrar.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (! existeHabitatge() )// Problema 4
      {
        sResultado = sResultado + "e126: El Habitatge no existeix. <br /> " ;
      }
      if (CDG_CHBTG == -1)// Problema 16
      {
          sResultado = sResultado + "e138: El delete requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprova si podem fer el select.
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hi ha comprovacions.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }   
     
    
}
