/*
 * PDRInicio.java
 *
 * Created on 4 de julio de 2005, 12:23
 *
 */

package PDR;

import java.io.*;
import java.net.*;
import java.sql.*;
import java.util.Date;

/**
 *
 * @author Miguel A. Panadero
 */
public class PDRInicio 
{
    // Variables
    public  String NOM;
    public  String sError;
    public  int    CDG_PRV;
    public  int    CDG_USR;
    public  String NOM_PRV;
    public  int    CDG_MNC;
    public  String NMUN;
    
    /** Creates a new instance of PDRInicio */
    public PDRInicio() 
    {
      NOM      = "";
      sError   = "";
      CDG_USR  = -1;
      CDG_PRV  = -1;
      NOM_PRV  = "";
      CDG_MNC  = -1;
      NMUN     = "";
    }
    
    public void rellenar(ResultSet rSelect)
    {
      try
      {
        NOM       = rSelect.getString ("NOM");
        CDG_USR   = Integer.parseInt(rSelect.getString("CDG_USR"));
        CDG_PRV   = Integer.parseInt(rSelect.getString("CDG_PRV"));
        NOM_PRV   = rSelect.getString ("NOM_PRV");
        CDG_MNC   = Integer.parseInt(rSelect.getString("CDG_MNC"));
        NMUN      = rSelect.getString ("NMUN");
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
      }
    }
    
    public BDConnexio conectarse(String NOM_USR,String PSW_USR)
    {
      // Conexio
      BDConnexio con = null;  
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      String sResultado;
      
      sResultado = "";
      
      // Comprovo que es pugui mira si existeix l'usuari. 
      if (NOM_USR.compareTo("")==0)// Problema 5
      {
          sResultado = sResultado + "5: No se ha escrito usuario. <br /> " ;
      }
      
      if (PSW_USR.compareTo("")==0)// Problema 6
      {
        sResultado = sResultado + "6: No se ha escrito Password. <br /> " ;
      }
      
      if (sResultado.compareTo("") == 0)
      {
        sbSql = null;
        // Comprovo si existeix l'usuari.
        try{
          // Obtindre conexio
          con = new BDConnexio();
          con.AssignaConnexio("jdbc:postgresql://127.0.0.1:5432/postgres", "PDR2", "gato");
          
          con.connectaBD();

          // Possem que no es faixin commits automatics (despres de cada insert, update o delete...)
          con.cnPrincipal.setAutoCommit(false);
          
          // Cargar Dades del Usuari en la sesio.
          stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

          // Preparem la sentncia SQL
          sbSql  = new StringBuffer("");
          sbSql.append("Select * From ");
          sbSql.append(    " PDR_USUARI ");
          sbSql.append(" where ");
          sbSql.append("   NOM_USR = '"+ NOM_USR + "'  ");
          sbSql.append("   and ");
          sbSql.append("   PSW_USR = '"+ PSW_USR + "'  ");


          rSelect = stmt.executeQuery(sbSql.toString());

          if (rSelect.next())
          {
            rellenar(rSelect);
          }
          else
          {
            sResultado = sResultado + "11: No existe Usuario." +"<br />";
          }
      
        } catch (Exception e)
        {
           sError = sError + ("Fallo en la conxion a la base de datos:"+e + "<br />");
        }
      }
      // Si hi ha algun problema el poso dintre de sError y intento tanca la conexio.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
       if (con != null)
       {
        try{con.cnPrincipal.close();} 
        catch (Exception e){sError = sError + ("Fallo en la conxion a la base de datos:"+e + "<br />");}
       }
      }
      return (con);
    }
    
    public void desconectarse(BDConnexio con)
    {
      try{
      con.cnPrincipal.close();
      } catch (Exception e)
      {
        sError = sError + ("Fallo en el cierre de la conxion a la base de datos:"+e + "<br />");
      }
    }
    
    
    
}
