/*
 * PDRNacionalidad.java
 *
 * Created on 2 de abril de 2006, 15:42
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Panadero
 */

public class PDRNacionalidad
{
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    // De la base de datos
    public  int          NACI;              // Nmero de la Nacionalidad.                      (Posat per l'usuari)
    public  String       NMB_NACI;          // Nom de la Nacionalidad.                         (Posat per l'usuari)
    
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    
    // Creates a new instance of PDRNacionalidad 
    public PDRNacionalidad() 
    {
        con             = null;    
        // De la base de datos
        NACI     = -1;       
        NMB_NACI = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
    
    // Creates a new instance of PDRNacionalidad 
    public PDRNacionalidad(BDConnexio conexion) 
    {
        con             = conexion;   
        // De la base de datos
        NACI     = -1;       
        NMB_NACI = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
     
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion.
    public void reiniciar()
    {              
        // De la base de datos
        NACI     = -1;       
        NMB_NACI = "";       
             
        // Relacionada con Errores
        sError          = "";          
        
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {   
      try
      {
        // Dades de PDR_NCN
        NACI     = Integer.parseInt(rSelect.getString("NACI"));       
        NMB_NACI = rSelect.getString ("NMB_NACI");     
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Fa un select d'un Nacionalidad
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{ 
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_NCN NCN");
        sbSql.append(" where ");
        sbSql.append("  ( NCN.NACI ='"+ NACI +"' or ");
        sbSql.append(   "'"+NACI            +"'  = -1) and");
        sbSql.append("  ( NCN.NMB_NACI ='"+ NMB_NACI +"' or ");
        sbSql.append(   "'"+NMB_NACI           +"'  = '')   ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "82: No existeix Nacionalitat amb aquestes caracterstiques." +"<br />";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Carrega el Nacionalidad en el objecte que la cridat.
    public void darNacionalitat(int NACIaux, String NMB_NACIaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_NCN NCN");
        sbSql.append(" where ");
        sbSql.append("  NCN.NACI ='"+ NACIaux +"' or ");
        sbSql.append("  NCN.NMB_NACI ='"+ NMB_NACIaux +"' ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
           
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "83: La Nacionalitat no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Comproba si el Nacionalidad existeix.
    public boolean existeNacionalitat()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
             // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_NCN NCN");
            sbSql.append(" where ");
            sbSql.append("  NCN.NACI ='"+ NACI +"' or ");
            sbSql.append("  NCN.NMB_NACI ='"+ NMB_NACI +"' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset totes les Nacionalitats que no estiguin donats de baixa.
    public ResultSet TotsNacionalitats()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_NCN ");
        sbSql.append(" where ");
        sbSql.append(" NACI != -2");
        sbSql.append(" Order by ");
        sbSql.append(" NMB_NACI ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per les Nacionalitats.
    public String MostrarNacionalitat ()
    {
        StringBuffer    sResultat;
        ResultSet       rSelect; 
        PDRNacionalidad oNcn;
        int          i;
        
        sResultat = new StringBuffer("");
        oNcn  = new PDRNacionalidad(con);
        i = 0;
        
        try
        {            
            // obtenim els Totes les Nacionalitats
            rSelect = oNcn.TotsNacionalitats();
            
            sResultat.append("<SELECT NAME=\"NACIONALIDAD\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oNcn.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oNcn.NMB_NACI +"\"");
                if (NMB_NACI.compareTo(oNcn.NMB_NACI) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oNcn.NMB_NACI+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
}
