/*
 * PDRProv.java
 *
 * Created on 2 de abril de 2006, 14:30
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */


package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Panadero
 */

public class PDRProv
{
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    // De la base de datos
    public  int          PROV;              // Nmero de la Provincia.                                          (Posat per l'usuari)
    public  String       NMB_PROV;          // Nom de la Provincia.                                             (Posat per l'usuari)
    
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    
    // Creates a new instance of PDRPROV 
    public PDRProv() 
    {
        con             = null;    
        // De la base de datos
        PROV     = -1;       
        NMB_PROV = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
    
    // Creates a new instance of PDRPROV 
    public PDRProv(BDConnexio conexion) 
    {
        con             = conexion;   
        // De la base de datos
        PROV     = -1;       
        NMB_PROV = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
     
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion.
    public void reiniciar()
    {              
        // De la base de datos
        PROV     = -1;       
        NMB_PROV = "";       
             
        // Relacionada con Errores
        sError          = "";          
        
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {   
      try
      {
        // Dades de PDR_PROV
        PROV     = Integer.parseInt(rSelect.getString("PROV"));       
        NMB_PROV = rSelect.getString ("NMB_PROV");     
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Fa un select d'una Provincia
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{ 
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_PROV PRV");
        sbSql.append(" where ");
        sbSql.append("  ( PRV.PROV ='"+ PROV +"' or ");
        sbSql.append(   "'"+PROV            +"'  = -1) and");
        sbSql.append("  ( PRV.NMB_PROV ='"+ NMB_PROV +"' or ");
        sbSql.append(   "'"+NMB_PROV           +"'  = '')   ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "129: No existeix Provincia amb aquestes caracterstiques." +"<br />";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Carrega la Provincia en el objecte que la cridat.
    public void darProv(int PROVaux, String NMB_PROVaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_PROV PRV");
        sbSql.append(" where ");
        sbSql.append("  PRV.PROV ='"+ PROVaux +"' or ");
        sbSql.append("  PRV.NMB_PROV ='"+ NMB_PROVaux +"' ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "4: La Provincia no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Comproba si la Provincia existeix.
    public boolean existeProv()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
             // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_PROV PRV");
            sbSql.append(" where ");
            sbSql.append("  PRV.PROV ='"+ PROV +"' or ");
            sbSql.append("  PRV.NMB_PROV ='"+ NMB_PROV +"' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset totes les Nacionalitats que no estiguin donats de baixa.
    public ResultSet TotsProv()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_PROV ");
        sbSql.append(" where ");
        sbSql.append(" PROV != 0");
        sbSql.append(" Order by ");
        sbSql.append(" NMB_PROV ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per les Provincies per el lloc de Naixement.
    public String MostrarProvNaixement ()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRProv      oProv;
        int          i;
        
        sResultat = new StringBuffer("");
        oProv     = new PDRProv(con);
        i = 0;
        
        try
        {            
            // obtenim els Totes les Provincies
            rSelect = oProv.TotsProv();
            
            sResultat.append("<SELECT NAME=\"PROVNACIMIENTO\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oProv.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oProv.NMB_PROV +"\"");
                if (NMB_PROV.compareTo(oProv.NMB_PROV) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oProv.NMB_PROV+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Ens dona un desplegable amb totes les obcions per les Provincies per el lloc de Procedencia o desti.
    public String MostrarProvProcedencia ()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRProv      oProv;
        int          i;
        
        sResultat = new StringBuffer("");
        oProv     = new PDRProv(con);
        i = 0;
        
        try
        {            
            // obtenim els Tots els Municipis
            rSelect = oProv.TotsProv();
            
            sResultat.append("<SELECT NAME=\"PROVPROCEDENCIA\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oProv.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oProv.NMB_PROV +"\"");
                if (NMB_PROV.compareTo(oProv.NMB_PROV) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oProv.NMB_PROV+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
}
