/*
 * PDRProvincia.java
 *
 * Created on 22 de junio de 2005, 11:38
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 * @author Miguel Angel Panadero
 */

package PDR;

import java.io.*;
import java.net.*;
import java.sql.*;
//import java.util.Date;

public class PDRProvincia 
{
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio con;           // Nos permite conectarnos con la base de datos.
    public  ResultSet  rSelectPublic; // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int        CDG_PRV;       // Nmero de identificacin de la provincia. (Puesto por nosotros)
    public  int        PRV_CPRO;      // Nmero de identificador de la provincia para el INE (Puesto por el ayuntamiento o por el INE)
    public  String     NOM_PRV;       // Nombre de la provincia. (Puesto por el usuario)
    public  String     DSC_PRV;       // Descripci de la provincia. (Posat per l'usuari)
    // Relacionada con Errores
    public  String     sError;        // Guardamos todos los errores generados.
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    /** Creates a new instance of PDRProvincia */
    public PDRProvincia() 
    {
       CDG_PRV       = -1;
       PRV_CPRO      = -1;
       NOM_PRV       = ""; 
       DSC_PRV       = "";
       sError        = "";
       con           = null;
       rSelectPublic = null;
       sSiguiente    = "disabled";
       sAnterior     = "disabled";
    }
    
    public PDRProvincia(BDConnexio conexion) 
    {
       CDG_PRV       = -1;
       PRV_CPRO      = -1;
       NOM_PRV       = ""; 
       DSC_PRV       = "";
       sError        = "";
       con           = conexion;
       rSelectPublic = null;
       sSiguiente    = "disabled";
       sAnterior     = "disabled";
    }
    
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    public void reiniciar()
    {  
       CDG_PRV       = -1;
       PRV_CPRO      = -1;
       NOM_PRV       = ""; 
       DSC_PRV       = "";
       sError        = "";
       rSelectPublic = null;
       sSiguiente    = "disabled";
       sAnterior     = "disabled";
    }
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {
      try
      {
        CDG_PRV  = Integer.parseInt(rSelect.getString("CDG_PRV"));
        PRV_CPRO = Integer.parseInt(rSelect.getString("PRV_CPRO"));
        NOM_PRV  = rSelect.getString ("NOM_PRV");
        DSC_PRV  = rSelect.getString ("DSC_PRV");
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Inserta una provincia en la taula de provincias.
    public void insert()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador pNum;
      
      pNum = new PDRNumerador(con);
      try
      {
        // Possem un numero a la provincia.
        pNum.NMR_NOM = "NMR_Provincia";
        pNum.select();
        CDG_PRV = pNum.NMR_VLR;
            
        sbSql = null;
      
        stmt = con.cnPrincipal.createStatement();

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append("    PDR_PRV ");
        sbSql.append(" (CDG_PRV, PRV_CPRO, NOM_PRV, DSC_PRV) ");
        sbSql.append(" values ");
        sbSql.append("('"+  CDG_PRV +"','"+ PRV_CPRO +"','"+ NOM_PRV+"','"+ DSC_PRV + "')");

        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un Update de una provincia en la taula de provincias,
    // Solament es por updateixa la descripci y el numero de la provincia
    public void update()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;

      sbSql = null;
      try{
        stmt = con.cnPrincipal.createStatement();

        // Preparem la sentncia SQL, solament podem updateixa la descripcio
        sbSql  = new StringBuffer("");
        sbSql.append("Update ");
        sbSql.append("   PDR_PRV ");
        sbSql.append(" SET "  );
        sbSql.append("   DSC_PRV=  '"+ DSC_PRV + "', ");
        sbSql.append("   PRV_CPRO= '"+ PRV_CPRO + "' ");
        sbSql.append(" where");
        sbSql.append("   NOM_PRV= '"+ NOM_PRV + "' ");
        

        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un delete en la taula de provincies, 
    // mirant solament el nom de la provincia.
    public void delete()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;

      sbSql = null;
      try{
        stmt = con.cnPrincipal.createStatement();

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Delete From ");
        sbSql.append("    PDR_PRV ");
        sbSql.append(" where");
        sbSql.append("   NOM_PRV= '"+ NOM_PRV + "' ");
        

        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'una Provincia
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
        // Cerramos el select anterior
        if (rSelectPublic != null){rSelectPublic.close();}  
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append("     PDR_PRV ");
        sbSql.append(" where ");      
        sbSql.append("   ( PRV_CPRO = '"+ PRV_CPRO + "' or ");
        sbSql.append("     '"+PRV_CPRO+"' = -1)");
        sbSql.append("   and ");
        sbSql.append("   ( NOM_PRV LIKE'%"+ NOM_PRV + "%' or ");
        sbSql.append("     '"+NOM_PRV+"' = '')");
        sbSql.append("   and ");
        sbSql.append("   ( DSC_PRV LIKE'%"+ DSC_PRV + "%' or ");
        sbSql.append("     '"+DSC_PRV+"' = '')");
        sbSql.append("   and ");
        sbSql.append("   ( PRV_CPRO != '0' )");
        sbSql.append(" Order by NOM_PRV");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
           rSelectPublic = rSelect;
           
           // Desbloqueamos o bloqueamos los botones que haga falta.
           if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
           if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
        }
        else
        {
           sError = sError + "e7: No existeix Provncia amb aquestes caracterstiques." +"<br />";
           rSelectPublic = null;
           // Desactivamos los botones de siguiente y anteriror.
           sSiguiente    = "disabled";
           sAnterior     = "disabled";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }
    
    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }
    
    // Comprueba si la provincia existe.
    public boolean existeProvincia()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select  ");
            sbSql.append("    *  ");
            sbSql.append("  from  ");
            sbSql.append("     PDR_PRV ");
            sbSql.append("  where  ");
            sbSql.append(" ( ");
            sbSql.append("  NOM_PRV  = '"+ NOM_PRV + "' ");
            sbSql.append(" ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprueba si la provincia te municipis asignats.
    public boolean teMunicipis()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select  ");
            sbSql.append("    *  ");
            sbSql.append("  from  ");
            sbSql.append(   " PDR_MNC ");
            sbSql.append("  where  ");
            sbSql.append(" ( ");
            sbSql.append("  CDG_PRV  = '"+ CDG_PRV + "' ");
            sbSql.append(" ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset totes les Entitats Singulars que no estiguin donats de baixa.
    public ResultSet TotsProvincia()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append("     PDR_PRV ");
        sbSql.append("    WHERE ");
        sbSql.append("   ( CDG_PRV != '0' )");
        sbSql.append(" Order by NOM_PRV");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Comprova si la Provincia es correcta per inserir-lo.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (NOM_PRV.compareTo("")==0)// Problema 1
      {
          sResultado = sResultado + "e1: Falta posar el nom de la Provncia. <br /> " ;
      }
      
      if (DSC_PRV.compareTo("")==0)// Problema 2
      {
          sResultado = sResultado + "e2: Falta posar la Descripci de la Provncia. <br /> " ;
      }
      
      if (existeProvincia() )// Problema 3
      {
        sResultado = sResultado + "e3: La Provncia existeix. <br /> " ;
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la provincia se puede updatear
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (NOM_PRV.compareTo("")==0)// Problema 1
      {
          sResultado = sResultado + "e1: Falta posar el nom de la Provncia. <br /> " ;
      }
      
      if (DSC_PRV.compareTo("")==0)// Problema 2
      {
          sResultado = sResultado + "e2: Falta posar la Descripci de la Provncia. <br /> " ;
      }
      
      if (! existeProvincia() )// Problema 4
      {
        sResultado = sResultado + "e4: La Provncia no existeix. <br /> " ;
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la provincia se puede borrar.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (NOM_PRV.compareTo("")==0)// Problema 1
      {
          sResultado = sResultado + "e1: Falta posar el nom de la Provncia. <br /> " ;
      }
      
      if (CDG_PRV == -1)// Problema 16
      {
        sResultado = sResultado + "e138: El delete requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      else
      {
        //Comprovem si aquesta provincia no tingui cap municipi asignat.
        if ( teMunicipis() )// Problema 18
        {
            sResultado = sResultado + "e18: La Provncia te Municipis assignats i no es pot esborra. <br /> " ;
        }
      }
      if (! existeProvincia() )// Problema 4 
      {
        sResultado = sResultado + "e4: La Provncia no existeix. <br /> " ;
      }
            
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprova si podem fer el select.
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hay comprovaciones.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    
}
