/*
 * PDRSexo.java
 *
 * Created on 2 de abril de 2006, 13:53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Panadero
 */

public class PDRSexo 
{
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    // De la base de datos
    public  int          SEXO;              // Nmero del Sexa.                                          (Posat per l'usuari)
    public  String       NMB_SEXO;          // Nom del Sexa.                                             (Posat per l'usuari)
    
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    
    // Creates a new instance of PDRSexo 
    public PDRSexo() 
    {
        con             = null;    
        // De la base de datos
        SEXO     = -1;       
        NMB_SEXO = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
    
    // Creates a new instance of PDRSexo 
    public PDRSexo(BDConnexio conexion) 
    {
        con             = conexion;   
        // De la base de datos
        SEXO     = -1;       
        NMB_SEXO = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
     
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion.
    public void reiniciar()
    {              
        // De la base de datos
        SEXO     = -1;       
        NMB_SEXO = "";       
             
        // Relacionada con Errores
        sError          = "";          
        
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    private void rellenar(ResultSet rSelect)
    {   
      try
      {
        // Dades de PDR_DDSTRM
        SEXO     = Integer.parseInt(rSelect.getString("SEXO"));       
        NMB_SEXO = rSelect.getString ("NMB_SEXO");     
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Fa un select d'un Tipus de Sexa
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{ 
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_SEX SEX");
        sbSql.append(" where ");
        sbSql.append("  ( SEX.SEXO ='"+ SEXO +"' or ");
        sbSql.append(   "'"+SEXO            +"'  = -1) and");
        sbSql.append("  ( SEX.NMB_SEXO ='"+ NMB_SEXO +"' or ");
        sbSql.append(   "'"+NMB_SEXO           +"'  = '')   ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "76: No existeixen Tipus de Sexa amb aquestes caracterstiques." +"<br />";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Carrega el Tipus de Sexa en el objecte que la cridat.
    public void darSexo(int SEXOaux, String NMB_SEXOaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_SEX SEX");
        sbSql.append(" where ");
        sbSql.append("  SEX.SEXO ='"+ SEXOaux +"' or ");
        sbSql.append("  SEX.NMB_SEXO ='"+ NMB_SEXOaux +"' ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
           
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "77: El Tipus de Sexa no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Comproba si el Tipus de Sexa existeix.
    public boolean existeSexo()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
             // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_SEX SEX");
            sbSql.append(" where ");
            sbSql.append("  SEX.SEXO ='"+ SEXO +"' or ");
            sbSql.append("  SEX.NMB_SEXO ='"+ NMB_SEXO +"' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
}
