/*
 * PDRTipusIden.java
 *
 * Created on 2 de abril de 2006, 15:19
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Panadero
 */

public class PDRTipusIden
{
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    // De la base de datos
    public  int          TIDEN;              // Nmero del Tipus de Identificador.                      (Posat per l'usuari)
    public  String       NMB_TIDEN;          // Nom del Tipus de Identificador.                         (Posat per l'usuari)
    
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    
    // Creates a new instance of PDRTipusIden 
    public PDRTipusIden() 
    {
        con             = null;    
        // De la base de datos
        TIDEN     = -1;       
        NMB_TIDEN = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
    
    // Creates a new instance of PDRTipusIden 
    public PDRTipusIden(BDConnexio conexion) 
    {
        con             = conexion;   
        // De la base de datos
        TIDEN     = -1;       
        NMB_TIDEN = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
     
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion.
    public void reiniciar()
    {              
        // De la base de datos
        TIDEN     = -1;       
        NMB_TIDEN = "";       
             
        // Relacionada con Errores
        sError          = "";          
        
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {   
      try
      {
        // Dades de PDR_TPS_IDEN
        TIDEN     = Integer.parseInt(rSelect.getString("TIDEN"));       
        NMB_TIDEN = rSelect.getString ("NMB_TIDEN");     
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Fa un select d'un Municipi
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{ 
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_TPS_IDN TDN");
        sbSql.append(" where ");
        sbSql.append("  ( TDN.TIDEN ='"+ TIDEN +"' or ");
        sbSql.append(   "'"+TIDEN            +"'  = -1) and");
        sbSql.append("  ( TDN.NMB_TIDEN ='"+ NMB_TIDEN +"' or ");
        sbSql.append(   "'"+NMB_TIDEN           +"'  = '')   ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "78: No existeix Tipus de Identificador amb aquestes caracterstiques." +"<br />";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Carrega el Tipus de Identificador en el objecte que la cridat.
    public void darTipusIden(int TIDENaux, String NMB_TIDENaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_TPS_IDN TDN");
        sbSql.append(" where ");
        sbSql.append("  TDN.TIDEN ='"+ TIDENaux +"' or ");
        sbSql.append("  TDN.NMB_TIDEN ='"+ NMB_TIDENaux +"' ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "79: El Tipus de Identificador no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    
    // Comproba si el Municipi existeix.
    public boolean existeTipusIden()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
             // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_TPS_IDN TDN");
            sbSql.append(" where ");
            sbSql.append("  TDN.TIDEN ='"+ TIDEN +"' or ");
            sbSql.append("  TDN.NMB_TIDEN ='"+ NMB_TIDEN +"' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset totes les Nacionalitats que no estiguin donats de baixa.
    public ResultSet TotsTipusIdentificadors()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_TPS_IDN ");
        sbSql.append(" where ");
        sbSql.append(" TIDEN != -2");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per els Tipus de Identificadors.
    public String MostrarTipusIdentificador ()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRTipusIden oTpsIden;
        int          i;
        
        sResultat = new StringBuffer("");
        oTpsIden  = new PDRTipusIden(con);
        i = 0;
        
        try
        {            
            // obtenim els Tots els Tipus de Identificadors
            rSelect = oTpsIden.TotsTipusIdentificadors();
            
            sResultat.append("<SELECT NAME=\"TIPIDEN\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oTpsIden.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oTpsIden.NMB_TIDEN +"\"");
                if (NMB_TIDEN.compareTo(oTpsIden.NMB_TIDEN) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oTpsIden.NMB_TIDEN+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
}
