/*
 * PDRTram.java
 *
 * Created on 1 de marzo de 2006, 17:01
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;

import java.io.*;
import java.net.*;
import java.sql.*;
//import java.util.GregorianCalendar;

/**
 * @author Miguel Panadero
 */

public class PDRTram {
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    public  ResultSet    rSelectPublic;     // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int          CDG_PRV;           // Nmero de identificacin de la provincia.        (Posat per nosaltres)
    public  int          CDG_MNC;           // Nmero que identifica la provincia.              (Posat per nosaltres)
    private int          DDSTRM_CTRM;       // Cdi de les dades del Tram.                      (Posat per nosaltres)
    public  int          CDG_CTRM;          // Cdi del Tram.                                   (Posat per nosaltres)
    public  int          CUN;               // Cdi d'Unitat Poblacional                        (Posat per l'INE)
    public  int          DIST;              // Districte.                                       (Posat per l'usuari)
    public  int          SECC;              // Secci.                                          (Posat per l'usuari)
    public  String       LSECC;             // Lletra de Secci.                                (Posat per l'usuari)
    public  String       SUBSC;             // Subsecci.                                       (Posat per l'usuari)
    public  String       MANZ;              // Manzana.                                         (Posat per l'usuari)
    public  int          TINUM;             // Tipus de Numeraci.                              (Posat per l'usuari)
    public  int          EIN;               // Extrem inferior de Nmeraci.                    (Posat per l'usuari)
    public  String       CEIN;              // Calificador Extrem inferior de Numeraci.        (Posat per l'usuari)
    public  int          ESN;               // Extrem superior de Nmeraci.                    (Posat per l'usuari)
    public  String       CESN;              // Calificador Extrem superior de Numeraci.        (Posat per l'usuari)
    public  int          CPOS;              // Cdi Postal                                      (Posat per l'usuari)
    private String       FVAR;              // Data del cambi.                                  (Posat per nosaltres)
    public  String       CVAR;              // Codi de Variacio                                 (Posat per nosaltres)
    private String       Envio;             // Ens indica si esta enviat al Ine.                (Posat per nosaltres)
    
    // Contenedores de otras clases.
    public  PDRVia       VIA;               // Objecta Via.                                     (Posat per l'usuari)
    public  PDRPseudovia PSEUDOVIA;         // Objecta Pseudovia                                (Posat per l'usuari)
    public  PDRNucli     NUCLI;             // Objecta Nucli                                    (Posat per l'usuari)
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    // Dades del Usuari
    public  int        CDG_USR;         // Nmero que identifica al usuari que esta realitzan les accion (Posat per nosaltres)
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    // Creates a new instance of PDRTram 
    public PDRTram(int USR) 
    {
        con             = null;            
        rSelectPublic   = null;    
        // De la base de datos
        CDG_PRV         = -1;         
        CDG_MNC         = -1;  
        DDSTRM_CTRM     = -1;
        CDG_CTRM        = -1;
        CUN             = -1;
        DIST            = -1;            
        SECC            = -1;             
        LSECC           = "";         
        SUBSC           = "";          
        MANZ            = "";         
        TINUM           = -1;          
        EIN             = -1;        
        CEIN            = "";          
        ESN             = -1;             
        CESN            = "";           
        CPOS            = -1;             
        FVAR            = "";             
        CVAR            = "";              
        Envio           = "";            
    
        // Contenedores de otras clases.
        VIA             = new PDRVia(USR);              
        PSEUDOVIA       = new PDRPseudovia(USR);       
        NUCLI           = new PDRNucli(USR);             
        // Relacionada con Errores
        sError          = "";        
        // Dades del Usuari
        CDG_USR         = USR;         
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
        
    }
    
    // Creates a new instance of PDRHabitant 
    public PDRTram(BDConnexio conexion, int USR) 
    {
        con             = conexion;            
        rSelectPublic   = null;    
        // De la base de datos
        CDG_PRV         = -1;         
        CDG_MNC         = -1; 
        DDSTRM_CTRM     = -1;
        CDG_CTRM        = -1;
        DIST            = -1;            
        SECC            = -1;             
        LSECC           = "";         
        SUBSC           = "";          
        MANZ            = "";         
        TINUM           = -1;          
        EIN             = -1;        
        CEIN            = "";          
        ESN             = -1;             
        CESN            = "";           
        CPOS            = -1;             
        FVAR            = "";             
        CVAR            = "";              
        Envio           = "";            
    
        // Contenedores de otras clases.
        VIA             = new PDRVia(conexion,USR);              
        PSEUDOVIA       = new PDRPseudovia(conexion,USR);       
        NUCLI           = new PDRNucli(conexion,USR);             
        // Relacionada con Errores
        sError          = "";        
        // Dades del Usuari
        CDG_USR         = USR;         
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior = "disabled";
        
    }
    
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    public void reiniciar()
    {            
        rSelectPublic   = null;    
        // De la base de datos
        DDSTRM_CTRM     = -1;
        CDG_CTRM        = -1;
        CUN             = -1;
        DIST            = -1;            
        SECC            = -1;             
        LSECC           = "";         
        SUBSC           = "";          
        MANZ            = "";         
        TINUM           = -1;          
        EIN             = -1;        
        CEIN            = "";          
        ESN             = -1;             
        CESN            = "";           
        CPOS            = -1;             
        FVAR            = "";             
        CVAR            = "";              
        Envio           = "";            
    
        // Contenedores de otras clases.
        VIA             = new PDRVia(con,CDG_USR);              
        PSEUDOVIA       = new PDRPseudovia(con,CDG_USR);       
        NUCLI           = new PDRNucli(con,CDG_USR);             
        // Relacionada con Errores
        sError          = "";          
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {   
      try
      {
        // Dades de PDR_DDSTRM
        CDG_PRV         = Integer.parseInt(rSelect.getString("CDG_PRV")); 
        CDG_MNC         = Integer.parseInt(rSelect.getString("CDG_MNC"));
        DDSTRM_CTRM     = Integer.parseInt(rSelect.getString("DDSTRM_CTRM"));
        CDG_CTRM        = Integer.parseInt(rSelect.getString("CDG_CTRM"));  
        CUN             = Integer.parseInt(rSelect.getString("CUN"));
        DIST            = Integer.parseInt(rSelect.getString("DIST"));      
        SECC            = Integer.parseInt(rSelect.getString("SECC"));           
        LSECC           = rSelect.getString ("LSECC");     
        SUBSC           = rSelect.getString ("SUBSC");      
        MANZ            = rSelect.getString ("MANZ");    
        TINUM           = Integer.parseInt(rSelect.getString("TINUM"));     
        EIN             = Integer.parseInt(rSelect.getString("EIN"));       
        CEIN            = rSelect.getString ("CEIN");     
        ESN             = Integer.parseInt(rSelect.getString("ESN"));            
        CESN            = rSelect.getString ("CESN");       
        CPOS            = Integer.parseInt(rSelect.getString("CPOS"));          
        // Dades de PDR_VIA_has_DDSVIA que no estan en l'altre.
        CDG_USR         = Integer.parseInt(rSelect.getString("CDG_USR")); 
        FVAR            = rSelect.getString ("FVAR").substring(1, 10);     
        CVAR            = rSelect.getString ("CVAR");            
        Envio           = rSelect.getString ("Envio");   
          
        // Carguem les dades de la via.
        if (Integer.parseInt(rSelect.getString("CDG_VIA")) != -1)
        {
            VIA.CDG_PRV = CDG_PRV;
            VIA.CDG_MNC = CDG_MNC;
            VIA.darVia(Integer.parseInt(rSelect.getString("CDG_VIA")),"");
            // Intoduim el posibles error en els errors d'aquest objecte.
            if (VIA.sError.compareTo("") != 0)
            {
                sError = sError + VIA.sError + "<br />"; 
            }
        }
        else
        {
           VIA.reiniciar();
        }
        // Carguem les dades de la Pseudovia.
        if (Integer.parseInt(rSelect.getString("CDG_CPSVIA")) != -1)
        {
            PSEUDOVIA.CDG_PRV = CDG_PRV;
            PSEUDOVIA.CDG_MNC = CDG_MNC;
            PSEUDOVIA.darPseudovia(Integer.parseInt(rSelect.getString("CDG_CPSVIA")),"");
            // Intoduim el posibles error en els errors d'aquest objecte.
            if (PSEUDOVIA.sError.compareTo("") != 0)
            {
                sError = sError + PSEUDOVIA.sError + "<br />"; 
            }
        }
        else
        {
          PSEUDOVIA.reiniciar();
        }
        // Carguem les dades del Nucli.
        if (Integer.parseInt(rSelect.getString("CDG_CNCL")) != -1)
        {
            NUCLI.CDG_PRV = CDG_PRV;
            NUCLI.CDG_MNC = CDG_MNC;
            NUCLI.darNucli(Integer.parseInt(rSelect.getString("CDG_CNCL")),"");
            // Intoduim el posibles error en els errors d'aquest objecte.
            if (NUCLI.sError.compareTo("") != 0)
            {
                sError = sError + NUCLI.sError + "<br />"; 
            }
        }
        else
        {
            NUCLI.reiniciar();
        }
        
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Inserta los datos del Tram en la taula de PDR_DDSTRM.
    // Inserta el Tram en taula de PDR_TRM.
    // Inserta la relaci Tram-dades en la taula de PDR_TRM_has_DDSTRM.
    public void insert()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador TrmNum;
      
      // Date
      Data dFecha;
      
      TrmNum = new PDRNumerador(con);
      try
      {
        // Possem un numero a les dades del Tram.
        TrmNum.NMR_NOM = "NMR_DDSTRM";
        TrmNum.select();
        DDSTRM_CTRM = TrmNum.NMR_VLR;
            
        sbSql = null;
      
        stmt = con.cnPrincipal.createStatement();

        // Preparem la sentncia SQL per inseri en PDR_DDSTRM
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_DDSTRM ");
        sbSql.append(" (CDG_PRV, CDG_MNC, DDSTRM_CTRM, CDG_CNCL, CDG_CPSVIA, CDG_VIA, CUN, DIST, SECC,  ");
        sbSql.append("  LSECC, SUBSC, MANZ, TINUM, EIN, CEIN, ESN, CESN, CPOS)");
        sbSql.append(" values ");
        sbSql.append("('"+  CDG_PRV        +"', '"+ CDG_MNC              +"', '"+DDSTRM_CTRM  +"', '");
        sbSql.append(       NUCLI.CDG_CNCL +"', '"+ PSEUDOVIA.CDG_CPSVIA +"', '"+ VIA.CDG_VIA +"',  ");
        sbSql.append(   "   -1                , '"+ DIST                 +"', '"+ SECC        +"', '");
        sbSql.append(       LSECC          +"', '"+ SUBSC                +"', '"+ MANZ        +"', '");
        sbSql.append(       TINUM          +"', '"+ EIN                  +"', '"+ CEIN        +"', '");
        sbSql.append(       ESN            +"', '"+ CESN                 +"', '"+ CPOS        +"')");

        stmt.executeUpdate(sbSql.toString());
                
        // Possem un numero al Tram.
        TrmNum.NMR_NOM = "NMR_TRM";
        TrmNum.select();
        CDG_CTRM = TrmNum.NMR_VLR;
        
        // Preparem la sentncia SQL per inseri en PDR_TRM
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_TRM ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CTRM) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV +"', '"+ CDG_MNC +"', '"+ CDG_CTRM+"')");
        
        stmt.executeUpdate(sbSql.toString());
        
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha();
        
        // Preparem la sentncia SQL per inseri en PDR_Via_has_DDSVia
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_TRM_has_DDSTRM ");
        sbSql.append(" (CDG_PRV, CDG_MNC, DDSTRM_CTRM, CDG_CTRM, CDG_USR, FVAR, CVAR, Envio) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ DDSTRM_CTRM+"', '");
        sbSql.append(      CDG_CTRM +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'A', 'N')");
        
        stmt.executeUpdate(sbSql.toString());
        
        stmt.close();
        con.cnPrincipal.commit();
        
    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un Insert de las dades de Tram en la taula de PDR_DDSTRM.
    // Fa un Insert en la taula PDR_TRM_has_DDSTRM enllaant TRM-Dades Noves.
    // Es pot updateixa tot menys Provincia i Municipi.
    public void update()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador TrmNum;
      
      // Date
      Data dFecha;
      
      TrmNum = new PDRNumerador(con);
      try{
        // Possem un numero a les dades del Tram.
        TrmNum.NMR_NOM = "NMR_DDSTRM";
        TrmNum.select();
        DDSTRM_CTRM = TrmNum.NMR_VLR;
      
        sbSql = null;
      
        stmt = con.cnPrincipal.createStatement();
       
        // Preparem la sentncia SQL per inseri en PDR_DDSTRM
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_DDSTRM ");
        sbSql.append(" (DDSTRM_CTRM, CDG_PRV, CDG_MNC, CDG_CNCL, CDG_CPSVIA, CDG_VIA, CUN, DIST, SECC,  ");
        sbSql.append("  LSECC      , SUBSC  , MANZ   , TINUM   , EIN       , CEIN   , ESN , CESN, CPOS)");
        sbSql.append(" values ");
        sbSql.append("('"+  DDSTRM_CTRM    +"', '"+ CDG_PRV              +"', '"+ CDG_MNC     +"', '");
        sbSql.append(       NUCLI.CDG_CNCL +"', '"+ PSEUDOVIA.CDG_CPSVIA +"', '"+ VIA.CDG_VIA +"', '");
        sbSql.append(       CUN            +"', '"+ DIST                 +"', '"+ SECC        +"', '");
        sbSql.append(       LSECC          +"', '"+ SUBSC                +"', '"+ MANZ        +"', '");
        sbSql.append(       TINUM          +"', '"+ EIN                  +"', '"+ CEIN        +"', '");
        sbSql.append(       ESN            +"', '"+ CESN                 +"', '"+ CPOS        +"')");
        
        stmt.executeUpdate(sbSql.toString());
        
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha(); 
        
        // Preparem la sentncia SQL per inseri en PDR_TRM_has_DDSTRM
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_TRM_has_DDSTRM ");
        sbSql.append(" (CDG_PRV, CDG_MNC, DDSTRM_CTRM, CDG_CTRM, CDG_USR, FVAR, CVAR, Envio) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ DDSTRM_CTRM+"', '");
        sbSql.append(      CDG_CTRM +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'M', 'N')");
        
        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un Insert en la taula PDR_TRM_has_DDSTRM enllaant TRM-Dades, inserim en motiu envia a Ine Baixa.
    public void delete()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      
      // Date
      Data dFecha;
      
      sbSql = null;
      try{
        stmt = con.cnPrincipal.createStatement();
       
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha();
        
        // Preparem la sentncia SQL per inseri en PDR_Via_has_DDSVia
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_TRM_has_DDSTRM ");
        sbSql.append(" (CDG_PRV, CDG_MNC, DDSTRM_CTRM,CDG_CTRM, CDG_USR, FVAR, CVAR, Envio) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV  +"', '"+ CDG_MNC +"', '"+ -1 +"', ");
        sbSql.append( "'"+ CDG_CTRM +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'B','N')");

        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'un Tram
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{
        // Cerramos el select anterior
        if (rSelectPublic != null){rSelectPublic.close();}  
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_TRM_has_DDSTRM THD,PDR_DDSTRM DTR");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DTR.CDG_PRV     = THD.CDG_PRV     and ");
        sbSql.append("   DTR.CDG_MNC     = THD.CDG_MNC     and ");
        sbSql.append("   DTR.DDSTRM_CTRM = THD.DDSTRM_CTRM     ");
        sbSql.append("  ) and ");
        sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( DTR.CDG_CNCL ='"+ NUCLI.CDG_CNCL +"' or ");
        sbSql.append(   "'"+NUCLI.CDG_CNCL +"'  = -1) and");
        sbSql.append("  ( DTR.CDG_CPSVIA ='"+ PSEUDOVIA.CDG_CPSVIA +"' or ");
        sbSql.append(   "'"+PSEUDOVIA.CDG_CPSVIA +"'  = -1) and");
        sbSql.append("  ( DTR.CDG_VIA ='"+ VIA.CDG_VIA +"' or ");
        sbSql.append(   "'"+VIA.CDG_VIA +"'  = -1) and");
        sbSql.append("  ( DTR.CUN ='"+ CUN +"' or ");
        sbSql.append(   "'"+CUN            +"'  = -1) and");
        sbSql.append("  ( DTR.DIST ='"+ DIST +"' or ");
        sbSql.append(   "'"+DIST           +"'  = -1) and");
        sbSql.append("  ( DTR.SECC ='"+ SECC +"' or ");
        sbSql.append(   "'"+SECC           +"'  = -1) and");
        sbSql.append("  ( DTR.LSECC ='"+ LSECC +"' or ");
        sbSql.append(   "'"+LSECC           +"'  = '') and");
        sbSql.append("  ( DTR.SUBSC ='"+ SUBSC +"' or ");
        sbSql.append(   "'"+SUBSC           +"'  = '') and");
        sbSql.append("  ( DTR.MANZ ='"+ MANZ +"' or ");
        sbSql.append(   "'"+MANZ           +"'  = '') and");
        sbSql.append("  ( DTR.TINUM ='"+ TINUM +"' or ");
        sbSql.append(   "'"+TINUM           +"'  = -1) and");
        sbSql.append("  ( DTR.EIN ='"+ EIN +"' or ");
        sbSql.append(   "'"+EIN           +"'  = -1) and");
        sbSql.append("  ( DTR.CEIN ='"+ CEIN +"' or ");
        sbSql.append(   "'"+CEIN           +"'  = '') and");
        sbSql.append("  ( DTR.ESN ='"+ ESN +"' or ");
        sbSql.append(   "'"+ESN           +"'  = -1) and");
        sbSql.append("  ( DTR.CESN ='"+ CESN +"' or ");
        sbSql.append(   "'"+CESN +"'  = '') and");
        sbSql.append("  ( DTR.CPOS ='"+ CPOS +"' or ");
        sbSql.append(   "'"+CPOS           +"'  = -1) and");
        sbSql.append("  THD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_TRM_has_DDSTRM THD2, PDR_DDSTRM DTR2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DTR2.CDG_PRV     = THD2.CDG_PRV     and ");
        sbSql.append("      DTR2.CDG_MNC     = THD2.CDG_MNC     and ");
        sbSql.append("      DTR2.DDSTRM_CTRM = THD2.DDSTRM_CTRM ");
        sbSql.append("    ) and "); 
        sbSql.append("    THD.CDG_CTRM = THD2.CDG_CTRM ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DTR.DDSTRM_CTRM < DTR2.DDSTRM_CTRM  or ");
        sbSql.append("    DTR2.DDSTRM_CTRM =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
        sbSql.append("  order by CUN ");
       
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
           rSelectPublic = rSelect;
           
           // Desbloqueamos o bloqueamos los botones que haga falta.
           if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
           if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
        }
        else
        {
           sError = sError + "e44: No existeix Tram amb aquestes caracterstiques." +"<br />";
           rSelectPublic = null;
           // Desactivamos los botones de siguiente y anteriror.
           sSiguiente    = "disabled";
           sAnterior     = "disabled";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }
    
    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }
    
    // Carrega el Tram en el objecte que la cridat.
    // Requereix que tingui posada la provincia y el municipi de busqueda
    public void darTram(int CDG_TRMaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_TRM_has_DDSTRM THD,PDR_DDSTRM DTR");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DTR.CDG_PRV     = THD.CDG_PRV     and ");
        sbSql.append("   DTR.CDG_MNC     = THD.CDG_MNC     and ");
        sbSql.append("   DTR.DDSTRM_CTRM = THD.DDSTRM_CTRM     ");
        sbSql.append("  ) and ");
        sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  THD.CDG_CTRM ='"+ CDG_TRMaux +"' and ");
        sbSql.append("  THD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_TRM_has_DDSTRM THD2, PDR_DDSTRM DTR2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DTR2.CDG_PRV     = THD2.CDG_PRV     and ");
        sbSql.append("      DTR2.CDG_MNC     = THD2.CDG_MNC     and ");
        sbSql.append("      DTR2.DDSTRM_CTRM = THD2.DDSTRM_CTRM ");
        sbSql.append("    ) and "); 
        sbSql.append("    THD.CDG_CTRM = THD2.CDG_CTRM ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DTR.DDSTRM_CTRM < DTR2.DDSTRM_CTRM  or ");
        sbSql.append("    DTR2.DDSTRM_CTRM =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e51: El Tram no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Carrega el Tram en el objecte que la cridat en la Data que ens donen.
    // Requereix que tingui posada la provincia y el municipi de busqueda
    public void darTram(int CDG_TRMaux, String Data)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_TRM_has_DDSTRM THD,PDR_DDSTRM DTR");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DTR.CDG_PRV     = THD.CDG_PRV     and ");
        sbSql.append("   DTR.CDG_MNC     = THD.CDG_MNC     and ");
        sbSql.append("   DTR.DDSTRM_CTRM = THD.DDSTRM_CTRM     ");
        sbSql.append("  ) and ");
        sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  THD.CDG_CTRM ='"+ CDG_TRMaux +"' and ");
        sbSql.append("  THD.CVAR <> 'B' and ");
        sbSql.append("  THD.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_TRM_has_DDSTRM THD2, PDR_DDSTRM DTR2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DTR2.CDG_PRV     = THD2.CDG_PRV     and ");
        sbSql.append("      DTR2.CDG_MNC     = THD2.CDG_MNC     and ");
        sbSql.append("      DTR2.DDSTRM_CTRM = THD2.DDSTRM_CTRM ");
        sbSql.append("    ) and "); 
        sbSql.append("    THD.CDG_CTRM = THD2.CDG_CTRM and");
        sbSql.append("    THD2.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("    (");
        sbSql.append("    DTR.DDSTRM_CTRM < DTR2.DDSTRM_CTRM  or ");
        sbSql.append("    DTR2.DDSTRM_CTRM =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e51: El Tram no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Recopera el Tram que ens han marcat a una data o ens retorna totes les d'una data si no ens han marcat cap.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarTrams (String sData)
    {    
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_TRM_has_DDSTRM THD,PDR_DDSTRM DTR");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DTR.CDG_PRV     = THD.CDG_PRV     and ");
        sbSql.append("   DTR.CDG_MNC     = THD.CDG_MNC     and ");
        sbSql.append("   DTR.DDSTRM_CTRM = THD.DDSTRM_CTRM     ");
        sbSql.append("  ) and ");
        sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( THD.CDG_CTRM   ='"+ CDG_CTRM +"' or ");
        sbSql.append("  '"+ CDG_CTRM +"' = -1 ) and ");
        sbSql.append("  THD.CVAR <> 'B' and ");
        sbSql.append("  THD.FVAR <= to_timestamp('"+ sData +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_TRM_has_DDSTRM THD2, PDR_DDSTRM DTR2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DTR2.CDG_PRV     = THD2.CDG_PRV     and ");
        sbSql.append("      DTR2.CDG_MNC     = THD2.CDG_MNC     and ");
        sbSql.append("      DTR2.DDSTRM_CTRM = THD2.DDSTRM_CTRM ");
        sbSql.append("    ) and "); 
        sbSql.append("    THD.CDG_CTRM = THD2.CDG_CTRM and");
        sbSql.append("    THD2.FVAR <= to_timestamp('"+ sData +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("    (");
        sbSql.append("    DTR.DDSTRM_CTRM < DTR2.DDSTRM_CTRM  or ");
        sbSql.append("    DTR2.DDSTRM_CTRM =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Recopera el Tram que esta en l'objecte (CDG_CTRM) si es de la Via que ens han passat, si no hi ha (CDG_CTRM = -1) retorna tots els Trams D'aquesta via.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarTramsDeVia (int iVia, String sData)
    {    
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_TRM_has_DDSTRM THD,PDR_DDSTRM DTR");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DTR.CDG_PRV     = THD.CDG_PRV     and ");
        sbSql.append("   DTR.CDG_MNC     = THD.CDG_MNC     and ");
        sbSql.append("   DTR.DDSTRM_CTRM = THD.DDSTRM_CTRM     ");
        sbSql.append("  ) and ");
        sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( THD.CDG_CTRM   ='"+ CDG_CTRM +"' or ");
        sbSql.append("  '"+ CDG_CTRM +"' = -1 ) and ");
        sbSql.append("  DTR.CDG_VIA ='"+ iVia +"'   and ");
        sbSql.append("  THD.CVAR <> 'B' and ");
        sbSql.append("  THD.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_TRM_has_DDSTRM THD2, PDR_DDSTRM DTR2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DTR2.CDG_PRV     = THD2.CDG_PRV     and ");
        sbSql.append("      DTR2.CDG_MNC     = THD2.CDG_MNC     and ");
        sbSql.append("      DTR2.DDSTRM_CTRM = THD2.DDSTRM_CTRM ");
        sbSql.append("    ) and "); 
        sbSql.append("    THD.CDG_CTRM = THD2.CDG_CTRM and");
        sbSql.append("    THD2.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("    (");
        sbSql.append("    DTR.DDSTRM_CTRM < DTR2.DDSTRM_CTRM  or ");
        sbSql.append("    DTR2.DDSTRM_CTRM =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Recopera el Tram que esta en l'objecte (CDG_CTRM) si es de la Pseudovia que ens han passat, si no hi ha (CDG_CTRM = -1) retorna tots els Trams D'aquesta Pseudovia.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarTramsDePseudovia (int iPseudovia, String sData)
    {    
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_TRM_has_DDSTRM THD,PDR_DDSTRM DTR");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DTR.CDG_PRV     = THD.CDG_PRV     and ");
        sbSql.append("   DTR.CDG_MNC     = THD.CDG_MNC     and ");
        sbSql.append("   DTR.DDSTRM_CTRM = THD.DDSTRM_CTRM     ");
        sbSql.append("  ) and ");
        sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( THD.CDG_CTRM   ='"+ CDG_CTRM +"' or ");
        sbSql.append("  '"+ CDG_CTRM +"' = -1 ) and ");
        sbSql.append("  DTR.CDG_CPSVIA ='"+ iPseudovia +"'   and ");
        sbSql.append("  THD.CVAR <> 'B' and ");
        sbSql.append("  THD.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_TRM_has_DDSTRM THD2, PDR_DDSTRM DTR2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DTR2.CDG_PRV     = THD2.CDG_PRV     and ");
        sbSql.append("      DTR2.CDG_MNC     = THD2.CDG_MNC     and ");
        sbSql.append("      DTR2.DDSTRM_CTRM = THD2.DDSTRM_CTRM ");
        sbSql.append("    ) and "); 
        sbSql.append("    THD.CDG_CTRM = THD2.CDG_CTRM and");
        sbSql.append("    THD2.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("    (");
        sbSql.append("    DTR.DDSTRM_CTRM < DTR2.DDSTRM_CTRM  or ");
        sbSql.append("    DTR2.DDSTRM_CTRM =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Recopera el Tram que esta en l'objecte (CDG_CTRM) si es del Nucli que ens han passat, si no hi ha (CDG_CTRM = -1) retorna tots els Trams D'aquesta Nucli.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarTramsDeNucli (int iNucli, String sData)
    {    
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_TRM_has_DDSTRM THD,PDR_DDSTRM DTR");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DTR.CDG_PRV     = THD.CDG_PRV     and ");
        sbSql.append("   DTR.CDG_MNC     = THD.CDG_MNC     and ");
        sbSql.append("   DTR.DDSTRM_CTRM = THD.DDSTRM_CTRM     ");
        sbSql.append("  ) and ");
        sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( THD.CDG_CTRM   ='"+ CDG_CTRM +"' or ");
        sbSql.append("  '"+ CDG_CTRM +"' = -1 ) and ");
        sbSql.append("  DTR.CDG_CNCL ='"+ iNucli +"'   and ");
        sbSql.append("  THD.CVAR <> 'B' and ");
        sbSql.append("  to_timestamp(THD.FVAR,'DD/MM/YYYY') <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_TRM_has_DDSTRM THD2, PDR_DDSTRM DTR2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DTR2.CDG_PRV     = THD2.CDG_PRV     and ");
        sbSql.append("      DTR2.CDG_MNC     = THD2.CDG_MNC     and ");
        sbSql.append("      DTR2.DDSTRM_CTRM = THD2.DDSTRM_CTRM ");
        sbSql.append("    ) and "); 
        sbSql.append("    THD.CDG_CTRM = THD2.CDG_CTRM and");
        sbSql.append("    to_timestamp(THD2.FVAR,'DD/MM/YYYY') <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("    (");
        sbSql.append("    DTR.DDSTRM_CTRM < DTR2.DDSTRM_CTRM  or ");
        sbSql.append("    DTR2.DDSTRM_CTRM =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Comproba si el Tram existeix.
    public boolean existeTram()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
             // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_TRM_has_DDSTRM THD,PDR_DDSTRM DTR");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DTR.CDG_PRV     = THD.CDG_PRV     and ");
            sbSql.append("   DTR.CDG_MNC     = THD.CDG_MNC     and ");
            sbSql.append("   DTR.DDSTRM_CTRM = THD.DDSTRM_CTRM     ");
            sbSql.append("  ) and ");
            sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  ( THD.CDG_CTRM ='"+ CDG_CTRM +"' or ");
            sbSql.append("    DTR.CUN      ='"+ CUN      +"' ) and ");
            sbSql.append("  THD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_TRM_has_DDSTRM THD2, PDR_DDSTRM DTR2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DTR2.CDG_PRV     = THD2.CDG_PRV     and ");
            sbSql.append("      DTR2.CDG_MNC     = THD2.CDG_MNC     and ");
            sbSql.append("      DTR2.DDSTRM_CTRM = THD2.DDSTRM_CTRM ");
            sbSql.append("    ) and "); 
            sbSql.append("    THD.CDG_CTRM = THD2.CDG_CTRM ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DTR.DDSTRM_CTRM < DTR2.DDSTRM_CTRM  or ");
            sbSql.append("    DTR2.DDSTRM_CTRM =  -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprova si te asignat algn Habitatge.
    public boolean teHabitatge()
    {
        boolean bResultado;
        bResultado = false;
       
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_HABITATGE HBTG");
            sbSql.append(" where ");
            sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  CDG_CTRM  = '"+ CDG_CTRM +"' and");
            sbSql.append("  HBTG.Estado <> 'Baja' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset tots els Trams que no estiguin donats de baixa.
    public ResultSet TotsTram()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_TRM_has_DDSTRM THD,PDR_DDSTRM DTR");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DTR.CDG_PRV     = THD.CDG_PRV     and ");
        sbSql.append("   DTR.CDG_MNC     = THD.CDG_MNC     and ");
        sbSql.append("   DTR.DDSTRM_CTRM = THD.DDSTRM_CTRM     ");
        sbSql.append("  ) and ");
        sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  THD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_TRM_has_DDSTRM THD2, PDR_DDSTRM DTR2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DTR2.CDG_PRV     = THD2.CDG_PRV     and ");
        sbSql.append("      DTR2.CDG_MNC     = THD2.CDG_MNC     and ");
        sbSql.append("      DTR2.DDSTRM_CTRM = THD2.DDSTRM_CTRM ");
        sbSql.append("    ) and "); 
        sbSql.append("    THD.CDG_CTRM = THD2.CDG_CTRM ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DTR.DDSTRM_CTRM < DTR2.DDSTRM_CTRM  or ");
        sbSql.append("    DTR2.DDSTRM_CTRM =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
        sbSql.append("  order by CUN ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per Tram.
    public String MostrarTram (int PRV, int MNC)
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRTram       oTrm;
        int          i;
        
        sResultat = new StringBuffer("");
        oTrm   = new PDRTram(con, CDG_USR);
        i = 0;
        
        try
        {
            // Coloquem en el objecta les Provincia y Municipi corresponent.
            oTrm.CDG_PRV = PRV;
            oTrm.CDG_MNC = MNC;
            
            // obtenim els Tots els Trams
            rSelect = oTrm.TotsTram();
            
            sResultat.append("<SELECT NAME=\"TRAM\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oTrm.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\"" + oTrm.CDG_CTRM + "\"");
                if (CDG_CTRM == oTrm.CDG_CTRM)
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(">"+oTrm.CDG_CTRM+"</OPTION>");
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Comprova si el Tram es correcta per inserir-la.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (DIST == -1)// Problema 45
      {
          sResultado = sResultado + "e45: Falta posar el districte. <br /> " ;
      }
      if (SECC == -1)// Problema 46
      {
          sResultado = sResultado + "e46: Falta posar la secci. <br /> " ;
      }
      if (MANZ.compareTo("") == 0)// Problema 47
      {
          sResultado = sResultado + "e47: Falta posar la illa. <br /> " ;
      }
      if (TINUM == -1 || (TINUM != 0 && TINUM != 1 && TINUM != 2))// Problema 48
      {
          sResultado = sResultado + "4e48: El tipus de numeraci no es correcta 0(Sense numeraci) 1(Senar) 2(Parell). <br /> " ;
      }
      if (CPOS == -1)// Problema 49
      {
          sResultado = sResultado + "e49: Falta posar el codi postal. <br /> " ;
      }
      if (VIA.NVIA.compareTo("") != 0 && PSEUDOVIA.DPSVIA.compareTo("") != 0)
      {
          sResultado = sResultado + "e50: Hi ha una Via i una Pseudovia assignades al Tram. <br /> " ;
      }
      // Comprova si las dades se adecuan a las de la base de dades.
      if (VIA.NVIA.compareTo("") != 0)// Problema 25
      {
          if (! VIA.existeVia())
          {
            sResultado = sResultado + "e25: La Via no existeix. <br /> " ;
          }
      }
      if (PSEUDOVIA.DPSVIA.compareTo("") != 0)// Problema 32
      {
          if (! PSEUDOVIA.existePseudovia())
          {
            sResultado = sResultado + "e32: La Pseudovia no existeix. <br /> " ;
          }
      }
      if (NUCLI.NNUCLE.compareTo("") != 0)// Problema 67
      {
          if (! NUCLI.existeNucli())
          {
            sResultado = sResultado + "e67: El Nucli no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e140: Falta posar el Nucli. <br /> " ;
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si el Tram se puede updatear
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
              
      // El nombre ens indica el problema. 
      if (CDG_CTRM == -1)// Problema 16
      {
          sResultado = sResultado + "e16: El update requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      
      if (DIST == -1)// Problema 45
      {
          sResultado = sResultado + "e45: Falta posar el districte. <br /> " ;
      }
      if (SECC == -1)// Problema 46
      {
          sResultado = sResultado + "e46: Falta posar la secci. <br /> " ;
      }
      if (MANZ.compareTo("") == 0)// Problema 47
      {
          sResultado = sResultado + "e47: Falta posar la illa. <br /> " ;
      }
      if (TINUM == -1 || (TINUM != 0 && TINUM != 1 && TINUM != 2))// Problema 48
      {
          sResultado = sResultado + "e48: El tipus de numeraci no es correcta 0(Sense numeraci) 1(Senar) 2(Parell). <br /> " ;
      }
      if (CPOS == -1)// Problema 49
      {
          sResultado = sResultado + "e49: Falta posar el codi postal. <br /> " ;
      }
      if (VIA.NVIA.compareTo("") != 0 && PSEUDOVIA.DPSVIA.compareTo("") != 0)
      {
          sResultado = sResultado + "e50: Hi ha una Via i una Pseudovia assignades al Tram. <br /> " ;
      }
      // Comprova si las dades se adecuan a las de la base de dades.
      if (VIA.NVIA.compareTo("") != 0)
      {
          if (! VIA.existeVia())
          {
            sResultado = sResultado + "e25: La Via no existeix. <br /> " ;
          }
      }
      if (PSEUDOVIA.DPSVIA.compareTo("") != 0)
      {
          if (! PSEUDOVIA.existePseudovia())
          {
            sResultado = sResultado + "e32: La Pseudovia no existeix. <br /> " ;
          }
      }
     if (NUCLI.NNUCLE.compareTo("") != 0)
      {
          if (! NUCLI.existeNucli())//Problema 67
          {
            sResultado = sResultado + "e67: El Nucli no existeix. <br /> " ;
          }
      }
      else
      {
        sResultado = sResultado + "e140: Falta posar el Nucli. <br /> " ;
      }
      if (! existeTram() )// Problema 25
      {
        sResultado = sResultado + "e25: La Via no existeix. <br /> " ;
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la provincia se puede borrar.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (! existeTram() )// Problema 4
      {
        sResultado = sResultado + "e51: El Tram no existeix. <br /> " ;
      }
      
      if (CDG_CTRM == -1)// Problema 16
      {
          sResultado = sResultado + "e138: El delete requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      if (teHabitatge())// Problema 73
      {
         sResultado = sResultado + "e73: El Tram esta relacionat amb un Habitatge. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprova si podem fer el select.
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hi ha comprovacions.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }   
}
