/*
 * Usuari.java
 *
 * Created on 4 de mayo de 2006, 10:36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Angel Panadero
 */

public class Usuari {
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio con;                 // Nos permite conectarnos con la base de datos.
    public  ResultSet  rSelectPublic;       // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int        CDG_USR;             // Codi intern del Usuari                                           (Posat per nosaltres)
    public  int        CDG_PRV;             // Nmero de identificacin de la provincia.                        (Posat per nosaltres)
    public  int        CDG_MNC;             // Nmero que identifica la provincia.                              (Posat per nosaltres)
    public  String     NOM_USR;             // Nom del Usuari                                                   (Posat per el Usuari)
    public  String     PSW_USR;             // Password del Usuari.                                             (Posat per el Usuari)
    public  String     PSW_USR2;            // Password del Usuari.                                             (Posat per el Usuari)
    public  String     NOM;                 // Nom Real del Usuari.                                             (Posat per el Usuari)
    public  String     COGN1;               // Primer Cognom del Usuari.                                        (Posat per el Usuari)
    public  String     COGN2;               // Segon Cognom del Usuari.                                         (Posat per el Usuari)
    public  String     NOM_PRV;             // Nom de la Provincia.                                             (Posat per el Usuari)
    public  String     NMUN;                // Nom del Municipi.                                                (Posat per el Usuari)
    // Relacionada con Errores
    public  String     sError;              // Guardamos todos los errores generados.
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    // Creates a new instance of PDRNucli 
    public Usuari() 
    {
        // Relacionada con la base de datos
        con           = null;               
        rSelectPublic = null;     
        // De la base de datos
        CDG_USR       = -1;
        CDG_PRV       = -1;             
        CDG_MNC       = -1;             
        NOM_USR       = "";
        PSW_USR       = "";
        NOM           = "";
        COGN1         = "";
        COGN2         = "";
        NOM_PRV       = "";
        NMUN          = "";
        
        // Relacionada con Errores
        sError              = "";         
        // Relacionadas con estado de los botones.
        sSiguiente          = "disabled";
        sAnterior           = "disabled";
    }
    
    // Creates a new instance of PDRNucli 
    public Usuari(BDConnexio conexion)
    {
        // Relacionada con la base de datos
        con           = conexion;               
        rSelectPublic = null;     
        // De la base de datos
        CDG_USR       = -1;
        CDG_PRV       = -1;             
        CDG_MNC       = -1;          
        NOM_USR       = "";
        PSW_USR       = "";
        NOM           = "";
        COGN1         = "";
        COGN2         = "";
        NOM_PRV       = "";
        NMUN          = "";     
        
        // Relacionada con Errores
        sError              = "";         
        // Relacionadas con estado de los botones.
        sSiguiente          = "disabled";
        sAnterior           = "disabled";
    }
    
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion.
    public void reiniciar()
    {        
        // Relacionada con la base de datos              
        rSelectPublic       = null;     
        // De la base de datos 
        CDG_USR       = -1;           
        CDG_PRV       = -1;             
        CDG_MNC       = -1;          
        NOM_USR       = "";
        PSW_USR       = "";
        NOM           = "";
        COGN1         = "";
        COGN2         = "";
        NOM_PRV       = "";
        NMUN          = "";    
        
        // Relacionada con Errores
        sError              = "";        
        // Relacionadas con estado de los botones.
        sSiguiente          = "disabled";
        sAnterior           = "disabled";
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {
        try
        {
            // Dades de PDR_DDSENTCLC
            CDG_USR       = Integer.parseInt(rSelect.getString("CDG_USR"));     
            CDG_PRV       = Integer.parseInt(rSelect.getString("CDG_PRV"));     
            CDG_MNC       = Integer.parseInt(rSelect.getString("CDG_MNC"));        
            NOM_USR       = rSelect.getString("NOM_USR");
            PSW_USR       = rSelect.getString("PSW_USR");
            NOM           = rSelect.getString("NOM");
            COGN1         = rSelect.getString("COGN1");
            COGN2         = rSelect.getString("COGN2");
            NOM_PRV       = rSelect.getString("NOM_PRV");
            NMUN          = rSelect.getString("NMUN");       
        }   catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
            {con.cnPrincipal.rollback();
            }catch (Exception e2)
            {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Inserta los datos del Usuari en la taula de PDR_USUARI.
    public void insert()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador UsrNum;
      
      // Instroducimos las tablas para que se pueden llevar a cabo los deletes.
      // Miramos si el municipi existeix per si un altre usuari amb les mateixes caracteristiques ha sigut inserit.
      PDRMunicipi municipi = new PDRMunicipi(con);
      try
      {  
          sbSql = null;
          stmt = con.cnPrincipal.createStatement();
          
        if (! municipi.existeMunicipiCodi(CDG_PRV, CDG_MNC))
        {
          
        
          sbSql = new StringBuffer("");
          // Crear una Un Municipio para el primer usuario.
          sbSql.append("insert into PDR_MNC (CDG_PRV, CDG_MNC, CUN, NMUN, NMUN50, NMUNC, DSC_MNC) values ("+ CDG_PRV +","+ CDG_MNC +",0,'m"+ CDG_MNC +"','m','m','prueba')");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");
         
          //Via
          sbSql.append("Insert into PDR_VIA (CDG_PRV, CDG_MNC, CDG_VIA) values("+ CDG_PRV +","+ CDG_MNC +",-1)");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");
         
          sbSql.append("Insert into PDR_DDSVIA (CDG_PRV, CDG_MNC, DDSVIA_CVIA, TPSVIA_CTIPVIA, POS, NVIA, NVIAC ,CVIA) values ("+ CDG_PRV +", "+ CDG_MNC +",-1,-1,0,'v666', 'v666', 0)");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");
         
          //Pseudovia
          sbSql.append("Insert into PDR_PSD (CDG_PRV, CDG_MNC, CDG_CPSVIA) values ("+ CDG_PRV +" , "+ CDG_MNC +", -1)");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");
         
          sbSql.append("Insert into PDR_DDSPSD (CDG_PRV, CDG_MNC, DDSPSD_CPSVIA, DPSVIA, CPSVIA) values ("+ CDG_PRV +" , "+ CDG_MNC +", -1, 'ps666',0)");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");     
         
          //Tram
          sbSql.append("Insert into PDR_TRM (CDG_PRV, CDG_MNC, CDG_CTRM) values ("+ CDG_PRV  +" , "+ CDG_MNC +", -1)");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");
         
          sbSql.append("Insert into PDR_DDSTRM (CDG_PRV, CDG_MNC, DDSTRM_CTRM, CDG_CNCL, CDG_CPSVIA, CDG_VIA, CUN, DIST, SECC, LSECC, SUBSC, MANZ, TINUM, EIN, CEIN, ESN, CESN, CPOS) values ( "+ CDG_PRV +", "+ CDG_MNC +", -1, -1, -1, -1, 0, 01, 01, 'B', 'B', 125, 0, null, null, null, null, 08907)");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");

          //Entitat Colectiva
          sbSql.append("Insert into PDR_ENTCLC    (CDG_PRV, CDG_MNC, CDG_CCLC) values ("+ CDG_PRV +","+ CDG_MNC +",-1)");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");
         
          sbSql.append("Insert into PDR_DDSENTCLC (CDG_PRV, CDG_MNC, DDSENTCLC_CCLC, CUN, NENTCO, NENTCO50, NENTCOC) values ("+ CDG_PRV +","+ CDG_MNC +",-1,0,'ec666','ec666','ec666')");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");
         
          //Entitat Singular
          sbSql.append("Insert into PDR_ENTSNG (CDG_PRV, CDG_MNC, CDG_CSNG) values ("+ CDG_PRV +","+ CDG_MNC +",-1)");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");
         
          sbSql.append("Insert into PDR_DDSENTSNG (CDG_PRV, CDG_MNC, DDSENTSNG_CSNG, CUN, CDG_CCLC, NENTSI, NENTSI50, NENTSIC) values ("+ CDG_PRV +","+ CDG_MNC +",-1,0,-1,'es666','es666','es666')");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");
         
          //Nucli
          sbSql.append("Insert into PDR_DDSNCL (CDG_PRV, CDG_MNC, DDSNCL_CNCL, CUN, CDG_CSNG, NNUCLE, NNUCLE50, NNUCLEC) values ("+ CDG_PRV +","+ CDG_MNC +",-1,0,-1,'n666','n666','n666')");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");
         
          //Habitatge
          sbSql.append("insert into PDR_HABITATGE (CDG_PRV, CDG_MNC, CDG_CHBTG, CDG_CTRM, NHOP, CDG_CPSVIA,NUMER, CNUMER, NUMERS, CNUMERS, KMT, HMT, BLOQ, PORT, ESCA, PLAN, PUER, TLOC) values ( "+ CDG_PRV +", "+ CDG_MNC +", -1, -1, 0, -1, -1, 'a', -1, 'a', 0, 0, '00', '00', '00', '000', '0000', '1')");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");
         
          //Habitant
          sbSql.append("insert into PDR_DDSHBT (CDG_PRV, CDG_MNC, DDSHBT_CHBT, PRDP, MUDP, NIA, NIE, NOMB, PART1, APE1, PART2, APE2, SEXO, CPRON, CMUNN, FNAC, TIDEN, LEXTR, IDEN, LIDEN, NDOCU, CNES, NACI, CODP) values ( "+ CDG_PRV +", "+ CDG_MNC +", -1, -2, -2, '00', -1, 'Nombre' , 'Part1', 'Apellido1', 'Part2', 'Apellido2', -2, -2, -2, to_date('01/01/2006:00:00:00','DD/MM/YYYY:HH24:MI:SS'), -2, 'L', 0, 'L', 'NumeroDocumento', -2, -2, -2)");
          stmt.executeUpdate(sbSql.toString());
          sbSql = new StringBuffer("");

        }
      
      UsrNum = new PDRNumerador(con); 
      
          // Possem un numero al Usuari.
          UsrNum.NMR_NOM = "NMR_Usr";
          UsrNum.select();
          CDG_USR = UsrNum.NMR_VLR;
      
          sbSql = null;
      
          // Preparem la sentncia SQL per inseri en PDR_DDSENTCLC
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_USUARI ");
          sbSql.append(" (CDG_USR, PSW_USR, NOM_USR, NOM, COGN1, COGN2, CDG_PRV, NOM_PRV, CDG_MNC, NMUN, Estado) ");
          sbSql.append(" values ");
          sbSql.append("('"+  CDG_USR +"', '"+ PSW_USR +"', '"+ NOM_USR +"', '");
          sbSql.append(       NOM     +"', '"+ COGN1   +"', '"+ COGN2   +"', '");
          sbSql.append(       CDG_PRV +"', '"+ NOM_PRV +"', '"+ CDG_MNC +"', '");
          sbSql.append(       NMUN     +"', 'Actiu' )");
          
          stmt.executeUpdate(sbSql.toString());
          
        stmt.close();
        con.cnPrincipal.commit();
      } catch (Exception e)
      {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Fa un Update de les dades d'un Usuari en la taula PDR_USUARI
    public void update()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      
      try
      {
          sbSql = null;
      
          stmt = con.cnPrincipal.createStatement();
          // Preparem la sentncia SQL per inseri en PDR_DDSENTCLC
          sbSql = new StringBuffer("");
          sbSql.append("UPDATE PDR_USUARI ");
          sbSql.append(" SET ");
          sbSql.append(" PSW_USR = '" + PSW_USR + "', ");
          sbSql.append(" NOM_USR = '" + NOM_USR + "', ");
          sbSql.append(" NOM     = '" + NOM     + "', ");
          sbSql.append(" COGN1   = '" + COGN1   + "', ");
          sbSql.append(" COGN2   = '" + COGN2   + "', ");
          sbSql.append(" NOM_PRV = '" + NOM_PRV + "', ");
          sbSql.append(" CDG_MNC = '" + CDG_MNC + "', ");
          sbSql.append(" NMUN    = '" + NMUN +    "'");
          sbSql.append(" WHERE ");
          sbSql.append(" CDG_USR = '" + CDG_USR + "'");
          
          stmt.executeUpdate(sbSql.toString());
          
        stmt.close();
        con.cnPrincipal.commit();
      } catch (Exception e)
      {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Fa un Update de estado per posarlo a Baixa
    public void delete()
    {
        // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      
      try
      {
          sbSql = null;
      
          stmt = con.cnPrincipal.createStatement();
          // Preparem la sentncia SQL per inseri en PDR_DDSENTCLC
          sbSql = new StringBuffer("");
          sbSql.append("UPDATE PDR_USUARI ");
          sbSql.append(" SET ");
          sbSql.append(" Estado = 'Baixa' ");
          sbSql.append(" WHERE ");
          sbSql.append(" CDG_USR = '" + CDG_USR + "'");
          
          stmt.executeUpdate(sbSql.toString());
          
        stmt.close();
        con.cnPrincipal.commit();
      } catch (Exception e)
      {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Fa un select d'una o un grup de Entitats Singualr
    public void select()
    {
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        ResultSet rSelect;
      
        sbSql = null;
        try
        {
            // Cerramos el select anterior
            if (rSelectPublic != null){rSelectPublic.close();} 
            
            stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );
            
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_USUARI USR");
            sbSql.append(" where ");
            sbSql.append("  ( USR.NOM_USR   ='"+ NOM_USR +"' or ");
            sbSql.append(   "'"+NOM_USR           +"'    = '') and");
            sbSql.append("  ( USR.NOM   ='"+ NOM +"' or ");
            sbSql.append(   "'"+NOM           +"'    = '') and");
            sbSql.append("  ( USR.COGN1   ='"+ COGN1 +"' or ");
            sbSql.append(   "'"+COGN1           +"'    = '') and");
            sbSql.append("  ( USR.COGN2   ='"+ COGN2 +"' or ");
            sbSql.append(   "'"+COGN2           +"'    = '') and");
            sbSql.append("  ( USR.NOM_PRV   ='"+ NOM_PRV +"' or ");
            sbSql.append(   "'"+NOM_PRV           +"'    = '') and");
            sbSql.append("  ( USR.NMUN      ='"+ NMUN +"' or ");
            sbSql.append(   "'"+NMUN           +"'    = '') and");
            sbSql.append("  USR.Estado <> 'Baixa'  ");
            sbSql.append("  order by USR.NOM_USR ");
        
            rSelect = stmt.executeQuery(sbSql.toString());
        
            if (rSelect.next())
            {
                rellenar(rSelect);
                rSelectPublic = rSelect;
           
                // Desbloqueamos o bloqueamos los botones que haga falta.
                if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
                if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
            }
            else
            {
               sError = sError + "e143: No existeixen Usuaris amb aquestes caracterstiques." +"<br />";
               rSelectPublic = null;
               // Desactivamos los botones de siguiente y anteriror.
               sSiguiente    = "disabled";
               sAnterior     = "disabled";
            }

        } catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
            {con.cnPrincipal.rollback();
            }catch (Exception e2)
            {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }

    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }

    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }

    // Comprueba si el nom del Usuari existeix.
    public boolean existeNomUsr()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_USUARI USR");
            sbSql.append(" where ");
            sbSql.append("  USR.NOM_USR   ='"+ NOM_USR +"' and");
            sbSql.append("  USR.CDG_USR  !='"+ CDG_USR +"' and");
            sbSql.append("  USR.Estado <> 'Baixa' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprova si el cod existeix.
    public boolean existeCDGUSR()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_USUARI USR");
            sbSql.append(" where ");
            sbSql.append("  USR.CDG_USR  ='"+ CDG_USR +"' and");
            sbSql.append("  USR.Estado <> 'Baixa'  ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Posar a CDG_PRV el codi de la provincia que correspon a NOM_PRV.
    public void obteniCDG_PRV ()
    {
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append("     PDR_PRV ");
            sbSql.append(" where ");     
            sbSql.append("  NOM_PRV = '"+ NOM_PRV + "' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              CDG_PRV = Integer.parseInt(rs.getString("CDG_PRV"));
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Posar a CDG_MNC el codi del Municipi que correspon a NMUN.
    public void obteniCDG_MNC ()
    {
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append("     PDR_MNC ");
            sbSql.append(" where ");     
            sbSql.append("   NMUN    = '"+ NMUN + "' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              CDG_MNC = Integer.parseInt(rs.getString("CDG_MNC"));
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Ens dona un desplegable amb totes les opcions per Provincies.
    public String MostrarProvincia ()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRProvincia oProv;
        int          i;
        
        sResultat = new StringBuffer("");
        oProv     = new PDRProvincia(con);
        i = 0;
        
        try
        {
            // obtenim els Tots els Tipus de Via
            rSelect = oProv.TotsProvincia();
            
            sResultat.append("<SELECT NAME=\"NOM_PRV\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com Provincies hi aixin.
            while (rSelect.next())
            {      
                oProv.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oProv.NOM_PRV +"\"");
                if (NOM_PRV.compareTo(oProv.NOM_PRV) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oProv.NOM_PRV+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Ens dona un desplegable amb totes les opcions per Provincies.
    public String MostrarMunicipi ()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRMunicipi  oMnc;
        int          i;
        
        sResultat = new StringBuffer("");
        oMnc     = new PDRMunicipi(con);
        i = 0;
        
        try
        {
            // obtenim els Tots els Tipus de Via
            rSelect = oMnc.TotsMunicipi();
            
            sResultat.append("<SELECT NAME=\"NMUN\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com Provincies hi aixin.
            while (rSelect.next())
            {      
                oMnc.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oMnc.NMUN +"\"");
                if (NMUN.compareTo(oMnc.NMUN) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oMnc.NMUN+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Comprova si el Usuari es correcta per inserir-lo.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      
      // Posem perque funcioni la comprovacio de si existeix el nom.
      CDG_USR = -1;
      
      // El nombre ens indica el problema. 
      if (NOM_USR.compareTo("")==0)// Problema 144
      {
          sResultado = sResultado + "e144: Falta posar el nom del Usuari. <br /> " ;
      }
      if (existeNomUsr())// Problema 145
      {
          sResultado = sResultado + "e145: El nom del Usuari ja existeix. <br /> " ;
      }
      if (PSW_USR.compareTo("")!=0 && PSW_USR2.compareTo("")!=0)// Problema 146 i 147
      {
          if (PSW_USR.compareTo(PSW_USR2)!=0)
          {
            sResultado = sResultado + "e147: Els dos Passwords tenen que coincidir. <br /> " ;
          }
      }
      else
      {
          sResultado = sResultado + "e146: Falta posar el Password. <br /> " ;
      }
      if (NOM.compareTo("")==0)// Problema 148
      {
          sResultado = sResultado + "e148: Falta posar el nom. <br /> " ;
      }
      if (COGN1.compareTo("")==0)// Problema 149
      {
          sResultado = sResultado + "e149: Falta posar el Primer Cognom del Usuari. <br /> " ;
      }
      if (COGN2.compareTo("")==0)// Problema 150
      {
          sResultado = sResultado + "e150: Falta posar el Segon Cognom del Usuari. <br /> " ;
      }
      if (NOM_PRV.compareTo("")==0)// Problema 150
      {
          sResultado = sResultado + "e151: Falta posar la Provncia. <br /> " ;
      }
      if (NMUN.compareTo("")==0)// Problema 150
      {
          sResultado = sResultado + "e152: Falta posar el Municipi. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si el Usuari es pot updatear
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
              
      // El nombre ens indica el problema. 
      if (CDG_USR == -1)// Problema 16
      {
          sResultado = sResultado + "e16: El update requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      
      if (! existeCDGUSR())// Problema 153
      {
        sResultado = sResultado + "e153: El Usuari no existeix. <br /> " ;
      }
      
      // El nombre ens indica el problema. 
      if (NOM_USR.compareTo("")==0)// Problema 144
      {
          sResultado = sResultado + "e144: Falta posar el nom del Usuari. <br /> " ;
      }
      if (existeNomUsr())// Problema 145
      {
          sResultado = sResultado + "e145: El nom del Usuari ja existeix. <br /> " ;
      }
      if (PSW_USR.compareTo("")!=0 && PSW_USR2.compareTo("")!=0)// Problema 146 i 147
      {
          if (PSW_USR.compareTo(PSW_USR2)!=0)
          {
            sResultado = sResultado + "e147: Els dos Passwords tenen que coincidir. <br /> " ;
          }
      }
      else
      {
          sResultado = sResultado + "e146: Falta posar el Password. <br /> " ;
      }
      if (NOM.compareTo("")==0)// Problema 148
      {
          sResultado = sResultado + "e148: Falta posar el nom. <br /> " ;
      }
      if (COGN1.compareTo("")==0)// Problema 149
      {
          sResultado = sResultado + "e149: Falta posar el Primer Cognom del Usuari. <br /> " ;
      }
      if (COGN2.compareTo("")==0)// Problema 150
      {
          sResultado = sResultado + "e150: Falta posar el Segon Cognom del Usuari. <br /> " ;
      }
      if (NOM_PRV.compareTo("")==0)// Problema 150
      {
          sResultado = sResultado + "e151: Falta posar la Provncia. <br /> " ;
      }
      if (NMUN.compareTo("")==0)// Problema 150
      {
          sResultado = sResultado + "e152: Falta posar el Municipi. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si el Nucli es pot esborra.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (CDG_USR == -1)// Problema 16
      {
          sResultado = sResultado + "e16: El update requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      
      if (! existeCDGUSR())// Problema 153
      {
        sResultado = sResultado + "e153: El Usuari no existeix. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprova si podem fer el select.
    
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hi ha comprovacions.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
     
    
}
