/*
 * PDREntSingular.java
 *
 * Created on 15 de marzo de 2006, 10:27
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;

import java.io.*;
import java.net.*;
import java.sql.*;
//import java.util.GregorianCalendar;

/**
 * @author Miguel Angel Panadero
 */

public class PDREntSingular {
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio con;                 // Nos permite conectarnos con la base de datos.
    public  ResultSet  rSelectPublic;       // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int        CDG_PRV;             // Nmero de identificacin de la provincia.                        (Posat per nosaltres)
    public  int        CDG_MNC;             // Nmero que identifica la provincia.                              (Posat per nosaltres)
    public  int        CDG_CSNG;            // Nmero que indentifica la Entitat Singular                       (Posat per nosaltres)
    public  int        DDSENTSNG_CSNG;      // Nmero de identificacin de las dades de la Entitat Singular.    (Posat per nosaltres)
    public  int        CUN;                 // Cdi Unitat Poblacional                                          (Posat per l'Ine) 
    public  String     NENTSI;              // Nom de la Entitat Singular.                                      (Posat per l'usuari)
    public  String     NENTSI50;            // Nom de la Entitat Singular de 50 caracters.                      (Posat per l'usuari)
    public  String     NENTSIC;             // Nom de la Entitat Singular corto.                                (Posat per l'usuari)
    private String     FVAR;                // Data del cambi.                                                  (Posat per nosaltres)
    public  String     CVAR;                // Codi de Variacio                                                 (Posat per nosaltres)
    private String     Envio;               // Ens indica si esta enviat al Ine.                                (Posat per nosaltres)
    // Contenedores de otras clases.
    public  PDREntColectiva  EntColectiva;  // Objecte Entitat Colectiva.                                       (Posat per l'usuari)
    // Relacionada con Errores
    public  String     sError;        // Guardamos todos los errores generados.
    // Dades del Usuari
    public  int        CDG_USR;       // Nmero que identifica al usuari que esta realitzan les accion (Posat per nosaltres)
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    // Creates a new instance of PDREntSingular 
    public PDREntSingular(int USR) 
    {
        // Relacionada con la base de datos
        con                 = null;               
        rSelectPublic       = null;     
        // De la base de datos
        CDG_PRV             = -1;             
        CDG_MNC             = -1;             
        CDG_CSNG            = -1;          
        DDSENTSNG_CSNG      = -1;  
        CUN                 = -1;                  
        NENTSI              = "";         
        NENTSI50            = "";           
        NENTSIC             = "";     
        FVAR                = "";        
        CVAR                = "";          
        Envio               = "";     
        
        // Contenedores de otras clases.
        EntColectiva        = new PDREntColectiva(USR); 
        
        // Relacionada con Errores
        sError              = "";     
        // Dades del Usuari
        CDG_USR             = USR;      
        // Relacionadas con estado de los botones.
        sSiguiente          = "disabled";
        sAnterior           = "disabled";
    }
    public PDREntSingular(BDConnexio conexion, int USR) 
    {
        // Relacionada con la base de datos
        con                 = conexion;               
        rSelectPublic       = null;     
        // De la base de datos
        CDG_PRV             = -1;             
        CDG_MNC             = -1;             
        CDG_CSNG            = -1;          
        DDSENTSNG_CSNG      = -1;  
        CUN                 = -1;                  
        NENTSI              = "";         
        NENTSI50            = "";           
        NENTSIC             = "";     
        FVAR                = "";        
        CVAR                = "";          
        Envio               = "";     
        
        // Contenedores de otras clases.
        EntColectiva        = new PDREntColectiva(conexion, USR);  
        // Relacionada con Errores
        sError              = "";     
        // Dades del Usuari
        CDG_USR             = USR;      
        // Relacionadas con estado de los botones.
        sSiguiente          = "disabled";
        sAnterior           = "disabled";
    }
    
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    public void reiniciar()
    {        
        // Relacionada con la base de datos               
        rSelectPublic       = null;     
        // De la base de datos           
        CDG_CSNG            = -1;          
        DDSENTSNG_CSNG      = -1;  
        CUN                 = -1;                  
        NENTSI              = "";         
        NENTSI50            = "";           
        NENTSIC             = "";     
        FVAR                = "";        
        CVAR                = "";          
        Envio               = "";     
        
        // Contenedores de otras clases.
        EntColectiva        = new PDREntColectiva(con, CDG_USR);  
        // Relacionada con Errores
        sError              = "";        
        // Relacionadas con estado de los botones.
        sSiguiente          = "disabled";
        sAnterior           = "disabled";
    
    }
     // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {
        try
        {
            // Dades de PDR_DDSENTCLC
            CDG_PRV             = Integer.parseInt(rSelect.getString("CDG_PRV"));     
            CDG_MNC             = Integer.parseInt(rSelect.getString("CDG_MNC"));       
            DDSENTSNG_CSNG      = Integer.parseInt(rSelect.getString("DDSENTSNG_CSNG")); 
            CUN                 = Integer.parseInt(rSelect.getString("CUN"));       
            NENTSI              = rSelect.getString ("NENTSI");        
            NENTSI50            = rSelect.getString ("NENTSI50");      
            NENTSIC             = rSelect.getString ("NENTSIC");      
               
            // Dades de PDR_PSD_has_DDSPSD que no estan en l'altre.
            CDG_CSNG            = Integer.parseInt(rSelect.getString("CDG_CSNG")); 
            FVAR                = rSelect.getString ("FVAR");        
            CVAR                = rSelect.getString ("CVAR");      
            Envio               = rSelect.getString ("Envio");
            // Carguem les dades de la via.
            if (Integer.parseInt(rSelect.getString("CDG_CCLC")) != -1)
            {
                EntColectiva.CDG_PRV = CDG_PRV;
                EntColectiva.CDG_MNC = CDG_MNC;
                EntColectiva.darEntColectiva(Integer.parseInt(rSelect.getString("CDG_CCLC")),"");
                // Intoduim el posibles error en els errors d'aquest objecte.
                if (EntColectiva.sError.compareTo("") != 0)
                {
                   sError = sError + EntColectiva.sError + "<br />"; 
                }
            }
            else
            {
                EntColectiva.reiniciar();
            }
        }   catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
            {con.cnPrincipal.rollback();
            }catch (Exception e2)
            {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Inserta los datos de la Entitat Singular en la taula de PDR_DDSENTSNG.
    // Inserta la Entitat Singular en la taula de PDR_ENTSNG.
    // Inserta la relaci Entitat Singular-dades en la taula de PDR_ENTSNG_has_DDSENTSNG.
    public void insert()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador EntSngNum;
      
      //Date
      Data dFecha;
      
      EntSngNum = new PDRNumerador(con); 
      try
      {
          // Possem un numero a les dades de la Entitat Colectiva.
          EntSngNum.NMR_NOM = "NMR_DDSENTSNG";
          EntSngNum.select();
          DDSENTSNG_CSNG = EntSngNum.NMR_VLR;
      
          sbSql = null;
      
          stmt = con.cnPrincipal.createStatement();
          // Preparem la sentncia SQL per inseri en PDR_DDSENTCLC
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_DDSENTSNG ");
          sbSql.append(" (CDG_PRV, CDG_MNC, DDSENTSNG_CSNG, CUN, CDG_CCLC, NENTSI, NENTSI50, NENTSIC) ");
          sbSql.append(" values ");
          sbSql.append("('"+  CDG_PRV        +"', '"+ CDG_MNC  +"', '"+ DDSENTSNG_CSNG  +"',   -1, '");
          sbSql.append( EntColectiva.CDG_CCLC+"', '"+ NENTSI   +"', '"+ NENTSI50        +"', '"+ NENTSIC +"')");
          
          stmt.executeUpdate(sbSql.toString());
          
          // Posem un numero intern a la Entitta Colectiva
          EntSngNum.NMR_NOM = "NMR_ENTSNG";
          EntSngNum.select();
          CDG_CSNG = EntSngNum.NMR_VLR;
          
          // Preparem la sentncia SQL per inseri en PDR_ENTSNG
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_ENTSNG ");
          sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CSNG) ");
          sbSql.append(" values ");
          sbSql.append("('"+ CDG_PRV +"', '"+ CDG_MNC +"', '"+ CDG_CSNG+"')");
          
          stmt.executeUpdate(sbSql.toString());
          
          // obtenim el dia al que estem.
          dFecha = new Data (con);
          
          FVAR = dFecha.darFecha();
          
          // Preparem la sentncia SQL per inseri en PDR_ENTCLCL_has_DDSENTCCLC
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_ENTSNG_has_DDSENTSNG ");
          sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CSNG, DDSENTSNG_CSNG, CDG_USR, FVAR, CVAR, Envio) ");
          sbSql.append(" values ");
          sbSql.append("('"+ CDG_PRV        +"', '"+ CDG_MNC +"', '"+ CDG_CSNG+"', '");
          sbSql.append(      DDSENTSNG_CSNG +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'A', 'N')");
          
          
        stmt.executeUpdate(sbSql.toString());
        
        stmt.close();
        con.cnPrincipal.commit();
      } catch (Exception e)
      {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Fa un insert de les dades d'una Entitat Singular en la taula PDR_DDSENTSNG
    // Fa un insert en la taulta PDR_ENTSNG_has_DDSENTSNG enllaant Entitat Singualr-Dades.
    // Es pot updateixa el nom, el nom de 50 carters, el nom curt de la Entitat Colectiva i la Entitat Colectiva.
    public void update()
    {
        // Conexio
        Statement stmt;
        StringBuffer sbSql;
        PDRNumerador EntSngNum;
        
        //Date
        Data dFecha;
        
        EntSngNum = new PDRNumerador(con);
        
        try
        {
            
            // Possem un numero a les dades de la Entitat Colectiva.
            EntSngNum.NMR_NOM = "NMR_DDSENTSNG";
            EntSngNum.select();
            DDSENTSNG_CSNG = EntSngNum.NMR_VLR;
        
            sbSql = null;
        
            stmt = con.cnPrincipal.createStatement();
            
            // Preparem la sentncia SQL per inseri en PDR_DDSENTCLC
            sbSql = new StringBuffer("");
            sbSql.append("Insert into  ");
            sbSql.append( " PDR_DDSENTSNG ");
            sbSql.append(" (CDG_PRV, CDG_MNC, DDSENTSNG_CSNG, CUN, CDG_CCLC, NENTSI, NENTSI50, NENTSIC) ");
            sbSql.append(" values ");
            sbSql.append("('"+  CDG_PRV        +"', '"+ CDG_MNC  +"', '"+ DDSENTSNG_CSNG  +"', '"+ CUN     +"','");
            sbSql.append( EntColectiva.CDG_CCLC+"', '"+ NENTSI   +"', '"+ NENTSI50        +"', '"+ NENTSIC +"')");
        
            stmt.executeUpdate(sbSql.toString());
        
            // obtenim el dia al que estem.
            dFecha = new Data (con);
          
            FVAR = dFecha.darFecha(); 
            
            // Preparem la sentncia SQL per inseri en PDR_ENTCLCL_has_DDSENTCCLC
            sbSql = new StringBuffer("");
            sbSql.append("Insert into  ");
            sbSql.append( " PDR_ENTSNG_has_DDSENTSNG ");
            sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CSNG, DDSENTSNG_CSNG, CDG_USR, FVAR, CVAR, Envio) ");
            sbSql.append(" values ");
            sbSql.append("('"+ CDG_PRV        +"', '"+ CDG_MNC +"', '"+ CDG_CSNG+"', '");
            sbSql.append(      DDSENTSNG_CSNG +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'M', 'N')");
            
            stmt.executeUpdate(sbSql.toString());
            stmt.close();
            con.cnPrincipal.commit();

        }catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
            {con.cnPrincipal.rollback();
            }catch (Exception e2)
            {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
     
    // Fa un Insert a la taula PDR_ENTSNG_has_DDSENTSNG enllaant Entitat Singualr-Dades, inserim en motiu envia a Ine Baixa
    public void delete()
    {
        // Conexio 
        Statement stmt; 
        StringBuffer sbSql;
        sbSql = null;
        
        //Date
        Data dFecha;
          
        try{
            stmt = con.cnPrincipal.createStatement();
        
            // obtenim el dia al que estem.
            dFecha = new Data (con);
          
            FVAR = dFecha.darFecha();
        
            // Preparem la sentncia SQL per inseri en PDR_ENTCLCL_has_DDSENTCCLC
            sbSql = new StringBuffer("");
            sbSql.append("Insert into  ");
            sbSql.append( " PDR_ENTSNG_has_DDSENTSNG ");
            sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CSNG, DDSENTSNG_CSNG, CDG_USR, FVAR, CVAR, Envio) ");
            sbSql.append(" values ");
            sbSql.append("('"+ CDG_PRV        +"', '"+ CDG_MNC +"', '"+ CDG_CSNG+"', ");
            sbSql.append(      "'-1', '" + CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'B', 'N')");
            
            stmt.executeUpdate(sbSql.toString());
            stmt.close();
            con.cnPrincipal.commit();
        
    }   catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'una o un grup de Entitats Singualr
    public void select()
    {
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        ResultSet rSelect;
      
        sbSql = null;
        try
        {
            // Cerramos el select anterior
            if (rSelectPublic != null){rSelectPublic.close();} 
            
            stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );
            
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_ENTSNG_has_DDSENTSNG EHS,PDR_DDSENTSNG DES");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DES.CDG_PRV        = EHS.CDG_PRV     and ");
            sbSql.append("   DES.CDG_MNC        = EHS.CDG_MNC     and ");
            sbSql.append("   DES.DDSENTSNG_CSNG = EHS.DDSENTSNG_CSNG  ");
            sbSql.append("  ) and ");
            sbSql.append("  DES.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DES.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  ( DES.CUN   ='"+ CUN    +"' or ");
            sbSql.append(   "'"+CUN +"'  = -1) and");
            sbSql.append("  ( DES.NENTSI   LIKE'%"+ NENTSI +"%' or ");
            sbSql.append(   "'"+NENTSI           +"'    = '') and");
            sbSql.append("  ( DES.NENTSI50 LIKE'%"+ NENTSI50 +"%' or ");
            sbSql.append(   "'"+NENTSI50           +"'  = '') and");
            sbSql.append("  ( DES.NENTSIC  LIKE'%"+ NENTSIC +"%' or ");
            sbSql.append(   "'"+NENTSIC           +"'   = '') and");
            sbSql.append("  ( DES.CDG_CCLC  ='"+ EntColectiva.CDG_CCLC +"' or ");
            sbSql.append(   "'"+EntColectiva.CDG_CCLC +"'   = -1) and");
            sbSql.append("  EHS.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_ENTSNG_has_DDSENTSNG EHS2,PDR_DDSENTSNG DES2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DES2.CDG_PRV        = EHS2.CDG_PRV     and ");
            sbSql.append("      DES2.CDG_MNC        = EHS2.CDG_MNC     and ");
            sbSql.append("      DES2.DDSENTSNG_CSNG = EHS2.DDSENTSNG_CSNG  ");
            sbSql.append("    ) and "); 
            sbSql.append("    EHS.CDG_CSNG = EHS2.CDG_CSNG ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DES.DDSENTSNG_CSNG < DES2.DDSENTSNG_CSNG  or ");
            sbSql.append("    DES2.DDSENTSNG_CSNG = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            sbSql.append("  order by DES.NENTSI ");
        
            rSelect = stmt.executeQuery(sbSql.toString());
        
            if (rSelect.next())
            {
                rellenar(rSelect);
                rSelectPublic = rSelect;
           
                // Desbloqueamos o bloqueamos los botones que haga falta.
                if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
                if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
            }
            else
            {
               sError = sError + "e65: No existeixen Entitats Singulars amb aquestes caracterstiques." +"<br />";
               rSelectPublic = null;
               // Desactivamos los botones de siguiente y anteriror.
               sSiguiente    = "disabled";
               sAnterior     = "disabled";
            }

        } catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
            {con.cnPrincipal.rollback();
            }catch (Exception e2)
            {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }

    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs. " + "<br />";}
    }

    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
      }
      else {sError = sError + "e8: No hi ha cerca en curs. " + "<br />";}
    }

    // Carrega la Entitat Singular en el objecte que la cridat.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public void darEntSingular(int CDG_CSNGaux, String NENTSIaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_ENTSNG_has_DDSENTSNG EHS,PDR_DDSENTSNG DES");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DES.CDG_PRV        = EHS.CDG_PRV     and ");
        sbSql.append("   DES.CDG_MNC        = EHS.CDG_MNC     and ");
        sbSql.append("   DES.DDSENTSNG_CSNG = EHS.DDSENTSNG_CSNG  ");
        sbSql.append("  ) and ");
        sbSql.append("  DES.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DES.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( EHS.CDG_CSNG  ='"+ CDG_CSNGaux    +"' or ");
        sbSql.append(   "'"+CDG_CSNGaux +"'  = -1) and");
        sbSql.append("  ( DES.NENTSI ='"+ NENTSIaux +"' or ");
        sbSql.append(   "'"+NENTSIaux           +"'    = '') and");
        sbSql.append("  EHS.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_ENTSNG_has_DDSENTSNG EHS2,PDR_DDSENTSNG DES2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DES2.CDG_PRV        = EHS2.CDG_PRV     and ");
        sbSql.append("      DES2.CDG_MNC        = EHS2.CDG_MNC     and ");
        sbSql.append("      DES2.DDSENTSNG_CSNG = EHS2.DDSENTSNG_CSNG  ");
        sbSql.append("    ) and "); 
        sbSql.append("    EHS.CDG_CSNG = EHS2.CDG_CSNG ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DES.DDSENTSNG_CSNG < DES2.DDSENTSNG_CSNG  or ");
        sbSql.append("    DES2.DDSENTSNG_CSNG = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");

        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e63: La Entitat Singular no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
           try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Carrega la Entitat Singular en el objecte que la cridat, tenin en compte el temps.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public void darEntSingular(int CDG_CSNGaux, String NENTSIaux, String Data)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_ENTSNG_has_DDSENTSNG EHS,PDR_DDSENTSNG DES");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DES.CDG_PRV        = EHS.CDG_PRV     and ");
        sbSql.append("   DES.CDG_MNC        = EHS.CDG_MNC     and ");
        sbSql.append("   DES.DDSENTSNG_CSNG = EHS.DDSENTSNG_CSNG  ");
        sbSql.append("  ) and ");
        sbSql.append("  DES.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DES.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( EHS.CDG_CSNG  ='"+ CDG_CSNGaux    +"' or ");
        sbSql.append(   "'"+CDG_CSNGaux +"'  = -1) and");
        sbSql.append("  ( DES.NENTSI ='"+ NENTSIaux +"' or ");
        sbSql.append(   "'"+NENTSIaux           +"'    = '') and");
        sbSql.append("  EHS.CVAR <> 'B' and ");
        sbSql.append("  EHS.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_ENTSNG_has_DDSENTSNG EHS2,PDR_DDSENTSNG DES2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DES2.CDG_PRV        = EHS2.CDG_PRV     and ");
        sbSql.append("      DES2.CDG_MNC        = EHS2.CDG_MNC     and ");
        sbSql.append("      DES2.DDSENTSNG_CSNG = EHS2.DDSENTSNG_CSNG  ");
        sbSql.append("    ) and "); 
        sbSql.append("    EHS.CDG_CSNG = EHS2.CDG_CSNG and");
        sbSql.append("    EHS2.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("    (");
        sbSql.append("    DES.DDSENTSNG_CSNG < DES2.DDSENTSNG_CSNG  or ");
        sbSql.append("    DES2.DDSENTSNG_CSNG = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");

        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e63: La Entitat Singular no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
           try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }    
    
    // Recopera la Entitat Singular que ens han marcat a una data o ens retorna totes les d'una data si no ens han marcat cap.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarEntSingulars (String sData)
    {    
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_ENTSNG_has_DDSENTSNG EHS,PDR_DDSENTSNG DES");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DES.CDG_PRV        = EHS.CDG_PRV     and ");
        sbSql.append("   DES.CDG_MNC        = EHS.CDG_MNC     and ");
        sbSql.append("   DES.DDSENTSNG_CSNG = EHS.DDSENTSNG_CSNG  ");
        sbSql.append("  ) and ");
        sbSql.append("  DES.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DES.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( EHS.CDG_CSNG  ='"+ CDG_CSNG    +"' or ");
        sbSql.append(   "'"+CDG_CSNG +"'  = -1) and");
        sbSql.append("  ( DES.NENTSI ='"+ NENTSI +"' or ");
        sbSql.append(   "'"+NENTSI           +"'    = '') and");
        sbSql.append("  EHS.CVAR <> 'B' and ");
        sbSql.append("  EHS.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_ENTSNG_has_DDSENTSNG EHS2,PDR_DDSENTSNG DES2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DES2.CDG_PRV        = EHS2.CDG_PRV     and ");
        sbSql.append("      DES2.CDG_MNC        = EHS2.CDG_MNC     and ");
        sbSql.append("      DES2.DDSENTSNG_CSNG = EHS2.DDSENTSNG_CSNG  ");
        sbSql.append("    ) and "); 
        sbSql.append("    EHS.CDG_CSNG = EHS2.CDG_CSNG and");
        sbSql.append("    EHS2.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("    (");
        sbSql.append("    DES.DDSENTSNG_CSNG < DES2.DDSENTSNG_CSNG  or ");
        sbSql.append("    DES2.DDSENTSNG_CSNG = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Recopera la Entitat Singular (de una entitat colectiva) que ens han marcat a una data 
    // o ens retorna totes les d'una data si no ens han marcat cap.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarEntSingulars (PDR.PDREntColectiva EntColectiva, String sData)
    {    
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_ENTSNG_has_DDSENTSNG EHS,PDR_DDSENTSNG DES");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DES.CDG_PRV        = EHS.CDG_PRV     and ");
        sbSql.append("   DES.CDG_MNC        = EHS.CDG_MNC     and ");
        sbSql.append("   DES.DDSENTSNG_CSNG = EHS.DDSENTSNG_CSNG  ");
        sbSql.append("  ) and ");
        sbSql.append("  DES.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DES.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  (");
        sbSql.append("   Des.CDG_CCLC = '"+ EntColectiva.CDG_CCLC +"' or ");
        sbSql.append(    EntColectiva.CDG_CCLC + "= -1 "); 
        sbSql.append("  ) and ");
        sbSql.append("  ( EHS.CDG_CSNG  ='"+ CDG_CSNG    +"' or ");
        sbSql.append(   "'"+CDG_CSNG +"'  = -1) and");
        sbSql.append("  ( DES.NENTSI ='"+ NENTSI +"' or ");
        sbSql.append(   "'"+NENTSI           +"'    = '') and");
        sbSql.append("  EHS.CVAR <> 'B' and ");
        sbSql.append("  EHS.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_ENTSNG_has_DDSENTSNG EHS2,PDR_DDSENTSNG DES2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DES2.CDG_PRV        = EHS2.CDG_PRV     and ");
        sbSql.append("      DES2.CDG_MNC        = EHS2.CDG_MNC     and ");
        sbSql.append("      DES2.DDSENTSNG_CSNG = EHS2.DDSENTSNG_CSNG  ");
        sbSql.append("    ) and "); 
        sbSql.append("    EHS.CDG_CSNG = EHS2.CDG_CSNG and");
        sbSql.append("    EHS2.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("    (");
        sbSql.append("    DES.DDSENTSNG_CSNG < DES2.DDSENTSNG_CSNG  or ");
        sbSql.append("    DES2.DDSENTSNG_CSNG = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Comprueba si la Entitat Singular existeix.
    public boolean existeEntSingular()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_ENTSNG_has_DDSENTSNG EHS,PDR_DDSENTSNG DES");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DES.CDG_PRV        = EHS.CDG_PRV     and ");
            sbSql.append("   DES.CDG_MNC        = EHS.CDG_MNC     and ");
            sbSql.append("   DES.DDSENTSNG_CSNG = EHS.DDSENTSNG_CSNG  ");
            sbSql.append("  ) and ");
            sbSql.append("  DES.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DES.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  ( EHS.CDG_CSNG ='"+ CDG_CSNG    +"' or ");
            sbSql.append(   "'"+CDG_CSNG      +"'  = -1) and");
            sbSql.append("  ( DES.NENTSI   ='"+ NENTSI +"' or ");
            sbSql.append(   "'"+NENTSI        +"'  = '') and");
            sbSql.append("  EHS.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_ENTSNG_has_DDSENTSNG EHS2,PDR_DDSENTSNG DES2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DES2.CDG_PRV        = EHS2.CDG_PRV     and ");
            sbSql.append("      DES2.CDG_MNC        = EHS2.CDG_MNC     and ");
            sbSql.append("      DES2.DDSENTSNG_CSNG = EHS2.DDSENTSNG_CSNG  ");
            sbSql.append("    ) and "); 
            sbSql.append("    EHS.CDG_CSNG = EHS2.CDG_CSNG ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DES.DDSENTSNG_CSNG < DES2.DDSENTSNG_CSNG  or ");
            sbSql.append("    DES2.DDSENTSNG_CSNG = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }

    // Comprova si el cod existeix.
    public boolean existeCDGCSNG()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_ENTSNG_has_DDSENTSNG EHS,PDR_DDSENTSNG DES");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DES.CDG_PRV        = EHS.CDG_PRV     and ");
            sbSql.append("   DES.CDG_MNC        = EHS.CDG_MNC     and ");
            sbSql.append("   DES.DDSENTSNG_CSNG = EHS.DDSENTSNG_CSNG  ");
            sbSql.append("  ) and ");
            sbSql.append("  DES.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DES.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  EHS.CDG_CSNG ='"+ CDG_CSNG    +"' and ");
            sbSql.append("  EHS.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_ENTSNG_has_DDSENTSNG EHS2,PDR_DDSENTSNG DES2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DES2.CDG_PRV        = EHS2.CDG_PRV     and ");
            sbSql.append("      DES2.CDG_MNC        = EHS2.CDG_MNC     and ");
            sbSql.append("      DES2.DDSENTSNG_CSNG = EHS2.DDSENTSNG_CSNG  ");
            sbSql.append("    ) and "); 
            sbSql.append("    EHS.CDG_CSNG = EHS2.CDG_CSNG ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DES.DDSENTSNG_CSNG < DES2.DDSENTSNG_CSNG  or ");
            sbSql.append("    DES2.DDSENTSNG_CSNG = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprova si el nom ya existeix.
    public boolean existeNENTSI()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_ENTSNG_has_DDSENTSNG EHS,PDR_DDSENTSNG DES");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DES.CDG_PRV        = EHS.CDG_PRV     and ");
            sbSql.append("   DES.CDG_MNC        = EHS.CDG_MNC     and ");
            sbSql.append("   DES.DDSENTSNG_CSNG = EHS.DDSENTSNG_CSNG  ");
            sbSql.append("  ) and ");
            sbSql.append("  DES.CDG_PRV   ='"+ CDG_PRV   +"' and ");
            sbSql.append("  DES.CDG_MNC   ='"+ CDG_MNC   +"' and ");
            sbSql.append("  DES.NENTSI    ='"+ NENTSI   +"' and ");
            sbSql.append("  EHS.CDG_CSNG !='"+ CDG_CSNG +"' and ");
            sbSql.append("  EHS.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_ENTSNG_has_DDSENTSNG EHS2,PDR_DDSENTSNG DES2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DES2.CDG_PRV        = EHS2.CDG_PRV     and ");
            sbSql.append("      DES2.CDG_MNC        = EHS2.CDG_MNC     and ");
            sbSql.append("      DES2.DDSENTSNG_CSNG = EHS2.DDSENTSNG_CSNG  ");
            sbSql.append("    ) and "); 
            sbSql.append("    EHS.CDG_CSNG = EHS2.CDG_CSNG ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DES.DDSENTSNG_CSNG < DES2.DDSENTSNG_CSNG  or ");
            sbSql.append("    DES2.DDSENTSNG_CSNG = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprova si te asignat algn Nucli.
    public boolean teNucli()
    {
        boolean bResultado;
        bResultado = false;
       
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_NCL_has_DDSNCL EHN,PDR_DDSNCL DEN");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DEN.CDG_PRV     = EHN.CDG_PRV     and ");
            sbSql.append("   DEN.CDG_MNC     = EHN.CDG_MNC     and ");
            sbSql.append("   DEN.DDSNCL_CNCL = EHN.DDSNCL_CNCL  ");
            sbSql.append("  ) and ");
            sbSql.append("  DEN.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DEN.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  CDG_CSNG  = '"+ CDG_CSNG + "' and");
            sbSql.append("  EHN.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_NCL_has_DDSNCL EHN2,PDR_DDSNCL DEN2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DEN2.CDG_PRV     = EHN2.CDG_PRV     and ");
            sbSql.append("      DEN2.CDG_MNC     = EHN2.CDG_MNC     and ");
            sbSql.append("      DEN2.DDSNCL_CNCL = EHN2.DDSNCL_CNCL  ");
            sbSql.append("    ) and "); 
            sbSql.append("    EHN.CDG_CNCL = EHN2.CDG_CNCL ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DEN.DDSNCL_CNCL < DEN2.DDSNCL_CNCL  or ");
            sbSql.append("    DEN2.DDSNCL_CNCL = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    } 
            
    // Dona en un resulset totes les Entitats Singulars que no estiguin donats de baixa.
    public ResultSet TotsEntSingular()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_ENTSNG_has_DDSENTSNG EHS,PDR_DDSENTSNG DES");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DES.CDG_PRV        = EHS.CDG_PRV     and ");
        sbSql.append("   DES.CDG_MNC        = EHS.CDG_MNC     and ");
        sbSql.append("   DES.DDSENTSNG_CSNG = EHS.DDSENTSNG_CSNG  ");
        sbSql.append("  ) and ");
        sbSql.append("  DES.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DES.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  EHS.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_ENTSNG_has_DDSENTSNG EHS2,PDR_DDSENTSNG DES2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DES2.CDG_PRV        = EHS2.CDG_PRV     and ");
        sbSql.append("      DES2.CDG_MNC        = EHS2.CDG_MNC     and ");
        sbSql.append("      DES2.DDSENTSNG_CSNG = EHS2.DDSENTSNG_CSNG  ");
        sbSql.append("    ) and "); 
        sbSql.append("    EHS.CDG_CSNG = EHS2.CDG_CSNG ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DES.DDSENTSNG_CSNG < DES2.DDSENTSNG_CSNG  or ");
        sbSql.append("    DES2.DDSENTSNG_CSNG = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
        sbSql.append("  order by DES.NENTSI ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per Entitat Singular.
    public String MostrarEntSingular (int PRV, int MNC)
    {
        StringBuffer    sResultat;
        ResultSet       rSelect; 
        PDREntSingular  oEntSng;
        int          i;
        
        sResultat = new StringBuffer("");
        oEntSng   = new PDREntSingular(con, CDG_USR);
        i = 0;
        
        try
        {
            // Coloquem en el objecta les Provincia y Municipi corresponent.
            oEntSng.CDG_PRV = PRV;
            oEntSng.CDG_MNC = MNC;
            
            // obtenim els Tots els Tipus de Via
            rSelect = oEntSng.TotsEntSingular();
            
            sResultat.append("<SELECT NAME=\"EntSingular\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oEntSng.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oEntSng.NENTSI +"\"");
                if (NENTSI.compareTo(oEntSng.NENTSI) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oEntSng.NENTSI+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Comprova si la Entitat Colectiva es correcta per inserir-la.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      
      // Posem perque funcioni la comprovacio de si existeix el nom.
      CDG_CSNG = -1;
      
      // El nombre ens indica el problema. 
      if (NENTSI.compareTo("")==0)// Problema 59
      {
          sResultado = sResultado + "e59: Falta posar el nom de la Entitat Singular. <br /> " ;
      }
      if (NENTSI50.compareTo("")==0)// Problema 60
      {
          sResultado = sResultado + "e60: Falta posar el nom de com a molt 50 carcters de la Entitat Singular. <br /> " ;
      }
      if (NENTSIC.compareTo("")==0)// Problema 61
      {
          sResultado = sResultado + "e61: Falta posar el nom curt de la Entitat Singular. <br /> " ;
      }
         
      // Comprova si las dades se adecuan a las de la base de dades.
      if (existeNENTSI())// Problema 62
      {
          sResultado = sResultado + "e62: El nom de la Entitat Singular existeix. <br /> " ;
      }
      if (EntColectiva.NENTCO.compareTo("") != 0)// Problema 57
      {
          if (! EntColectiva.existeEntColectiva())
          {
            sResultado = sResultado + "e57: La Entitat Colectiva no existeix. <br /> " ;
          }
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la Entitat Singular es pot updatear
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
              
      // El nombre ens indica el problema. 
      if (CDG_CSNG == -1)// Problema 16
      {
          sResultado = sResultado + "e16: El update requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      
      if (! existeCDGCSNG())// Problema 63
      {
        sResultado = sResultado + "e63: La Entitat Singular no existeix. <br /> " ;
      }
       
      if (NENTSI.compareTo("")==0)// Problema 59
      {
          sResultado = sResultado + "e59: Falta posar el nom de la Entitat Singular. <br /> " ;
      }
      if (NENTSI50.compareTo("")==0)// Problema 60
      {
          sResultado = sResultado + "e60: Falta posar el nom de com a molt 50 carcters de la Entitat Singular. <br /> " ;
      }
      if (NENTSIC.compareTo("")==0)// Problema 61
      {
          sResultado = sResultado + "e61: Falta posar el nom curt de la Entitat Singular. <br /> " ;
      }
      // Comprova si las dades se adecuan a las de la base de dades.
      if (existeNENTSI())// Problema 62
      {
          sResultado = sResultado + "e62: El nom de la Entitat Singular existeix. <br /> " ;
      }
      
      // Comprova si las dades se adecuan a las de la base de dades.
      if (EntColectiva.NENTCO.compareTo("") != 0)// Problema 57
      {
          if (! EntColectiva.existeEntColectiva())
          {
            sResultado = sResultado + "e57: La Entitat Colectiva no existeix. <br /> " ;
          }
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la Entitat Singular es pot esborra.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (CDG_CSNG == -1)// Problema 16
      {
          sResultado = sResultado + "e138: El delete requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      
      if (! existeCDGCSNG())// Problema 63
      {
        sResultado = sResultado + "e57: La Entitat Colectiva no existeix. <br /> " ;
      }
      
      if ( teNucli())// Problema 64
      {
        sResultado = sResultado + "e64: La Entitat Singular esta relacionada amb un Nucli. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprova si podem fer el select.
    
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hi ha comprovacions.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
     
}
