/*
 * PDREstudios.java
 *
 * Created on 2 de abril de 2006, 15:36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Panadero
 */

public class PDREstudios
{
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    // De la base de datos
    public  int          CNES;              // Nmero del Tipus de Estudi.                      (Posat per l'usuari)
    public  String       NMB_CNES;          // Nom del Tipus de Estudi.                         (Posat per l'usuari)
    
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    
    // Creates a new instance of PDREstudios 
    public PDREstudios() 
    {
        con             = null;    
        // De la base de datos
        CNES     = -1;       
        NMB_CNES = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
    
    // Creates a new instance of PDREstudios 
    public PDREstudios(BDConnexio conexion) 
    {
        con             = conexion;   
        // De la base de datos
        CNES     = -1;       
        NMB_CNES = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
     
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion.
    public void reiniciar()
    {              
        // De la base de datos
        CNES     = -1;       
        NMB_CNES = "";       
             
        // Relacionada con Errores
        sError          = "";          
        
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {   
      try
      {
        // Dades de PDR_TPS_IDEN
        CNES     = Integer.parseInt(rSelect.getString("CNES"));       
        NMB_CNES = rSelect.getString ("NMB_CNES");     
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Fa un select d'un Estudi
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{ 
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_EST EST");
        sbSql.append(" where ");
        sbSql.append("  ( EST.CNES ='"+ CNES +"' or ");
        sbSql.append(   "'"+CNES            +"'  = -1) and");
        sbSql.append("  ( EST.NMB_CNES ='"+ NMB_CNES +"' or ");
        sbSql.append(   "'"+NMB_CNES           +"'  = '')   ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "80: No existeix Estudi amb aquestes caracterstiques." +"<br />";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Carrega el Estudi en el objecte que la cridat.
    public void darEstudis(int CNESaux, String NMB_CNESaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_EST EST");
        sbSql.append(" where ");
        sbSql.append("  EST.CNES ='"+ CNESaux +"' or ");
        sbSql.append("  EST.NMB_CNES ='"+ NMB_CNESaux +"' ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
           
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "81: El Estudi no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Comproba si el Estudi existeix.
    public boolean existeEstudis()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
             // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_EST EST");
            sbSql.append(" where ");
            sbSql.append("  EST.CNES ='"+ CNES +"' or ");
            sbSql.append("  EST.NMB_CNES ='"+ NMB_CNES +"' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset tots els Estudis que no estiguin donats de baixa.
    public ResultSet TotsEstudis()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_EST ");
        sbSql.append(" where ");
        sbSql.append(" CNES != -2");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per els Estudis.
    public String MostrarEstudis ()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDREstudios   oEst;
        int          i;
        
        sResultat = new StringBuffer("");
        oEst  = new PDREstudios(con);
        i = 0;
        
        try
        {            
            // obtenim els Tots els Estudis
            rSelect = oEst.TotsEstudis();
            
            sResultat.append("<SELECT NAME=\"ESTUDIOS\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oEst.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oEst.NMB_CNES +"\"");
                if (NMB_CNES.compareTo(oEst.NMB_CNES) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oEst.NMB_CNES+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
}
