/*
 * PDRMunc.java
 *
 * Created on 2 de abril de 2006, 14:47
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Panadero
 */

public class PDRMunc
{
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    // De la base de datos
    public  int          MUNC;              // Nmero del Municipi.                                          (Posat per l'usuari)
    public  String       NMB_MUNC;          // Nom del Municipi.                                             (Posat per l'usuari)
    
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    
    // Creates a new instance of PDRMUNC 
    public PDRMunc() 
    {
        con             = null;    
        // De la base de datos
        MUNC     = -1;       
        NMB_MUNC = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
    
    // Creates a new instance of PDRMUNC 
    public PDRMunc(BDConnexio conexion) 
    {
        con             = conexion;   
        // De la base de datos
        MUNC     = -1;       
        NMB_MUNC = "";       
        
        // Relacionada con Errores
        sError          = "";
    }
     
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion.
    public void reiniciar()
    {              
        // De la base de datos
        MUNC     = -1;       
        NMB_MUNC = "";       
             
        // Relacionada con Errores
        sError          = "";          
        
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {   
      try
      {
        // Dades de PDR_MUNC
        MUNC     = Integer.parseInt(rSelect.getString("MUNC"));       
        NMB_MUNC = rSelect.getString ("NMB_MUNC");     
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Fa un select d'un Municipi
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{ 
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_MUNC MNC");
        sbSql.append(" where ");
        sbSql.append("  ( MNC.MUNC ='"+ MUNC +"' or ");
        sbSql.append(   "'"+MUNC            +"'  = -1) and");
        sbSql.append("  ( MNC.NMB_MUNC ='"+ NMB_MUNC +"' or ");
        sbSql.append(   "'"+NMB_MUNC           +"'  = '')   ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "11: No existeix Municipi amb aquestes caracterstiques." +"<br />";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Carrega la MUNCincia en el objecte que la cridat.
    public void darMunc(int MUNCaux, String NMB_MUNCaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_MUNC MNC");
        sbSql.append(" where ");
        sbSql.append("  MNC.MUNC ='"+ MUNCaux +"' or ");
        sbSql.append("  MNC.NMB_MUNC ='"+ NMB_MUNCaux +"' ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "17: El Municpi no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Comproba si el Municipi existeix.
    public boolean existeMunc()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
             // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_MUNC MNC");
            sbSql.append(" where ");
            sbSql.append("  MNC.MUNC ='"+ MUNC +"' or ");
            sbSql.append("  MNC.NMB_MUNC ='"+ NMB_MUNC +"' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset tots els Munc que no estiguin donats de baixa.
    public ResultSet TotsMunc()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_MUNC ");
        sbSql.append(" where ");
        sbSql.append(" MUNC != 0");
        sbSql.append(" Order by ");
        sbSql.append(" NMB_MUNC ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per els Municipis per el lloc de Naixement.
    public String MostrarMuncNaixement ()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRMunc      oMunc;
        int          i;
        
        sResultat = new StringBuffer("");
        oMunc     = new PDRMunc(con);
        i = 0;
        
        try
        {            
            // obtenim els Tots els Municipis
            rSelect = oMunc.TotsMunc();
            
            sResultat.append("<SELECT NAME=\"MUNNACIMIENTO\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oMunc.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oMunc.NMB_MUNC +"\"");
                 if (NMB_MUNC.compareTo(oMunc.NMB_MUNC) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oMunc.NMB_MUNC+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Ens dona un desplegable amb totes les obcions per els Municipis per el lloc de Procedencia o desti.
    public String MostrarMuncProcedencia ()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRMunc      oMunc;
        int          i;
        
        sResultat = new StringBuffer("");
        oMunc     = new PDRMunc(con);
        i = 0;
        
        try
        {            
            // obtenim els Tots els Municipis
            rSelect = oMunc.TotsMunc();
            
            sResultat.append("<SELECT NAME=\"MUNPROCEDENCIA\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oMunc.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oMunc.NMB_MUNC +"\"");
                if (NMB_MUNC.compareTo(oMunc.NMB_MUNC) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oMunc.NMB_MUNC+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
}