/*
 * PDRMunicipi.java
 *
 * Created on 11 de julio de 2005, 10:19
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package PDR;

import java.io.*;
import java.net.*;
import java.sql.*;
import java.util.Date;

/**
 *
 * @author Miguel Angel Panadero
 */
public class PDRMunicipi 
{
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio con;           // Nos permite conectarnos con la base de datos.
    public  ResultSet  rSelectPublic; // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int        CDG_PRV;       // Nmero de identificacin de la provincia. (Posat per nosaltres)
    public  int        CDG_MNC;       // Nmero que identifica la provincia.       (Posat per nosaltres)
    public  int        CUN;           // Codi Unitat Poblacional                   (Posat per l'Ine) 
    public  String     NMUN;          // Nom del municipi.                         (Posat per l'usuari)
    public  String     NMUN50;        // Nom del municipic max 50 caracter.        (Posat per l'usuari)
    public  String     NMUNC;         // Nom curt del municipi.                    (Posat per l'usuari)
    public  String     DSC_MNC;       // Descripci del municipi.                  (Posat per l'usuari)
    // Relacionada con Errores
    public  String     sError;        // Guardamos todos los errores generados.
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    public PDRMunicipi() 
    { 
       sError        = "";
       con           = null;
       rSelectPublic = null;
       sSiguiente    = "disabled";
       sAnterior     = "disabled";
       
       // Varialbes de la base de dades
       CDG_PRV  = -1;     
       CDG_MNC  = -1;
       CUN      = -1;
       NMUN     = "";       
       NMUN50   = "";        
       NMUNC    = "";     
       DSC_MNC  = "";     
    }
    
    public PDRMunicipi(BDConnexio conexion) 
    {
       sError        = "";
       con           = conexion;
       rSelectPublic = null;
       sSiguiente    = "disabled";
       sAnterior     = "disabled";
       
       // Varialbes de la base de dades
       CDG_PRV  = -1;   
       CDG_MNC  = -1; 
       CUN      = -1;
       NMUN     = "";       
       NMUN50   = "";        
       NMUNC    = "";     
       DSC_MNC  = "";     
    }
    
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    public void reiniciar()
    {    
       sError        = "";
       rSelectPublic = null;
       sSiguiente    = "disabled";
       sAnterior     = "disabled";
       
       // Varialbes de la base de dades  
       CUN      = -1;
       NMUN     = "";       
       NMUN50   = "";        
       NMUNC    = "";     
       DSC_MNC  = "";     
    }
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {    
      try
      {
        CDG_PRV  = Integer.parseInt(rSelect.getString("CDG_PRV"));
        CDG_MNC  = Integer.parseInt(rSelect.getString("CDG_MNC"));
        CUN      = Integer.parseInt(rSelect.getString("CUN"));
        NMUN     = rSelect.getString ("NMUN");
        NMUN50   = rSelect.getString ("NMUN50");
        NMUNC    = rSelect.getString ("NMUNC");
        DSC_MNC  = rSelect.getString ("DSC_MNC");
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Inserta un Municipi en la taula de Municipis.
    public void insert()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador pNum;
      
      pNum = new PDRNumerador(con);
      try
      {
          
        // Possem un numero al Municipi.
        pNum.NMR_NOM = "NMR_Municipi";
        pNum.select();
        CDG_MNC = pNum.NMR_VLR;
            
        sbSql = null;
      
        stmt = con.cnPrincipal.createStatement();

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append("   PDR_MNC ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CUN, NMUN, NMUN50, NMUNC, DSC_MNC) ");
        sbSql.append(" values ");
        sbSql.append("('"+  CDG_PRV +"', '"+ CDG_MNC + "', '" + CUN   +"', '");
        sbSql.append(       NMUN     +"', '"+ NMUN50   +"', '"+ NMUNC + "', '" + DSC_MNC +"')");

        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un Update de un Municipi en la taula de Municipis,
    // Es pot updateixa el nom, el nom en 50 caracters, el nom curt y la descripci.
    public void update()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;

      sbSql = null;
      try{
        stmt = con.cnPrincipal.createStatement();
       
        // Preparem la sentncia SQL, solament podem updateixa la descripcio
        sbSql  = new StringBuffer("");
        sbSql.append("Update ");
        sbSql.append("   PDR_MNC ");
        sbSql.append(" SET "  );
        sbSql.append("   NMUN   = '"+ NMUN    + "' , ");
        sbSql.append("   NMUN50 = '"+ NMUN50  + "' , ");
        sbSql.append("   NMUNC  = '"+ NMUNC   + "' , ");
        sbSql.append("   CUN    = '"+ CUN     + "' , ");
        sbSql.append("   DSC_MNC= '"+ DSC_MNC + "'   ");
        sbSql.append(" where");
        sbSql.append("   CDG_PRV= '"+ CDG_PRV + "' and ");
        sbSql.append("   CDG_MNC=  '"+ CDG_MNC + "' ");
        

        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un delete en la taula de Municipis, 
    // mirant el codi de la provincia y el nom del municipi.
    public void delete()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;

      sbSql = null;
      try{
        stmt = con.cnPrincipal.createStatement();

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Delete From ");
        sbSql.append("   PDR_MNC ");
        sbSql.append(" where");
        sbSql.append("   CDG_PRV= '"+ CDG_PRV + "' and ");
        sbSql.append("   NMUN=  '"   + NMUN     + "' ");
        

        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'un Municipi
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
        // Cerramos el select anterior
        if (rSelectPublic != null){rSelectPublic.close();}  
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append("   PDR_MNC ");
        sbSql.append(" where ");
        sbSql.append("   CDG_PRV = '"+ CDG_PRV + "'  ");
        sbSql.append("   and ");
        sbSql.append("   ( NMUN LIKE'%"+ NMUN + "%' or ");
        sbSql.append("     '"+NMUN+"' = '')");
        sbSql.append("   and ");
        sbSql.append("   ( NMUN50 LIKE'%"+ NMUN50 + "%' or ");
        sbSql.append("     '"+NMUN50+"' = '')");
        sbSql.append("   and ");
        sbSql.append("   ( NMUNC LIKE'%"+ NMUNC + "%' or ");
        sbSql.append("     '"+NMUNC+"' = '')");
        sbSql.append("   and ");
        sbSql.append("   ( DSC_MNC LIKE'%"+ DSC_MNC + "%' or ");
        sbSql.append("     '"+DSC_MNC+"' = '')");
        sbSql.append("   and ");
        sbSql.append("   ( CDG_MNC != '0' )");
        sbSql.append(" Order by CDG_PRV, NMUN");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
           rSelectPublic = rSelect;
           
           // Desbloqueamos o bloqueamos los botones que haga falta.
           if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
           if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
        }
        else
        {
           sError = sError + "e11: No existeix Municipi amb aquestes caracterstiques." +"<br />";
           rSelectPublic = null;
           // Desactivamos los botones de siguiente y anteriror.
           sSiguiente    = "disabled";
           sAnterior     = "disabled";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs" + "<br />";}
    }
    
    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior" + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs. " + "<br />";}
    }
    
    // Comprueba si la provincia existe.
    public boolean existeProvincia()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select  ");
            sbSql.append("    *  ");
            sbSql.append("  from  ");
            sbSql.append(    " PDR_PRV ");
            sbSql.append("  where  ");
            sbSql.append(" ( ");
            sbSql.append("  CDG_PRV  = '"+ CDG_PRV + "' ");
            sbSql.append(" ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprueba si el Municipio existe.
    public boolean existeMunicipi()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select  ");
            sbSql.append("    *  ");
            sbSql.append("  from  ");
            sbSql.append("  PDR_MNC ");
            sbSql.append("  where  ");
            sbSql.append(" ( ");
            sbSql.append("  CDG_PRV  = '"+ CDG_PRV + "' and ");
            sbSql.append("  NMUN      = '"+ NMUN  + "' ");
            sbSql.append(" ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprueba si el Municipio existe a partir del codi de provincia y municip que li passen.
    public boolean existeMunicipiCodi(int CPrv, int CMunc)
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select  ");
            sbSql.append("    *  ");
            sbSql.append("  from  ");
            sbSql.append("  PDR_MNC ");
            sbSql.append("  where  ");
            sbSql.append(" ( ");
            sbSql.append("  CDG_PRV  = '"+ CPrv   + "' and ");
            sbSql.append("  CDG_MNC  = '"+ CMunc  + "' ");
            sbSql.append(" ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset totes les Entitats Singulars que no estiguin donats de baixa.
    public ResultSet TotsMunicipi()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append("   PDR_MNC ");
        sbSql.append(" where ");
        sbSql.append("   ( CDG_MNC != '0' )");
        sbSql.append(" Order by CDG_PRV, NMUN");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Comprova si el Municipi es correcta per inserir-lo.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (! existeProvincia() )// Problema 4
      {
        sResultado = sResultado + "e4: La Provncia no existeix. <br /> " ;
      }
      
      if (NMUN.compareTo("")==0)// Problema 12
      {
          sResultado = sResultado + "e12: Falta posar el nom Municipi. <br /> " ;
      }
      
      if (NMUN50.compareTo("")==0)// Problema 13
      {
          sResultado = sResultado + "e13: Falta posar el nom de com a mxim 50 carcters del Municipi. <br /> " ;
      }
      
      if (NMUNC.compareTo("")==0)// Problema 14
      {
          sResultado = sResultado + "e14: Falta posar el nom curt del Municipi. <br /> " ;
      }
      
      if (DSC_MNC.compareTo("")==0)// Problema 15
      {
          sResultado = sResultado + "e15: Falta posar la Descripci del Municipi. <br /> " ;
      }
      
      if (existeMunicipi() )// Problema 131
      {
        sResultado = sResultado + "e131: El Municipi existeix. <br /> " ;
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la provincia se puede updatear
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (CDG_MNC == -1)// Problema 16
      {
          sResultado = sResultado + "e16: El update requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      
      if (NMUN.compareTo("")==0)// Problema 12
      {
          sResultado = sResultado + "e12: Falta posar el nom Municipi. <br /> " ;
      }
      
      if (NMUN50.compareTo("")==0)// Problema 13
      {
          sResultado = sResultado + "e13: Falta posar el nom de com a mxim 50 carcters del Municipi. <br /> " ;
      }
      
      if (NMUNC.compareTo("")==0)// Problema 14
      {
          sResultado = sResultado + "e14: Falta posar el nom curt del Municipi. <br /> " ;
      }
      
      if (DSC_MNC.compareTo("")==0)// Problema 15
      {
          sResultado = sResultado + "e15: Falta posar la Descripci del Municipi. <br /> " ;
      }
      
      if (! existeMunicipi() )// Problema 17
      {
        sResultado = sResultado + "e17: El municipi no existeix. <br /> " ;
      }
      
      // Comprova si las dades se adecuan a las de la base de dades.
      if (! existeProvincia() )// Problema 4
      {
        sResultado = sResultado + "e4: La Provncia no existeix. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
       
    // Comprueba si la provincia se puede borrar.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (! existeProvincia() )// Problema 4
      {
        sResultado = sResultado + "e4: La Provncia no existeix. <br /> " ;
      }
      
      if (CDG_MNC == -1)// Problema 16
      {
          sResultado = sResultado + "e138: El delete requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      
      if (! existeMunicipi() )// Problema 17
      {
        sResultado = sResultado + "e17: El municipi no existeix. <br /> " ;
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
     
    // Comprova si podem fer el select.
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hay comprovaciones.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
}
