/*
 * PDRPseudovia.java
 *
 * Created on 3 de febrero de 2006, 11:36
 *
 */

package PDR;

import java.io.*;
import java.net.*;
import java.sql.*;
//import java.util.GregorianCalendar;

/**
 *
 * @author Miguel Angel Panadero
 */

public class PDRPseudovia {
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio con;           // Nos permite conectarnos con la base de datos.
    public  ResultSet  rSelectPublic; // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int        CDG_PRV;       // Nmero de identificacin de la provincia.        (Posat per nosaltres)
    public  int        CDG_MNC;       // Nmero que identifica la provincia.              (Posat per nosaltres)
    public  int        CDG_CPSVIA;    // Nmeroque indentifica la via.                    (Posat per nosaltres)
    public  int        DDSPSD_CPSVIA; // Nmero de identificacin de las dades de la via. (Posat per nosaltres)
    public  int        CPSVIA;        // Cdi de la via.                                  (Posat per l'Ine) 
    public  String     DPSVIA;        // Descripci de la pseudovia.                      (Posat per l'Ine)
    private String     FVAR;          // Data del cambi.                                  (Posat per nosaltres)
    public  String     CVAR;          // Codi de Variacio                                 (Posat per nosaltres)
    private String     Envio;         // Ens indica si esta enviat al Ine.                (Posat per nosaltres)
    // Relacionada con Errores
    public  String     sError;        // Guardamos todos los errores generados.
    // Dades del Usuari
    public  int        CDG_USR;       // Nmero que identifica al usuari que esta realitzan les accion (Posat per nosaltres)
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    // Constructor
    public PDRPseudovia(int USR) 
    {
        con             = null;           
        rSelectPublic   = null; 
        // De la base de datos
        CDG_PRV         = -1;     
        CDG_MNC         = -1;       
        CDG_CPSVIA      = -1;    
        DDSPSD_CPSVIA   = -1; 
        CPSVIA          = -1;       
        DPSVIA          = "";        
        FVAR            = "";        
        CVAR            = "";      
        Envio           = "";      
        // Relacionada con Errores
        sError          = "";       
        // Dades del Usuari
        CDG_USR         = USR;     
        // Relacionadas con estado de los botones.
        sSiguiente      = "disabled";
        sAnterior       = "disabled";
    }
    
    public PDRPseudovia(BDConnexio conexion, int USR) 
    {
        con             = conexion;           
        rSelectPublic   = null; 
        // De la base de datos
        CDG_PRV         = -1;     
        CDG_MNC         = -1;       
        CDG_CPSVIA      = -1;    
        DDSPSD_CPSVIA   = -1; 
        CPSVIA          = -1;       
        DPSVIA          = "";        
        FVAR            = "";        
        CVAR            = "";      
        Envio           = "";      
        // Relacionada con Errores
        sError          = "";       
        // Dades del Usuari
        CDG_USR         = USR;     
        // Relacionadas con estado de los botones.
        sSiguiente      = "disabled";
        sAnterior       = "disabled";
    }
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    public void reiniciar()
    {             
        rSelectPublic   = null; 
        // De la base de datos      
        CDG_CPSVIA      = -1;    
        DDSPSD_CPSVIA   = -1; 
        CPSVIA          = -1;       
        DPSVIA          = "";        
        FVAR            = "";        
        CVAR            = "";      
        Envio           = "";      
        // Relacionada con Errores
        sError          = "";        
        // Relacionadas con estado de los botones.
        sSiguiente      = "disabled";
        sAnterior       = "disabled";
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {
        try
        {
            // Dades de PDR_DDSPSD
            CDG_PRV         = Integer.parseInt(rSelect.getString("CDG_PRV"));     
            CDG_MNC         = Integer.parseInt(rSelect.getString("CDG_MNC"));       
            DDSPSD_CPSVIA   = Integer.parseInt(rSelect.getString("DDSPSD_CPSVIA")); 
            CPSVIA          = Integer.parseInt(rSelect.getString("CPSVIA"));       
            DPSVIA          = rSelect.getString ("DPSVIA");        
               
            // Dades de PDR_PSD_has_DDSPSD que no estan en l'altre.
            CDG_CPSVIA      = Integer.parseInt(rSelect.getString("CDG_CPSVIA"));
            FVAR            = rSelect.getString ("FVAR");        
            CVAR            = rSelect.getString ("CVAR");      
            Envio           = rSelect.getString ("Envio");
        }   catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
            {con.cnPrincipal.rollback();
            }catch (Exception e2)
            {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");} 
        }
    }
    
    // Inserta los datos de la pseudoviavia en la taula de PDR_DDSPSD.
    // Inserta la via en taula de PDR_PSD.
    // Inserta la relaci pseudovia-dades en la taula de PDR_PSD_has_DDSPSD.
    public void insert()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador PsdNum;
      
      //Date
      Data dFecha;
      
      PsdNum = new PDRNumerador(con); 
      try
      {
          // Possem un numero a les dades de la Pseudovia.
          PsdNum.NMR_NOM = "NMR_DDSPSD_CPSVIA";
          PsdNum.select();
          DDSPSD_CPSVIA = PsdNum.NMR_VLR;
      
          sbSql = null;
      
          stmt = con.cnPrincipal.createStatement();
          // Preparem la sentncia SQL per inseri en PDR_DDSPSD
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_DDSPSD ");
          sbSql.append(" (CDG_PRV, CDG_MNC, DDSPSD_CPSVIA, DPSVIA, CPSVIA) ");
          sbSql.append(" values ");
          sbSql.append("('"+  CDG_PRV +"', '"+ CDG_MNC        +"', '"+ DDSPSD_CPSVIA+"', '");
          sbSql.append(       DPSVIA    +"', '"+ CPSVIA +"')");
          
          stmt.executeUpdate(sbSql.toString());
          
          // Posem un numero intern a la Pseudovia
          PsdNum.NMR_NOM = "NMR_PSDVIA";
          PsdNum.select();
          CDG_CPSVIA = PsdNum.NMR_VLR;
          
          // Preparem la sentncia SQL per inseri en PDR_PSD
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_PSD ");
          sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CPSVIA) ");
          sbSql.append(" values ");
          sbSql.append("('"+ CDG_PRV +"', '"+ CDG_MNC +"', '"+ CDG_CPSVIA+"')");
          
          stmt.executeUpdate(sbSql.toString());
          
          // obtenim el dia al que estem.
          dFecha = new Data (con);
          
          FVAR = dFecha.darFecha();
          
          // Preparem la sentncia SQL per inseri en PDR_PSD_has_DDSPSD
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_PSD_has_DDSPSD ");
          sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CPSVIA, DDSPSD_CPSVIA, CDG_USR, FVAR, CVAR, Envio) ");
          sbSql.append(" values ");
          sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ CDG_CPSVIA+"', '");
          sbSql.append(      DDSPSD_CPSVIA +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'A', 'N')");
          
          
        stmt.executeUpdate(sbSql.toString());
        
        stmt.close();
        con.cnPrincipal.commit();
      } catch (Exception e)
      {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
      
    }
    
    // Fa un insert de les dades d'una Pseudovia en la taula PDR_DDSPSD
    // Fa un insert en la taulta PDR_PSD_has_DDSPSD enllaant Pseudocia-dades.
    // Es pot updateixa la descripci de la pseudovia.
    public void update()
    {
        // Conexio
        Statement stmt;
        StringBuffer sbSql;
        PDRNumerador PsdNum;
        
        //Date
        Data dFecha;
        
        PsdNum = new PDRNumerador(con);
        
        try
        {
            
            //Possem un numero a les dades de la Pseudovia.
            PsdNum.NMR_NOM = "NMR_DDSPSD_CPSVIA";
            PsdNum.select();
            DDSPSD_CPSVIA = PsdNum.NMR_VLR;
        
            sbSql = null;
        
            stmt = con.cnPrincipal.createStatement();
            
            // Preparem la sentncia SQL per inseri en PDR_DDSPSD
            sbSql = new StringBuffer("");
            sbSql.append("Insert into  ");
            sbSql.append( " PDR_DDSPSD ");
            sbSql.append(" (CDG_PRV, CDG_MNC, DDSPSD_CPSVIA, DPSVIA, CPSVIA) ");
            sbSql.append(" values ");
            sbSql.append("('"+  CDG_PRV +"', '"+ CDG_MNC        +"', '"+ DDSPSD_CPSVIA+"', '");
            sbSql.append(       DPSVIA    +"', '"+ CPSVIA +"')");
        
            stmt.executeUpdate(sbSql.toString());
        
            // obtenim el dia al que estem.
            dFecha = new Data (con);
          
            FVAR = dFecha.darFecha(); 
            
            // Preparem la sentncia SQL per inseri en PDR_PSD_has_DDSPSD
            sbSql = new StringBuffer("");
            sbSql.append("Insert into  ");
            sbSql.append( " PDR_PSD_has_DDSPSD ");
            sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CPSVIA, DDSPSD_CPSVIA, CDG_USR, FVAR, CVAR, Envio) ");
            sbSql.append(" values ");
            sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ CDG_CPSVIA+"', '");
            sbSql.append(      DDSPSD_CPSVIA +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'M', 'N')");
            
            stmt.executeUpdate(sbSql.toString());
            stmt.close();
            con.cnPrincipal.commit();

        }catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
            {con.cnPrincipal.rollback();
            }catch (Exception e2)
            {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Recupera les dades de la Pseudovia que anem a borrar.
    // Fa un Insert a la taula PDR_PSD_has_DDSPSD enllaant pseudovia-dades, inserim en motiu envia a Ine Baixa
    public void delete()
    {
        // Conexio 
        Statement stmt; 
        StringBuffer sbSql;
        sbSql = null;
        
        //Date
        Data dFecha;
          
        try{
            stmt = con.cnPrincipal.createStatement();
        
            // obtenim el dia al que estem.
            dFecha = new Data (con);
          
            FVAR = dFecha.darFecha();
        
            // Preparem la sentncia SQL per inseri en PDR_PSD_has_DDSPSD
            sbSql = new StringBuffer("");
            sbSql.append("Insert into  ");
            sbSql.append( " PDR_PSD_has_DDSPSD ");
            sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CPSVIA, DDSPSD_CPSVIA, CDG_USR, FVAR, CVAR, Envio) ");
            sbSql.append(" values ");
            sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ CDG_CPSVIA+"', ");
            sbSql.append(      "'-1', '" + CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'B', 'N')");
            
            stmt.executeUpdate(sbSql.toString());
            stmt.close();
            con.cnPrincipal.commit();
        
    }   catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'un o un grup de Pseudovia
    public void select()
    {
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        ResultSet rSelect;
      
        sbSql = null;
        try
        {
            // Cerramos el select anterior
            if (rSelectPublic != null){rSelectPublic.close();} 
            
            stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );
            
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_PSD_has_DDSPSD PHD,PDR_DDSPSD DPS");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DPS.CDG_PRV       = PHD.CDG_PRV     and ");
            sbSql.append("   DPS.CDG_MNC       = PHD.CDG_MNC     and ");
            sbSql.append("   DPS.DDSPSD_CPSVIA = PHD.DDSPSD_CPSVIA     ");
            sbSql.append("  ) and ");
            sbSql.append("  DPS.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DPS.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  ( DPS.CPSVIA ='"+ CPSVIA +"' or ");
            sbSql.append(   "'"+CPSVIA +"'  = -1) and");
            sbSql.append("  ( DPS.DPSVIA LIKE'%"+ DPSVIA +"%' or ");
            sbSql.append(   "'"+DPSVIA           +"'  = '') and");
            sbSql.append("  PHD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_PSD_has_DDSPSD PHD2,PDR_DDSPSD DPS2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DPS2.CDG_PRV       = PHD2.CDG_PRV     and ");
            sbSql.append("      DPS2.CDG_MNC       = PHD2.CDG_MNC     and ");
            sbSql.append("      DPS2.DDSPSD_CPSVIA = PHD2.DDSPSD_CPSVIA ");
            sbSql.append("    ) and "); 
            sbSql.append("    PHD.CDG_CPSVIA = PHD2.CDG_CPSVIA ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DPS.DDSPSD_CPSVIA < DPS2.DDSPSD_CPSVIA  or ");
            sbSql.append("    DPS2.DDSPSD_CPSVIA = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            sbSql.append("  order by DPSVIA ");
        
            rSelect = stmt.executeQuery(sbSql.toString());
        
            if (rSelect.next())
            {
                rellenar(rSelect);
                rSelectPublic = rSelect;
           
                // Desbloqueamos o bloqueamos los botones que haga falta.
                if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
                if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
            }
            else
            {
               sError = sError + "e137: No existeixen Pseudovies amb aquestes caracterstiques." +"<br />";
               rSelectPublic = null;
               // Desactivamos los botones de siguiente y anteriror.
               sSiguiente    = "disabled";
               sAnterior     = "disabled";
            }

        } catch (Exception e)
        {
            sError = sError + ("Fallo en la base de datos:"+e + "<br />");
            try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }

    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }

    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }

    // Carrega la Via en el objecte que la cridat.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public void darPseudovia(int CDG_CPSVIAaux, String DPSVIAaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_PSD_has_DDSPSD PHD,PDR_DDSPSD DPS");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DPS.CDG_PRV       = PHD.CDG_PRV     and ");
        sbSql.append("   DPS.CDG_MNC       = PHD.CDG_MNC     and ");
        sbSql.append("   DPS.DDSPSD_CPSVIA = PHD.DDSPSD_CPSVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DPS.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DPS.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( PHD.CDG_CPSVIA ='"+ CDG_CPSVIAaux +"' or ");
        sbSql.append(   "'"+CDG_CPSVIAaux +"'  = -1) and");
        sbSql.append("  ( DPS.DPSVIA ='"+ DPSVIAaux +"' or ");
        sbSql.append(   "'"+DPSVIAaux   +"'  = '') and");
        sbSql.append("  PHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_PSD_has_DDSPSD PHD2,PDR_DDSPSD DPS2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DPS2.CDG_PRV       = PHD2.CDG_PRV     and ");
        sbSql.append("      DPS2.CDG_MNC       = PHD2.CDG_MNC     and ");
        sbSql.append("      DPS2.DDSPSD_CPSVIA = PHD2.DDSPSD_CPSVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    PHD.CDG_CPSVIA = PHD2.CDG_CPSVIA ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DPS.DDSPSD_CPSVIA < DPS2.DDSPSD_CPSVIA  or ");
        sbSql.append("    DPS2.DDSPSD_CPSVIA = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e32: La Pseudovia no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
           try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Carrega la Via en el objecte que la cridat en la Data que ens donen.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public void darPseudovia(int CDG_CPSVIAaux, String DPSVIAaux, String Data)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_PSD_has_DDSPSD PHD,PDR_DDSPSD DPS");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DPS.CDG_PRV       = PHD.CDG_PRV     and ");
        sbSql.append("   DPS.CDG_MNC       = PHD.CDG_MNC     and ");
        sbSql.append("   DPS.DDSPSD_CPSVIA = PHD.DDSPSD_CPSVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DPS.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DPS.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( PHD.CDG_CPSVIA ='"+ CDG_CPSVIAaux +"' or ");
        sbSql.append(   "'"+CDG_CPSVIAaux +"'  = -1) and");
        sbSql.append("  ( DPS.DPSVIA ='"+ DPSVIAaux +"' or ");
        sbSql.append(   "'"+DPSVIAaux   +"'  = '') and");
        sbSql.append("  PHD.CVAR <> 'B' and ");
        sbSql.append("  PHD.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_PSD_has_DDSPSD PHD2,PDR_DDSPSD DPS2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DPS2.CDG_PRV       = PHD2.CDG_PRV     and ");
        sbSql.append("      DPS2.CDG_MNC       = PHD2.CDG_MNC     and ");
        sbSql.append("      DPS2.DDSPSD_CPSVIA = PHD2.DDSPSD_CPSVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    PHD.CDG_CPSVIA = PHD2.CDG_CPSVIA and ");
        sbSql.append("    PHD2.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("    (");
        sbSql.append("    DPS.DDSPSD_CPSVIA < DPS2.DDSPSD_CPSVIA  or ");
        sbSql.append("    DPS2.DDSPSD_CPSVIA = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e32: La Pseudovia no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
           try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Recopera la Pseudovia que ens han marcat a una data o ens retorna totes les d'una data si no ens han marcat cap.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarPseudovias (String sData)
    {    
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_PSD_has_DDSPSD PHD,PDR_DDSPSD DPS");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DPS.CDG_PRV       = PHD.CDG_PRV     and ");
        sbSql.append("   DPS.CDG_MNC       = PHD.CDG_MNC     and ");
        sbSql.append("   DPS.DDSPSD_CPSVIA = PHD.DDSPSD_CPSVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DPS.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DPS.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( PHD.CDG_CPSVIA ='"+ CDG_CPSVIA +"' or ");
        sbSql.append(   "'"+CDG_CPSVIA +"'  = -1) and");
        sbSql.append("  ( DPS.DPSVIA ='"+ DPSVIA +"' or ");
        sbSql.append(   "'"+DPSVIA   +"'  = '') and");
        sbSql.append("  PHD.CVAR <> 'B' and ");
        sbSql.append("  PHD.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_PSD_has_DDSPSD PHD2,PDR_DDSPSD DPS2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DPS2.CDG_PRV       = PHD2.CDG_PRV     and ");
        sbSql.append("      DPS2.CDG_MNC       = PHD2.CDG_MNC     and ");
        sbSql.append("      DPS2.DDSPSD_CPSVIA = PHD2.DDSPSD_CPSVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    PHD.CDG_CPSVIA = PHD2.CDG_CPSVIA and ");
        sbSql.append("    PHD2.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("    (");
        sbSql.append("    DPS.DDSPSD_CPSVIA < DPS2.DDSPSD_CPSVIA  or ");
        sbSql.append("    DPS2.DDSPSD_CPSVIA = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Comprueba si la Pseudoviavia existe.
    public boolean existePseudovia()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_PSD_has_DDSPSD PHD,PDR_DDSPSD DPS");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DPS.CDG_PRV       = PHD.CDG_PRV     and ");
            sbSql.append("   DPS.CDG_MNC       = PHD.CDG_MNC     and ");
            sbSql.append("   DPS.DDSPSD_CPSVIA = PHD.DDSPSD_CPSVIA   ");
            sbSql.append("  ) and ");
            sbSql.append("  DPS.CDG_PRV    ='"+ CDG_PRV  +"' and ");
            sbSql.append("  DPS.CDG_MNC    ='"+ CDG_MNC  +"' and ");
            sbSql.append("  PHD.CDG_CPSVIA ='"+ CDG_CPSVIA +"' and ");
            sbSql.append("  PHD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_PSD_has_DDSPSD PHD2,PDR_DDSPSD DPS2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DPS2.CDG_PRV       = PHD2.CDG_PRV     and ");
            sbSql.append("      DPS2.CDG_MNC       = PHD2.CDG_MNC     and ");
            sbSql.append("      DPS2.DDSPSD_CPSVIA = PHD2.DDSPSD_CPSVIA ");
            sbSql.append("    ) and "); 
            sbSql.append("    PHD.CDG_CPSVIA = PHD2.CDG_CPSVIA ");
            sbSql.append("    and ");
            sbSql.append("    ( ");
            sbSql.append("    DPS.DDSPSD_CPSVIA < DPS2.DDSPSD_CPSVIA or ");
            sbSql.append("    DPS2.DDSPSD_CPSVIA = -1");
            sbSql.append("    ) ");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }

    
    public boolean existeCDGCPSVIA()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_PSD_has_DDSPSD PHD,PDR_DDSPSD DPS");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DPS.CDG_PRV       = PHD.CDG_PRV     and ");
            sbSql.append("   DPS.CDG_MNC       = PHD.CDG_MNC     and ");
            sbSql.append("   DPS.DDSPSD_CPSVIA = PHD.DDSPSD_CPSVIA     ");
            sbSql.append("  ) and ");
            sbSql.append("  DPS.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DPS.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  PHD.CDG_CPSVIA ='"+  CDG_CPSVIA +"' and ");
            sbSql.append("  PHD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_PSD_has_DDSPSD PHD2,PDR_DDSPSD DPS2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DPS2.CDG_PRV       = PHD2.CDG_PRV     and ");
            sbSql.append("      DPS2.CDG_MNC       = PHD2.CDG_MNC     and ");
            sbSql.append("      DPS2.DDSPSD_CPSVIA = PHD2.DDSPSD_CPSVIA ");
            sbSql.append("    ) and "); 
            sbSql.append("    PHD.CDG_CPSVIA = PHD2.CDG_CPSVIA ");
            sbSql.append("    and ");
            sbSql.append("    ( ");
            sbSql.append("    DPS.DDSPSD_CPSVIA < DPS2.DDSPSD_CPSVIA or ");
            sbSql.append("    DPS2.DDSPSD_CPSVIA = -1");
            sbSql.append("    ) ");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    public boolean existeDesPseudovia()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_PSD_has_DDSPSD PHD,PDR_DDSPSD DPS");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DPS.CDG_PRV       = PHD.CDG_PRV     and ");
            sbSql.append("   DPS.CDG_MNC       = PHD.CDG_MNC     and ");
            sbSql.append("   DPS.DDSPSD_CPSVIA = PHD.DDSPSD_CPSVIA     ");
            sbSql.append("  ) and ");
            sbSql.append("  DPS.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DPS.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  DPS.DPSVIA ='"+  DPSVIA +"' and ");
            sbSql.append("  PHD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_PSD_has_DDSPSD PHD2,PDR_DDSPSD DPS2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DPS2.CDG_PRV       = PHD2.CDG_PRV     and ");
            sbSql.append("      DPS2.CDG_MNC       = PHD2.CDG_MNC     and ");
            sbSql.append("      DPS2.DDSPSD_CPSVIA = PHD2.DDSPSD_CPSVIA ");
            sbSql.append("    ) and "); 
            sbSql.append("    PHD.CDG_CPSVIA = PHD2.CDG_CPSVIA ");
            sbSql.append("    and ");
            sbSql.append("    ( ");
            sbSql.append("    DPS.DDSPSD_CPSVIA < DPS2.DDSPSD_CPSVIA or ");
            sbSql.append("    DPS2.DDSPSD_CPSVIA = -1");
            sbSql.append("    ) ");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprova si te asignat algn Tram.
    public boolean teTram()
    {
        boolean bResultado;
        bResultado = false;
       
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_TRM_has_DDSTRM THD,PDR_DDSTRM DTR");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DTR.CDG_PRV     = THD.CDG_PRV     and ");
            sbSql.append("   DTR.CDG_MNC     = THD.CDG_MNC     and ");
            sbSql.append("   DTR.DDSTRM_CTRM = THD.DDSTRM_CTRM     ");
            sbSql.append("  ) and ");
            sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  CDG_CPSVIA  = '"+ CDG_CPSVIA + "' and ");
            sbSql.append("  THD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_TRM_has_DDSTRM THD2, PDR_DDSTRM DTR2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DTR2.CDG_PRV     = THD2.CDG_PRV     and ");
            sbSql.append("      DTR2.CDG_MNC     = THD2.CDG_MNC     and ");
            sbSql.append("      DTR2.DDSTRM_CTRM = THD2.DDSTRM_CTRM ");
            sbSql.append("    ) and "); 
            sbSql.append("    THD.CDG_CTRM = THD2.CDG_CTRM ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DTR.DDSTRM_CTRM < DTR2.DDSTRM_CTRM  or ");
            sbSql.append("    DTR2.DDSTRM_CTRM =  -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprova si te asignat algn Habitatge.
    public boolean teHabitatge()
    {
        boolean bResultado;
        bResultado = false;
       
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_HABITATGE HBTG");
            sbSql.append(" where ");
            sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  CDG_CPSVIA  = '"+ CDG_CPSVIA +"' and");
            sbSql.append("  HBTG.Estado <> 'Baja' ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    
    // Dona en un resulset totes les Pseudovies que no estiguin donats de baixa.
    public ResultSet TotsPseudovia()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_PSD_has_DDSPSD PHD,PDR_DDSPSD DPS");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DPS.CDG_PRV       = PHD.CDG_PRV     and ");
        sbSql.append("   DPS.CDG_MNC       = PHD.CDG_MNC     and ");
        sbSql.append("   DPS.DDSPSD_CPSVIA = PHD.DDSPSD_CPSVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DPS.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DPS.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  PHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_PSD_has_DDSPSD PHD2,PDR_DDSPSD DPS2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DPS2.CDG_PRV       = PHD2.CDG_PRV     and ");
        sbSql.append("      DPS2.CDG_MNC       = PHD2.CDG_MNC     and ");
        sbSql.append("      DPS2.DDSPSD_CPSVIA = PHD2.DDSPSD_CPSVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    PHD.CDG_CPSVIA = PHD2.CDG_CPSVIA ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DPS.DDSPSD_CPSVIA < DPS2.DDSPSD_CPSVIA  or ");
        sbSql.append("    DPS2.DDSPSD_CPSVIA = -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
        sbSql.append("  order by DPSVIA ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
     {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
     }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per Pseudovia.
    public String MostrarPseudovia (int PRV, int MNC)
    {
        StringBuffer  sResultat;
        ResultSet     rSelect; 
        PDRPseudovia  oPseudovia;
        int          i;
        
        sResultat = new StringBuffer("");
        oPseudovia      = new PDRPseudovia(con, CDG_USR);
        i = 0;
        
        try
        {
            // Coloquem en el objecta les Provincia y Municipi corresponent.
            oPseudovia.CDG_PRV = PRV;
            oPseudovia.CDG_MNC = MNC;
            
            // obtenim els Totes les Pseudovies
            rSelect = oPseudovia.TotsPseudovia();
            
            sResultat.append("<SELECT NAME=\"PSEUDOVIA\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oPseudovia.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oPseudovia.DPSVIA +"\"");
                if (DPSVIA.compareTo(oPseudovia.DPSVIA) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oPseudovia.DPSVIA+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Comprova si la Pseudoviavia es correcta per inserir-la.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (DPSVIA.compareTo("")==0)// Problema 31
      {
          sResultado = sResultado + "e31: Falta posar la descripci de la Pseudovia. <br /> " ;
      }
      
      // Comprova si las dades se adecuan a las de la base de dades.
      if (existeDesPseudovia())// Problema 33
      {
          sResultado = sResultado + "e33: La descripci de la Pseudovia existeix. <br /> " ;
      }
      
      /*
      if (existeCDGCPSVIA())
      {
          sResultado = sResultado + "e30: El Codi de la Pseudovia existeix. <br /> " ;
      }
      */
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
      
    }
    
    // Comprueba si la PseudoVia se puede updatear
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
              
      // El nombre ens indica el problema. 
      if (CDG_CPSVIA == -1)// Problema 16
      {
          sResultado = sResultado + "e16: El update requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      
      if (DPSVIA.compareTo("")==0)// Problema 31
      {
          sResultado = sResultado + "e31: Falta posar la descripci de la Pseudovia. <br /> " ;
      }
      
      if (! existeCDGCPSVIA())// Problema 32
      {
        sResultado = sResultado + "e32: La Pseudovia no existeix. <br /> " ;
      }
      
      /*
      if (existeCDGCPSVIA())
      {
          sResultado = sResultado + "e30: El Codi de la Pseudovia existeix. <br /> " ;
      }
      */
      
      if (existeDesPseudovia())// Problema 33
      {
          sResultado = sResultado + "e33: La descripci de la Pseudovia existeix. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la provincia se puede borrar.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (! existeCDGCPSVIA())// Problema 32
      {
        sResultado = sResultado + "e32: La Pseudovia no existeix. <br /> " ;
      }
      
      if (CDG_CPSVIA == -1)// Problema 16
      {
          sResultado = sResultado + "e138: El delete requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      if (teTram())// Problema 135
      {
        sResultado = sResultado + "e135: La Pseudovia esta relacionada amb un Tram. <br /> " ;
      }
      if (teHabitatge())// Problema 136
      {
        sResultado = sResultado + "e136: La Pseudovia esta relacionada amb un Habitatge. <br /> " ;
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprova si podem fer el select.
    
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hi ha comprovacions.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    
    
}
