/*
 * PDRTipusVia.java
 *
 * Created on 27 de febrero de 2006, 12:18
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

/**
 * @author Miguel Angel Panadero
 */

package PDR;

import java.io.*;
import java.net.*;
import java.sql.*;
//import java.util.Date;

public class PDRTipusVia {
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio con;               // Nos permite conectarnos con la base de datos.
    public  ResultSet  rSelectPublic;     // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int        TPSVIA_CTIPVIA;    // Nmero de identificacin del Tipus de Via.                         (Puesto por nosotros)
    public  int        DDSTPSVIA_CTPSVIA; // Ens dona el numero de les dades del tipus de via.                  (Posat per nosaltres)
    public  String     TVIAN;             // Nmero de identificador del Tipus de via para el INE               (Puesto por el ayuntamiento o por el INE)
    public  String     TVIA;              // Nombre del Tipus de Via.                                           (Puesto por el usuario)
    public  String     DTVIA;             // Descripci del Tipus de Via.                                       (Posat per l'usuari)
    private String     FVAR;              // Data del cambi.                                                    (Posat per nosaltres)
    public  String     CVAR;              // Codi de Variacio                                                   (Posat per nosaltres)
    private String     Envio;             // Ens indica si esta enviat al Ine.                                  (Posat per nosaltres)
    
    // Dades del Usuari
    public  int        CDG_USR;       // Nmero que identifica al usuari que esta realitzan les accion (Posat per nosaltres)
    
    // Relacionada con Errores
    public  String     sError;        // Guardamos todos los errores generados.
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    /** Creates a new instance of PDRTipusVia */
    public PDRTipusVia(int USR) 
    {
        TPSVIA_CTIPVIA    = -1;
        DDSTPSVIA_CTPSVIA = -1;
        TVIAN             = "";
        TVIA              = ""; 
        DTVIA             = "";
        FVAR              = "";
        CVAR              = "";
        Envio             = "";
        CDG_USR           = USR;
        sError            = "";
        con               = null;
        rSelectPublic     = null;
        sSiguiente        = "disabled";
        sAnterior         = "disabled";
    }
    
    public PDRTipusVia(BDConnexio conexion, int USR) 
    {
        TPSVIA_CTIPVIA    = -1;
        DDSTPSVIA_CTPSVIA = -1;
        TVIAN             = "";
        TVIA              = ""; 
        DTVIA             = "";
        FVAR              = "";
        CVAR              = "";
        Envio             = "";
        CDG_USR           = USR;
        sError            = "";
        con               = conexion;
        rSelectPublic     = null;
        sSiguiente        = "disabled";
        sAnterior         = "disabled";
    }
    
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    public void reiniciar()
    {
        TPSVIA_CTIPVIA    = -1;
        DDSTPSVIA_CTPSVIA = -1;
        TVIAN             = "";
        TVIA              = ""; 
        DTVIA             = "";
        FVAR              = "";
        CVAR              = "";
        Envio             = "";
        sError            = "";
        rSelectPublic     = null;
        sSiguiente        = "disabled";
        sAnterior         = "disabled";
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {
      try
      {
        TPSVIA_CTIPVIA    = Integer.parseInt(rSelect.getString("TPSVIA_CTIPVIA"));
        DDSTPSVIA_CTPSVIA = Integer.parseInt(rSelect.getString("DDSTPSVIA_CTPSVIA"));
        TVIAN             = rSelect.getString("TVIAN");
        TVIA              = rSelect.getString ("TVIA");
        DTVIA             = rSelect.getString ("DTVIA");
        FVAR              = rSelect.getString ("FVAR");
        CVAR              = rSelect.getString ("CVAR");
        Envio             = rSelect.getString ("Envio");
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Inserta un Tipus de Via en la taula de PDR_TPSVIA.
    public void insert()
    {
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        PDRNumerador pNum;
      
        //Date
        Data dFecha;
      
        pNum = new PDRNumerador(con); 
        try
        {
          // Possem un numero a les dades del Tipus de via.
          pNum.NMR_NOM = "NMR_DDSTipusVia";
          pNum.select();
          DDSTPSVIA_CTPSVIA = pNum.NMR_VLR;
      
          sbSql = null;
      
          stmt = con.cnPrincipal.createStatement();
          // Preparem la sentncia SQL per inseri en PDR_DDSTPSVIA
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append(" PDR_DDSTPSVIA ");
          sbSql.append(" (DDSTPSVIA_CTPSVIA, TVIAN,TVIA,DTVIA) ");
          sbSql.append(" values ");
          sbSql.append("('"+  DDSTPSVIA_CTPSVIA +"', '"+ TVIAN+"', '");
          sbSql.append(       TVIA              +"', '"+ DTVIA +"')");
          
          stmt.executeUpdate(sbSql.toString());
          
          // Posem un numero intern a la Entitta Colectiva
          pNum.NMR_NOM = "NMR_TipusVia";
          pNum.select();
          TPSVIA_CTIPVIA = pNum.NMR_VLR;
          
          // Preparem la sentncia SQL per inseri en PDR_TPSVIA
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append(" PDR_TPSVIA ");
          sbSql.append(" (TPSVIA_CTIPVIA) ");
          sbSql.append(" values ");
          sbSql.append(" ('"+TPSVIA_CTIPVIA+"') ");
          
          stmt.executeUpdate(sbSql.toString());
          
          // obtenim el dia al que estem.
          dFecha = new Data (con);
          
          FVAR = dFecha.darFecha();
          
          // Preparem la sentncia SQL per inseri en PDR_TPSVIA_has_DDSTPSVIA
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_TPSVIA_has_DDSTPSVIA ");
          sbSql.append(" (TPSVIA_CTIPVIA, DDSTPSVIA_CTPSVIA, CDG_USR, FVAR, CVAR, Envio) ");
          sbSql.append(" values ");
          sbSql.append("('"+ TPSVIA_CTIPVIA+"', '");
          sbSql.append(      DDSTPSVIA_CTPSVIA +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'A', 'N')");
          
          
        stmt.executeUpdate(sbSql.toString());
        
        stmt.close();
        con.cnPrincipal.commit();
 
    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un Update de un Tipus de Via en la taula de PDR_TPSVIA,
    // Solament es por updateixa la el nom y ladescripci del Tipus de Via.
    public void update()
    {
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        PDRNumerador pNum;
      
        //Date
        Data dFecha;
      
        pNum = new PDRNumerador(con); 
        try
        {
          // Possem un numero a les dades del Tipus de via.
          pNum.NMR_NOM = "NMR_DDSTipusVia";
          pNum.select();
          DDSTPSVIA_CTPSVIA = pNum.NMR_VLR;
      
          sbSql = null;
      
          stmt = con.cnPrincipal.createStatement();
          // Preparem la sentncia SQL per inseri en PDR_DDSTPSVIA
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append(" PDR_DDSTPSVIA ");
          sbSql.append(" (DDSTPSVIA_CTPSVIA, TVIAN,TVIA,DTVIA) ");
          sbSql.append(" values ");
          sbSql.append("('"+  DDSTPSVIA_CTPSVIA +"', '"+ TVIAN +"', '");
          sbSql.append(       TVIA              +"', '"+ DTVIA +"')");
          
          stmt.executeUpdate(sbSql.toString());
          
          // obtenim el dia al que estem.
          dFecha = new Data (con);
          
          FVAR = dFecha.darFecha();
          
          // Preparem la sentncia SQL per inseri en PDR_TPSVIA_has_DDSTPSVIA
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_TPSVIA_has_DDSTPSVIA ");
          sbSql.append(" (TPSVIA_CTIPVIA, DDSTPSVIA_CTPSVIA, CDG_USR, FVAR, CVAR, Envio) ");
          sbSql.append(" values ");
          sbSql.append("('"+ TPSVIA_CTIPVIA+"', '");
          sbSql.append(      DDSTPSVIA_CTPSVIA +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'M', 'N')");
            
          stmt.executeUpdate(sbSql.toString());
          stmt.close();
          con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un delete en la taula de Tipus de Via PDR_TPSVIA, 
    // mirant solament el numero del Tipus de via pusat per nosaltres.
    public void delete()
    {
      // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        PDRNumerador pNum;
      
        //Date
        Data dFecha;
      
        pNum = new PDRNumerador(con);
        try
        {
          // obtenim el dia al que estem.
          dFecha = new Data (con);
          
          FVAR = dFecha.darFecha();
          
          sbSql = null;
      
          stmt = con.cnPrincipal.createStatement();
          
          // Preparem la sentncia SQL per inseri en PDR_TPSVIA_has_DDSTPSVIA
          sbSql = new StringBuffer("");
          sbSql.append("Insert into  ");
          sbSql.append( " PDR_TPSVIA_has_DDSTPSVIA ");
          sbSql.append(" (TPSVIA_CTIPVIA, DDSTPSVIA_CTPSVIA, CDG_USR, FVAR, CVAR, Envio) ");
          sbSql.append(" values ");
          sbSql.append("('"+ TPSVIA_CTIPVIA+"', ");
          sbSql.append(  "'-1', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'B', 'N')");
            
          stmt.executeUpdate(sbSql.toString());
          stmt.close();
          con.cnPrincipal.commit();

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'un Tipus de Via
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
        // Cerramos el select anterior
        if (rSelectPublic != null){rSelectPublic.close();}  
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_TPSVIA_has_DDSTPSVIA THD,PDR_DDSTPSVIA DST");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DST.DDSTPSVIA_CTPSVIA = THD.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("  ) and ");
            sbSql.append("  ( DST.TVIAN  LIKE'%"+ TVIAN    +"%' or ");
            sbSql.append(   "'"+TVIAN +"'  = '') and");
            sbSql.append("  ( DST.TVIA  LIKE'%"+ TVIA    +"%' or ");
            sbSql.append(   "'"+TVIA +"'  = '') and");
            sbSql.append("  ( DST.DTVIA   LIKE'%"+ DTVIA +"%' or ");
            sbSql.append(   "'"+DTVIA           +"'    = '') and");
            sbSql.append("  THD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_TPSVIA_has_DDSTPSVIA THD2,PDR_DDSTPSVIA DST2");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DST2.DDSTPSVIA_CTPSVIA = THD2.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("    ) and "); 
            sbSql.append("    THD.TPSVIA_CTIPVIA = THD2.TPSVIA_CTIPVIA ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DST.DDSTPSVIA_CTPSVIA < DST2.DDSTPSVIA_CTPSVIA  or ");
            sbSql.append("    DST2.DDSTPSVIA_CTPSVIA = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            sbSql.append("  order by DST.TVIA ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
           rSelectPublic = rSelect;
           
           // Desbloqueamos o bloqueamos los botones que haga falta.
           if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
           if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
        }
        else
        {
           sError = sError + "e36: No existeix Tipus de Via cerca." +"<br />";
           rSelectPublic = null;
           // Desactivamos los botones de siguiente y anteriror.
           sSiguiente    = "disabled";
           sAnterior     = "disabled";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Carrega un Tipus de Via en el objecte que la cridat.
    public void darTpsVia(int TPSVIA_CTIPVIAaux, String TVIAaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
            stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_TPSVIA_has_DDSTPSVIA THD,PDR_DDSTPSVIA DST");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DST.DDSTPSVIA_CTPSVIA = THD.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("  ) and ");
            sbSql.append("  ( THD.TPSVIA_CTIPVIA ='"+ TPSVIA_CTIPVIAaux    +"' or ");
            sbSql.append("    DST.TVIA           ='"+ TVIAaux +"' ) and");
            sbSql.append("  THD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_TPSVIA_has_DDSTPSVIA THD2,PDR_DDSTPSVIA DST2");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DST2.DDSTPSVIA_CTPSVIA = THD2.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("    ) and "); 
            sbSql.append("    THD.TPSVIA_CTIPVIA = THD2.TPSVIA_CTIPVIA ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DST.DDSTPSVIA_CTPSVIA < DST2.DDSTPSVIA_CTPSVIA  or ");
            sbSql.append("    DST2.DDSTPSVIA_CTPSVIA = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e43: No existeix el Tipus de Via." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Carrega un Tipus de Via en el objecte que la cridat en la Data que ens donen.
    public void darTpsVia(int TPSVIA_CTIPVIAaux, String TVIAaux, String Data)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
            stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_TPSVIA_has_DDSTPSVIA THD,PDR_DDSTPSVIA DST");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DST.DDSTPSVIA_CTPSVIA = THD.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("  ) and ");
            sbSql.append("  ( THD.TPSVIA_CTIPVIA ='"+ TPSVIA_CTIPVIAaux    +"' or ");
            sbSql.append("    DST.TVIA           ='"+ TVIAaux +"' ) and");
            sbSql.append("  THD.CVAR <> 'B' and ");
            sbSql.append("  THD.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_TPSVIA_has_DDSTPSVIA THD2,PDR_DDSTPSVIA DST2");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DST2.DDSTPSVIA_CTPSVIA = THD2.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("    ) and "); 
            sbSql.append("    THD.TPSVIA_CTIPVIA = THD2.TPSVIA_CTIPVIA and");
            sbSql.append("    THD2.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
            sbSql.append("    (");
            sbSql.append("    DST.DDSTPSVIA_CTPSVIA < DST2.DDSTPSVIA_CTPSVIA  or ");
            sbSql.append("    DST2.DDSTPSVIA_CTPSVIA = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e43: No existeix el Tipus de Via." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
     
    
    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }
    
    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }
    
    // Comprueba si el Tipus de Via existe.
    public boolean existeTipusVia()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_TPSVIA_has_DDSTPSVIA THD,PDR_DDSTPSVIA DST");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DST.DDSTPSVIA_CTPSVIA = THD.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("  ) and ");
            sbSql.append("  ( THD.TPSVIA_CTIPVIA ='"+ TPSVIA_CTIPVIA    +"' or ");
            sbSql.append("    DST.TVIA          ='"+ TVIA +"' ) and");
            sbSql.append("  THD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_TPSVIA_has_DDSTPSVIA THD2,PDR_DDSTPSVIA DST2");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DST2.DDSTPSVIA_CTPSVIA = THD2.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("    ) and "); 
            sbSql.append("    THD.TPSVIA_CTIPVIA = THD2.TPSVIA_CTIPVIA ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DST.DDSTPSVIA_CTPSVIA < DST2.DDSTPSVIA_CTPSVIA  or ");
            sbSql.append("    DST2.DDSTPSVIA_CTPSVIA = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprueba si el nom del Tipus de Via existe.
    public boolean existeTVIA()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_TPSVIA_has_DDSTPSVIA THD,PDR_DDSTPSVIA DST");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DST.DDSTPSVIA_CTPSVIA = THD.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("  ) and ");
            sbSql.append("  DST.TVIA          ='"+ TVIA +"' and ");
            sbSql.append("  THD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_TPSVIA_has_DDSTPSVIA THD2,PDR_DDSTPSVIA DST2");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DST2.DDSTPSVIA_CTPSVIA = THD2.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("    ) and "); 
            sbSql.append("    THD.TPSVIA_CTIPVIA = THD2.TPSVIA_CTIPVIA ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DST.DDSTPSVIA_CTPSVIA < DST2.DDSTPSVIA_CTPSVIA  or ");
            sbSql.append("    DST2.DDSTPSVIA_CTPSVIA = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprueba si el Tipus de Via esta asignat a alguna Via.
    public boolean teVia()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
            sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
            sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
            sbSql.append("  ) and ");
            sbSql.append("  TPSVIA_CTIPVIA  = '"+ TPSVIA_CTIPVIA + "' and");
            sbSql.append("  VHD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
            sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
            sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
            sbSql.append("    ) and "); 
            sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
            sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset tots els Tipus de Via que no estiguin donats de baixa.
    public ResultSet TotsTipusVia()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_TPSVIA_has_DDSTPSVIA THD,PDR_DDSTPSVIA DST");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DST.DDSTPSVIA_CTPSVIA = THD.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("  ) and ");
            sbSql.append("  THD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_TPSVIA_has_DDSTPSVIA THD2,PDR_DDSTPSVIA DST2");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DST2.DDSTPSVIA_CTPSVIA = THD2.DDSTPSVIA_CTPSVIA  ");
            sbSql.append("    ) and "); 
            sbSql.append("    THD.TPSVIA_CTIPVIA = THD2.TPSVIA_CTIPVIA ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DST.DDSTPSVIA_CTPSVIA < DST2.DDSTPSVIA_CTPSVIA  or ");
            sbSql.append("    DST2.DDSTPSVIA_CTPSVIA = -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            sbSql.append("  order by DST.TVIA ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per Tipus de Via.
    public String MostrarTipusVia ()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRTipusVia  oTpsVia;
        int          i;
        
        sResultat = new StringBuffer("");
        oTpsVia   = new PDRTipusVia(con, CDG_USR);
        i = 0;
        
        try
        {
            // obtenim els Tots els Tipus de Via
            rSelect = oTpsVia.TotsTipusVia();
            
            sResultat.append("<SELECT NAME=\"TVIA\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oTpsVia.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oTpsVia.TVIA +"\"");
                if (TVIA.compareTo(oTpsVia.TVIA) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                sResultat.append(" >"+oTpsVia.TVIA+"</OPTION>" );
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Comprova si el Municipi es correcta per inserir-lo.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (TVIAN.compareTo("")==0)// Problema 139
      {
          sResultado = sResultado + "e139: Falta posar el nom normalitzat del Tipus de Via. <br /> " ;
      }
      if (TVIA.compareTo("")==0)// Problema 37
      {
          sResultado = sResultado + "e37: Falta posar el nom del Tipus de Via. <br /> " ;
      }
      
      if (DTVIA.compareTo("")==0)// Problema 38
      {
          sResultado = sResultado + "e38: Falta posar la descripci del Tipus de Via. <br /> " ;
      }
      
      
      if (existeTipusVia() )// Problema 39
      {
        sResultado = sResultado + "e39: El Tipus de Via ja existeix. <br /> " ;
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la provincia se puede updatear
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (TVIAN.compareTo("")==0)// Problema 139
      {
          sResultado = sResultado + "e139: Falta posar el nom normalitzat del Tipus de Via. <br /> " ;
      }
      if (TVIA.compareTo("")==0)// Problema 37
      {
          sResultado = sResultado + "e37: Falta posar el nom del Tipus de Via. <br /> " ;
      }
      
      if (DTVIA.compareTo("")==0)// Problema 38
      {
          sResultado = sResultado + "e38: Falta posar la descripci del Tipus de Via. <br /> " ;
      }
      
      if (! existeTipusVia() )// Problema 40
      {
        sResultado = sResultado + "e40: El Tipus de Via no existeix. <br /> " ;
      }
      else
      {
        if (existeTVIA()) // Problema 42
        {
          sResultado = sResultado + "e42: El nom del Tipus de Via ja existeix. <br /> " ;
        }
      }
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si el Tipus de Via se puede borrar.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (TVIAN.compareTo("")==0)// Problema 139
      {
          sResultado = sResultado + "e139: Falta posar el nom normalitzat del Tipus de Via. <br /> " ;
      }
      if (TVIA.compareTo("")==0)// Problema 37
      {
          sResultado = sResultado + "e37: Falta posar el nom del Tipus de Via. <br /> " ;
      }
      
      if (TPSVIA_CTIPVIA == -1)// Problema 16
      {
        sResultado = sResultado + "e138: El delete requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      else
      {
        //Comprovem si aquesta provincia no tingui cap municipi asignat.
        if ( teVia() )// Problema 41
        {
            sResultado = sResultado + "e41: El Tipus de Via te assignada una Via i no es pot esborra. <br /> " ;
        }
      }
      if (! existeTipusVia() )// Problema 40
      {
        sResultado = sResultado + "e40: El Tipus de Via no existeix. <br /> " ;
      }
            
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprova si podem fer el select.
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hay comprovaciones.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
}
