/*
 * PDRUnioHabitantHabitatge.java
 *
 * Created on 19 de abril de 2006, 11:46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */
package PDR;
import java.io.*;
import java.net.*;
import java.sql.*;

/**
 * @author Miguel Panadero
 */
public class PDRUnioHabitantHabitatge {
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio   con;               // Nos permite conectarnos con la base de datos.
    public  ResultSet    rSelectPublic;     // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int          CDG_PRV;           // Nmero de identificacin de la provincia.                (Posat per nosaltres)
    public  int          CDG_MNC;           // Nmero que identifica la provincia.                      (Posat per nosaltres)
    public  String       CAUV;              // Motiu de variaci de les dades.                          (Posat per l'usuari)
    private String       FVAR;              // Data del cambi.                                          (Posat per nosaltres)
    public  String       CVAR;              // Codi de Variacio                                         (Posat per nosaltres)
    private String       Envio;             // Ens indica si esta enviat al Ine.                        (Posat per nosaltres)
    public  int[]        iTablaHab;         // Tabla que contiene los habitantes que estamos tratando.  (Posat per nosaltres) 
    
    // Contenedores de otras clases.
    public  PDRHabitant  HABITANT;          // Objecta Habitant.                                        (Posat per l'usuari)
    public  PDRHabitatge HABITATGE;         // Objecta Habitatge                                        (Posat per l'usuari)
    
    // Relacionada con Errores
    public  String     sError;          // Guardamos todos los errores generados.
    // Dades del Usuari
    public  int        CDG_USR;         // Nmero que identifica al usuari que esta realitzan les accion (Posat per nosaltres)
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    // Creates a new instance of PDRUnioHabitantHabitatge 
    public PDRUnioHabitantHabitatge(int USR)  
    {
        // Relacionada con la base de datos
        con           = null;               
        rSelectPublic = null;  
        // De la base de datos
        CDG_PRV       = -1;
        CDG_MNC       = -1;
        CAUV          = ""; 
        iTablaHab     = new int[1];
        iTablaHab[0]  = -1;   
        FVAR          = "";
        CVAR          = "";
        Envio         = "";
    
        // Contenedores de otras clases.
        HABITANT  = new PDRHabitant(USR);            
        HABITATGE = new PDRHabitatge(USR);       
    
        // Relacionada con Errores
        sError   = "";         
        // Dades del Usuari
        CDG_USR  = USR;    
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
    }
    
    // Creates a new instance of PDRUnioHabitantHabitatge 
    public PDRUnioHabitantHabitatge(BDConnexio conexion, int USR) 
    {
         // Relacionada con la base de datos
        con           = conexion;               
        rSelectPublic = null;  
        // De la base de datos
        CDG_PRV       = -1;
        CDG_MNC       = -1;
        CAUV          = "";
        iTablaHab     = new int[1];
        iTablaHab[0]  = -1;
        FVAR          = "";
        CVAR          = "";
        Envio         = "";  
    
        // Contenedores de otras clases.
        HABITANT  = new PDRHabitant (conexion, USR);            
        HABITATGE = new PDRHabitatge(conexion, USR);       
    
        // Relacionada con Errores
        sError   = "";         
        // Dades del Usuari
        CDG_USR  = USR;    
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
    }
     
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    public void reiniciar()
    {            
        // Relacionada con la base de datos               
        rSelectPublic = null;  
        // De la base de datos                
        CAUV          = ""; 
        iTablaHab     = new int[1];
        iTablaHab[0]  = -1;
        FVAR          = "";
        CVAR          = "";
        Envio         = "";
        
        // Contenedores de otras clases.
        HABITANT.reiniciar();
        HABITATGE.reiniciar();
    
        // Relacionada con Errores
        sError   = "";   
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
    }
    
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    // Ni taula de habitants
    public void reiniciarHabitatge()
    {            
        // Relacionada con la base de datos               
        rSelectPublic = null;  
        // De la base de datos                
        CAUV          = ""; 
        FVAR          = "";
        CVAR          = "";
        Envio         = "";
        
        // Contenedores de otras clases.
        HABITANT.reiniciar();
        HABITATGE.reiniciar();
    
        // Relacionada con Errores
        sError   = "";   
        // Relacionadas con estado de los botones.
        sSiguiente = "disabled";
        sAnterior  = "disabled";
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    private void rellenar(ResultSet rSelect)
    {   
      try
      {
        // Dades de PDR_DDSTRM
        CDG_PRV   = Integer.parseInt(rSelect.getString("CDG_PRV")); 
        CDG_MNC   = Integer.parseInt(rSelect.getString("CDG_MNC"));
        
        // Carguem les dades de la Pseudovia.
        if (Integer.parseInt(rSelect.getString("CDG_CHBTG")) != -1)
        {
            HABITATGE.CDG_PRV = CDG_PRV;
            HABITATGE.CDG_MNC = CDG_MNC;
            HABITATGE.darHabitatge(Integer.parseInt(rSelect.getString("CDG_CHBTG"))); 
            // Intoduim el posibles error en els errors d'aquest objecte.
            if (HABITATGE.sError.compareTo("") != 0)
            {
                sError = sError + HABITATGE.sError + "<br />"; 
            }
        }
        else
        {
          HABITATGE.reiniciar();
        }
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    
    // Inserta los datos del Habitage en la taula de PDR_HABITATGE.
    // Inserta la relaci Habitant-Habitatge en la taula de PDR_TRM_has_DDSTRM.
    public void insert()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      
      // Date
      Data dFecha;
      
      try
      {
            
        sbSql = null;
      
        stmt = con.cnPrincipal.createStatement();

        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha();
        
        // Preparem la sentncia SQL per inseri en PDR_HBT_has_HABITATGE
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_habitant_has_habitatge ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CHBT, CDG_CHBTG, CDG_USR, FVAR, CVAR, CAUV, Envio) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ HABITANT.CDG_CHBT+"', '");
        sbSql.append(      HABITATGE.CDG_CHBTG +"', '"+ CDG_USR  +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'A', '"+ CAUV +"' , 'N')");
        
        stmt.executeUpdate(sbSql.toString());
        
        stmt.close();
        con.cnPrincipal.commit();
        
    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un Insert en la taula PDR_habitant_has_HABITATGE enllaant Habitant-Habitatge Noves.
    // Es pot updateixa tot menys Provincia i Municipi.
    public void update(int iHab)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      
      // Date
      Data dFecha;
      
      sbSql = null;
      try{
        stmt = con.cnPrincipal.createStatement();
       
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha();
        
        // Preparem la sentncia SQL per inseri en PDR_HBT_has_HABITATGE
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append(" PDR_Habitant_has_habitatge ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CHBT, CDG_CHBTG, CDG_USR, FVAR, CVAR, CAUV, Envio) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV              +"', '"+ CDG_MNC +"', '"+ iHab +"', '");
        sbSql.append(      HABITATGE.CDG_CHBTG  +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'M','"+ CAUV +"', 'N')");
        

        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    
    // Fa un Insert en la taula PDR_Habitant_has_HABITATGE enllaant HABITANT-HABITATGE, inserim en motiu envia a Ine Baixa.
    // Te part del codi en el jsp.
    public void delete(int iHab)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      
      // Date
      Data dFecha;
      
      sbSql = null;
      try{
        stmt = con.cnPrincipal.createStatement();
       
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha();
        
        // Preparem la sentncia SQL per inseri en PDR_HBT_has_HABITATGE
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append(" PDR_Habitant_has_habitatge ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CDG_CHBT, CDG_CHBTG, CDG_USR, FVAR, CVAR, CAUV, Envio) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ iHab +"', ");
        sbSql.append(   " '-1', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'B','"+ CAUV +"', 'N')");
        

        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'un Habitatge que no estigui de baixa.
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      
      try{
        // Cerramos el select anterior
        if (rSelectPublic != null){rSelectPublic.close();}  
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_HABITATGE HBTG");
        sbSql.append(" where ");
        sbSql.append("  HBTG.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  HBTG.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( HBTG.CDG_CTRM ='"+ HABITATGE.TRAM.CDG_CTRM +"' or ");
        sbSql.append(   "'"+HABITATGE.TRAM.CDG_CTRM +"'  = -1) and");
        sbSql.append("  ( HBTG.CDG_CPSVIA ='"+ HABITATGE.PSEUDOVIA.CDG_CPSVIA +"' or ");
        sbSql.append(   "'"+HABITATGE.PSEUDOVIA.CDG_CPSVIA +"'  = -1) and");
        sbSql.append("  ( HBTG.CDG_CHBTG ='"+ HABITATGE.CDG_CHBTG +"' or ");
        sbSql.append(   "'"+HABITATGE.CDG_CHBTG           +"'  = -1) and");
        sbSql.append("  ( HBTG.NHOP ='"+ HABITATGE.NHOP +"' or ");
        sbSql.append(   "'"+HABITATGE.NHOP           +"'  = '' ) and");
        sbSql.append("  ( HBTG.NUMER ='"+ HABITATGE.NUMER +"' or ");
        sbSql.append(   "'"+HABITATGE.NUMER           +"'  = -1) and");
        sbSql.append("  ( HBTG.CNUMER ='"+ HABITATGE.CNUMER +"' or ");
        sbSql.append(   "'"+HABITATGE.CNUMER           +"'  = '' ) and");
        sbSql.append("  ( HBTG.NUMERS ='"+ HABITATGE.NUMERS +"' or ");
        sbSql.append(   "'"+HABITATGE.NUMERS           +"'  = -1) and");
        sbSql.append("  ( HBTG.CNUMERS ='"+ HABITATGE.CNUMERS +"' or ");
        sbSql.append(   "'"+HABITATGE.CNUMERS           +"'  = '' ) and");
        sbSql.append("  ( HBTG.KMT ='"+ HABITATGE.KMT +"' or ");
        sbSql.append(   "'"+HABITATGE.KMT           +"'  = -1) and");
        sbSql.append("  ( HBTG.HMT ='"+ HABITATGE.HMT +"' or ");
        sbSql.append(   "'"+HABITATGE.HMT           +"'  = -1) and");
        sbSql.append("  ( HBTG.BLOQ ='"+ HABITATGE.BLOQ +"' or ");
        sbSql.append(   "'"+HABITATGE.BLOQ           +"'  = '' ) and");
        sbSql.append("  ( HBTG.PORT ='"+ HABITATGE.PORT +"' or ");
        sbSql.append(   "'"+HABITATGE.PORT           +"'  = '' ) and");
        sbSql.append("  ( HBTG.ESCA ='"+ HABITATGE.ESCA +"' or ");
        sbSql.append(   "'"+HABITATGE.ESCA           +"'  = '' ) and");
        sbSql.append("  ( HBTG.PLAN ='"+ HABITATGE.PLAN +"' or ");
        sbSql.append(   "'"+HABITATGE.PLAN           +"'  = '' ) and");
        sbSql.append("  ( HBTG.PUER ='"+ HABITATGE.PUER +"' or ");
        sbSql.append(   "'"+HABITATGE.PUER           +"'  = '' ) and");
        sbSql.append("  ( HBTG.TLOC ='"+ HABITATGE.TLOC +"' or ");
        sbSql.append(   "'"+HABITATGE.TLOC           +"'  = '' ) and");
        sbSql.append("  HBTG.Estado <> 'Baja' ");
        sbSql.append("  order by HBTG.CDG_CHBTG ");

        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
           rSelectPublic = rSelect;
           
           // Desbloqueamos o bloqueamos los botones que haga falta.
           if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
           if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
        }
        else
        {
           sError = sError + "e75: No existeixen Habitatges amb aquestes  caracterstiques." +"<br />";
           rSelectPublic = null;
           // Desactivamos los botones de siguiente y anteriror.
           sSiguiente    = "disabled";
           sAnterior     = "disabled";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs. " + "<br />";}
    }
    
    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs. " + "<br />";}
    }
    
    // Dona un hatml on mostra els habitants d'una casa.
    public String mostrarHabitants()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        int          i;
        
        sResultat = new StringBuffer("");
        
        i = 0;
        
        try
        {
            // obtenim els habitants que viuen a aquesta casa
            rSelect = HABITATGE.habitantsdelHabitatge();
            
            // construim una taula per guarda els habitants del habitatge.
            iTablaHab = new int[HABITATGE.numeroHabitants() + 1];
            
            // Posem els tituls de las columnes.
            sResultat.append("<TR width='100%'>"); 
            sResultat.append("<TD class='form1' nowrap>");
            sResultat.append("NIA");
            sResultat.append("</TD>");
            sResultat.append("<TD class='form1' nowrap>");
            sResultat.append("Nom i Cognoms");
            sResultat.append("</TD>");
            sResultat.append("</TR>");
            
            // fem tants inserts en PDR_habitant_has_HABITATGE com habitatns hi han.
            while (rSelect.next())
            {                
                // Obtenim el numero del habitant que esta al Habitatge.
                HABITATGE.rellenarHabitant(rSelect);
                
                // Carreguem provincia y municipi en el objecta habitant.
                HABITANT.CDG_PRV = CDG_PRV;
                HABITANT.CDG_MNC = CDG_MNC;
                
                // Carreguem a Habitant les dades del Habitant que acabem de obteni.
                HABITANT.darHabitant(HABITATGE.CDG_CHBT,"","","","","","");
                
                
                if (HABITANT.sError.compareTo("") != 0)
                {
                    sError = sError + HABITANT.sError + "<br />";
                }
                
                // Carguem els noms del habitants d'aquest habitatge a la taula iTablaHab
                iTablaHab[i] = HABITANT.CDG_CHBT;
                i++;
                        
                // Mirem si el subjecta esta donat de baixa.
                if (HABITANT.DDSHBT_CHBT != -1)
                {
                    sResultat.append("<TR width='100%'>"); 
                    sResultat.append("<TD class='form1' nowrap>");
                    sResultat.append(HABITANT.NIA);
                    sResultat.append("</TD>");
                    sResultat.append("<TD class='form1' nowrap>"); 
                    sResultat.append(HABITANT.NOMB +" "+ HABITANT.PART1 +" "+ HABITANT.APE1 +" "+ HABITANT.PART2 +" "+ HABITANT.APE2);
                    sResultat.append("</TD>");
                    sResultat.append("<TD class='form1' nowrap>"); 
                    sResultat.append("<INPUT TYPE=CHECKBOX NAME=\""+ "CHECKBOX" + HABITANT.CDG_CHBT +"\">");
                    sResultat.append("</TD></TR>");
                }                
            }
            
            sResultat.append("<TR width='100%'>"); 
            sResultat.append("<TD class='form1' nowrap>");
            sResultat.append("<input type=\"text\" name=\"NIA\">  ");
            sResultat.append("</TD>");
            sResultat.append("<TD class='form1' nowrap>");
            sResultat.append("<input type=\"submit\"  name=\"Grabar\"   value=\"Alta\">  ");
            sResultat.append("<input type=\"submit\"  name=\"Update\"   value=\"Modificar\">  ");
            sResultat.append("<input type=\"submit\"  name=\"Eliminar\" value=\"Baixa\">  ");
            sResultat.append("</TD></TR>");
            
            iTablaHab[i] = -1;
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
        return (sResultat.toString());
    }
    
    // Dona un hatml on mostra els habitants d'una casa.
    public String mostrarHabitantsdeTaula()
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        int          i;
        
        sResultat = new StringBuffer("");
        i = 0;
        
        try
        { 
            // Posem els tituls de las columnes.
            sResultat.append("<TR width='100%'>"); 
            sResultat.append("<TD class='form1' nowrap>");
            sResultat.append("NIA");
            sResultat.append("</TD>");
            sResultat.append("<TD class='form1' nowrap>");
            sResultat.append("Nom i Cognoms");
            sResultat.append("</TD>");
            sResultat.append("</TR>");
            
            // fem tants inserts en PDR_habitant_has_HABITATGE com habitatns hi han.
            while (iTablaHab[i] != -1)
            {                
                // Carreguem provincia y municipi en el objecta habitant.
                HABITANT.CDG_PRV = CDG_PRV;
                HABITANT.CDG_MNC = CDG_MNC;
                
                // Carreguem a Habitant les dades del Habitant que acabem de obteni.
                HABITANT.darHabitant(iTablaHab[i], "","","","","","");
                
               // Mirem si el subjecta esta donat de baixa.
                if (HABITANT.DDSHBT_CHBT != -1)
                {
                    sResultat.append("<TR width='100%'>"); 
                    sResultat.append("<TD class='form1' nowrap>");
                    sResultat.append(HABITANT.NIA);
                    sResultat.append("</TD>");
                    sResultat.append("<TD class='form1' nowrap>"); 
                    sResultat.append(HABITANT.NOMB +" "+ HABITANT.PART1 +" "+ HABITANT.APE1 +" "+ HABITANT.PART2 +" "+ HABITANT.APE2);
                    sResultat.append("</TD>");
                    sResultat.append("<TD class='form1' nowrap>"); 
                    sResultat.append("<INPUT TYPE=CHECKBOX NAME=\""+ "CHECKBOX" + HABITANT.CDG_CHBT +"\">");
                    sResultat.append("</TD></TR>");
                }    
                
                 i++;
            }
            
            sResultat.append("<TR width='100%'>"); 
            sResultat.append("<TD class='form1' nowrap>");
            sResultat.append("<input type=\"text\" name=\"NIA\">  ");
            sResultat.append("</TD>");
            sResultat.append("<TD class='form1' nowrap>");
            sResultat.append("<input type=\"submit\"  name=\"Grabar\" value=\"Alta\">  ");
            sResultat.append("<input type=\"submit\"  name=\"Update\"   value=\"Modificar\">  ");
            sResultat.append("<input type=\"submit\"  name=\"Eliminar\" value=\"Baixa\">  ");
            sResultat.append("</TD></TR>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
        return (sResultat.toString());
    }
    
    // Comprova si el Habitatge es correcta per inserir-la.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema.
      if (CAUV.compareTo("") == 0)// Problema 128
      {
          sResultado = sResultado + "e128: Falta posar la Causa de la Variaci. <br /> " ;
      } 
      if (! HABITATGE.existeHabitatge())// Problema 126
      {
          sResultado = sResultado + "e126: El Habitatge no existeix. <br /> " ;
      }
      if (! HABITANT.existeHabitant())// Problema 111
      {
          sResultado = sResultado + "e111: El Habitant no existeix. <br /> " ;
      }
      if (HABITANT.habitantTeHabitatge())// Problema 130
      {
         sResultado = sResultado + "e130: El Habitant te un Habitatge assignat. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si el Habitatge se puede updatear
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
              
      // El nombre ens indica el problema. 
      if (CAUV.compareTo("") == 0)// Problema 128
      {
          sResultado = sResultado + "e128: Falta posar la Causa de la Variaci. <br /> " ;
      } 
      if (! HABITATGE.existeHabitatge())// Problema 126
      {
          sResultado = sResultado + "e126: El Habitatge no existeix. <br /> " ;
      }      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si el habitatge es pot esborrar.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema.
      if (CAUV.compareTo("") == 0)// Problema 128
      {
          sResultado = sResultado + "e128: Falta posar la Causa de la Variaci. <br /> " ;
      } 
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    
    // Comprova si podem fer el select.
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hi ha comprovacions.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }   
     
}
