/*
 * PDRVia.java
 *
 * Created on 13 de julio de 2005, 12:22
 *
 */

package PDR;

import java.io.*;
import java.net.*;
import java.sql.*;
//import java.util.GregorianCalendar;

/**
 * @author Miguel Angel Panadero
 */

public class PDRVia {
    
    // Variables.
    // Relacionada con la base de datos
    public  BDConnexio con;           // Nos permite conectarnos con la base de datos.
    public  ResultSet  rSelectPublic; // Lo utilizaremos para tirar adelante y atras los selects.
    // De la base de datos
    public  int         CDG_PRV;       // Nmero de identificacin de la provincia.        (Posat per nosaltres)
    public  int         CDG_MNC;       // Nmero que identifica la provincia.              (Posat per nosaltres)
    public  int         CDG_VIA;       // Nmeroque indentifica la via.                    (Posat per nosaltres)
    public  int         DDSVIA_CVIA;   // Nmero de identificacin de las dades de la via. (Posat per nosaltres)
    public  int         CVIA;          // Cdi de la via.                                  (Posat per l'Ine) 
    public  int         POS;           // Posicio de la via.                               (Posat per l'usuari)
    public  String      NVIA;          // Nom de la via.                                   (Posat per l'usuari)
    public  String      NVIAC;         // Nom curt de la via.                              (Posat per l'usuari)
    private String      FVAR;          // Data del cambi.                                  (Posat per nosaltres)
    public  String      CVAR;          // Codi de Variacio                                 (Posat per nosaltres)
    private String      Envio;         // Ens indica si esta enviat al Ine.                (Posat per nosaltres)
    // Contenedores de otras clases.
    public  PDRTipusVia TPSVIA;        // Tipus de via.                                    (Posat per nosaltres)
    // Relacionada con Errores
    public  String     sError;        // Guardamos todos los errores generados.
    // Dades del Usuari
    public  int        CDG_USR;       // Nmero que identifica al usuari que esta realitzan les accion (Posat per nosaltres)
    // Relacionadas con estado de los botones.
    public  String     sSiguiente;
    public  String     sAnterior;
    
    /** Creates a new instance of PDRVia */
    public PDRVia(int USR) 
    {
      con            = null;          
      rSelectPublic  = null;  
      // De la base de datos
      CDG_PRV        = -1;    
      CDG_MNC        = -1;
      CDG_VIA        = -1;
      DDSVIA_CVIA    = -1;
      TPSVIA         = new PDRTipusVia (USR);
      CVIA           = -1;         
      POS            = -1;          
      NVIA           = "";         
      NVIAC          = "";
      FVAR           = "";
      CVAR           = "";
      Envio          = "";
      // Relacionada con Errores
      sError         = "";  
      // Dades del Usuari
      CDG_USR        = USR;     
      // Relacionadas con estado de los botones.
      sSiguiente     = "disabled";
      sAnterior      = "disabled";
       
    }
    
    public PDRVia(BDConnexio conexion, int USR) 
    {
      con            = conexion;          
      rSelectPublic  = null;
      // De la base de datos
      CDG_PRV        = -1;    
      CDG_MNC        = -1;
      CDG_VIA        = -1;
      DDSVIA_CVIA    = -1;
      TPSVIA         = new PDRTipusVia (conexion, USR);
      CVIA           = -1;         
      POS            = -1;          
      NVIA           = "";         
      NVIAC          = "";
      FVAR           = "";
      CVAR           = "";
      Envio          = "";      
      // Relacionada con Errores
      sError         = "";  
      // Dades del Usuari
      CDG_USR        = USR;     
      // Relacionadas con estado de los botones.
      sSiguiente     = "disabled";
      sAnterior      = "disabled";        
    }
    
    // Deja los parametros como si se hubiera acabado de crear.
    // No rectifica ni conexion, ni usuario.
    // Ni Provincia, ni Municipi.
    public void reiniciar()
    {          
      rSelectPublic  = null;
      // De la base de datos
      CDG_VIA        = -1;
      DDSVIA_CVIA    = -1;
      TPSVIA         = new PDRTipusVia (con, CDG_USR);
      CVIA           = -1;         
      POS            = -1;          
      NVIA           = "";         
      NVIAC          = "";
      FVAR           = "";
      CVAR           = "";
      Envio          = "";      
      // Relacionada con Errores
      sError         = "";     
      // Relacionadas con estado de los botones.
      sSiguiente     = "disabled";
      sAnterior      = "disabled";
    }
    
    // Omple las variables de la base de dades amb les dades del resulset (rSelect)
    public void rellenar(ResultSet rSelect)
    {   
      try
      {
        // Dades de PDR_DDSVIA
        CDG_PRV         = Integer.parseInt(rSelect.getString("CDG_PRV")); 
        CDG_MNC         = Integer.parseInt(rSelect.getString("CDG_MNC"));
        DDSVIA_CVIA     = Integer.parseInt(rSelect.getString("DDSVIA_CVIA"));
        POS             = Integer.parseInt(rSelect.getString("POS"));    
        NVIA            = rSelect.getString ("NVIA");  
        NVIAC           = rSelect.getString ("NVIAC");
        CVIA            = Integer.parseInt(rSelect.getString("CVIA"));  
        
        // Carguem les dades del tipus de via.
        TPSVIA.darTpsVia(Integer.parseInt(rSelect.getString("TPSVIA_CTIPVIA")),"");
        // Intoduim el posibles error en els errors d'aquest objecte.
        if (TPSVIA.sError.compareTo("") == 0)
        {
          sError = sError + TPSVIA.sError + "<br />"; 
        }
        
        // Dades de PDR_VIA_has_DDSVIA que no estan en l'altre.
        CDG_VIA         = Integer.parseInt(rSelect.getString("CDG_VIA"));
        CDG_USR         = Integer.parseInt(rSelect.getString("CDG_USR")); 
        FVAR            = rSelect.getString ("FVAR").substring(1, 10); 
        CVAR            = rSelect.getString("CVAR");
        Envio           = rSelect.getString ("Envio"); 
        
      } catch (Exception e)
      {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
      }
    }
    
    // Inserta los datos de la via en la taula de PDR_DDSVIA.
    // Inserta la via en taula de PDR_VIA.
    // Inserta la relaci via-dades en la taula de PDR_Via_has_DDSVia.
    public void insert()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador ViaNum;
      
      // Date
      Data dFecha;
      
      ViaNum = new PDRNumerador(con);
      try
      {
        // Possem un numero a les dades de la Via.
        ViaNum.NMR_NOM = "NMR_DDSVIA_CVIA";
        ViaNum.select();
        DDSVIA_CVIA = ViaNum.NMR_VLR;
            
        sbSql = null;
      
        stmt = con.cnPrincipal.createStatement();

        // Preparem la sentncia SQL per inseri en PDR_DDSVIA
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_DDSVIA ");
        sbSql.append(" (CDG_PRV, CDG_MNC, DDSVIA_CVIA, CVIA, TPSVIA_CTIPVIA, POS, NVIA, NVIAC) ");
        sbSql.append(" values ");
        sbSql.append("('"+  CDG_PRV +"', '"+ CDG_MNC        +"', '"+ DDSVIA_CVIA+"', '");
        sbSql.append(       CVIA    +"', '"+ TPSVIA.TPSVIA_CTIPVIA +"', '"+ POS       +"', '");
        sbSql.append(       NVIA    +"', '"+ NVIAC      +"')");

        stmt.executeUpdate(sbSql.toString());
                
        // Possem un numero a la Via.
        ViaNum.NMR_NOM = "NMR_VIA";
        ViaNum.select();
        CDG_VIA = ViaNum.NMR_VLR;
        
        // Preparem la sentncia SQL per inseri en PDR_VIA
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_VIA ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CDG_VIA) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV +"', '"+ CDG_MNC +"', '"+ CDG_VIA+"')");
        
        stmt.executeUpdate(sbSql.toString());
        
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha();
        
        // Preparem la sentncia SQL per inseri en PDR_Via_has_DDSVia
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_Via_has_DDSVia ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CDG_VIA, DDSVIA_CVIA, CDG_USR, FVAR, CVAR, Envio) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ CDG_VIA+"', '");
        sbSql.append(      DDSVIA_CVIA +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'A', 'N')");
        
        stmt.executeUpdate(sbSql.toString());
        
        stmt.close();
        con.cnPrincipal.commit();
        
    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un Insert de las dades de una Via en la taula de PDR_DDSVI.
    // Fa un Insert en la taula PDR_Via_has_DDSVia enllaant via-Dades Noves.
    // Es pot updateixa Tipus de via, Posicio, el codigo de via, el nom, el nom curt.
    public void update()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      PDRNumerador ViaNum;
      
      // Date
      Data dFecha;
      
      ViaNum = new PDRNumerador(con);
      try{
        // Possem un numero a les dades de la Via.
        ViaNum.NMR_NOM = "NMR_DDSVIA_CVIA";
        ViaNum.select();
        DDSVIA_CVIA = ViaNum.NMR_VLR;
      
        sbSql = null;
      
        stmt = con.cnPrincipal.createStatement();
       
        // Preparem la sentncia SQL per inseri en PDR_DDSVIA
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_DDSVIA ");
        sbSql.append(" (CDG_PRV, CDG_MNC, DDSVIA_CVIA, CVIA, TPSVIA_CTIPVIA, POS, NVIA, NVIAC) ");
        sbSql.append(" values ");
        sbSql.append("('"+  CDG_PRV    +"', '"+ CDG_MNC        +"', '"+ DDSVIA_CVIA+"', '");
        sbSql.append(       CVIA        +"', '"+ TPSVIA.TPSVIA_CTIPVIA +"', '"+ POS       +"', '");
        sbSql.append(       NVIA        +"', '"+ NVIAC          +"')");
        
        stmt.executeUpdate(sbSql.toString());
        
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha(); 
        
        // Preparem la sentncia SQL per inseri en PDR_Via_has_DDSVia
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_Via_has_DDSVia ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CDG_VIA, DDSVIA_CVIA, CDG_USR, FVAR, CVAR, Envio) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ CDG_VIA+"', '");
        sbSql.append(      DDSVIA_CVIA +"', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'M','N')");

        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Recupera les dades de la via que anem a borrar.
    // Fa un Insert en la taula PDR_Via_has_DDSVia enllaant via-Dades, inserim en motiu envia a Ine Baixa.
    public void delete()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      
      // Date
      Data dFecha;
      
      sbSql = null;
      try{
        stmt = con.cnPrincipal.createStatement();
       
        // obtenim el dia al que estem.
        dFecha = new Data (con);
          
        FVAR = dFecha.darFecha();
        
        // Preparem la sentncia SQL per inseri en PDR_Via_has_DDSVia
        sbSql = new StringBuffer("");
        sbSql.append("Insert into  ");
        sbSql.append( " PDR_Via_has_DDSVia ");
        sbSql.append(" (CDG_PRV, CDG_MNC, CDG_VIA, DDSVIA_CVIA, CDG_USR, FVAR, CVAR, Envio) ");
        sbSql.append(" values ");
        sbSql.append("('"+ CDG_PRV    +"', '"+ CDG_MNC +"', '"+ CDG_VIA+"', ");
        sbSql.append(    "'-1', '"+ CDG_USR +"', to_timestamp('"+ FVAR +"23:59:59','DD/MM/YYYY:HH24:MI:SS'), 'B','N')");

        stmt.executeUpdate(sbSql.toString());
        stmt.close();
        con.cnPrincipal.commit();

    } catch (Exception e)
    {
        sError = sError + ("Fallo en la base de datos:"+e + "<br />");
        try
        {con.cnPrincipal.rollback();
        }catch (Exception e2)
        {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Fa un select d'una via
    public void select()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
        // Cerramos el select anterior
        if (rSelectPublic != null){rSelectPublic.close();}  
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
        sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
        sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DVI.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DVI.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( DVI.TPSVIA_CTIPVIA ='"+ TPSVIA.TPSVIA_CTIPVIA +"' or ");
        sbSql.append(   "'"+TPSVIA.TVIA +"'  = '') and");
        sbSql.append("  ( DVI.CVIA ='"+ CVIA +"' or ");
        sbSql.append(   "'"+CVIA           +"'  = -1) and");
        sbSql.append("  ( DVI.POS  ='"+ POS  +"' or ");
        sbSql.append(   "'"+POS            +"'  = -1) and");
        sbSql.append("  ( DVI.NVIA LIKE'%"+ NVIA +"%' or ");
        sbSql.append(   "'"+NVIA           +"' = '') and");
        sbSql.append("  ( DVI.NVIAC LIKE'%"+ NVIAC +"%' or ");
        sbSql.append(   "'"+NVIAC          +"' = '') and");
        sbSql.append("  VHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
        sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
        sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
        sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
        sbSql.append("  order by NVIA ");
       
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
        if (rSelect.next())
        {
           rellenar(rSelect);
           rSelectPublic = rSelect;
           
           // Desbloqueamos o bloqueamos los botones que haga falta.
           if (rSelect.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
           if (rSelect.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
        }
        else
        {
           sError = sError + "e29: No existeixen Vies amb aquestes caracterstiques. " +"<br />";
           rSelectPublic = null;
           // Desactivamos los botones de siguiente y anteriror.
           sSiguiente    = "disabled";
           sAnterior     = "disabled";
        }

    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
    }
    
    // Mueve el resulset hacia adelante y rellena las variables con la nueva informacin.
    public void siguiente ()
    {
      if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.next())
          {
            rellenar(rSelectPublic);
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e9: No hi ha element segent." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }
    
    // Mueve el resulset hacia atras y rellena las variables con la nueva informacin.
    public void anterior ()
    {
       if (rSelectPublic != null)
      {
        try{
          if (rSelectPublic.previous())
          {
            rellenar(rSelectPublic);
            
            // Desbloqueamos o bloqueamos los botones que haga falta.
            if (rSelectPublic.isFirst()){sAnterior  = "disabled";} else {sAnterior  = "";}
            if (rSelectPublic.isLast() ){sSiguiente = "disabled";} else {sSiguiente = "";}
          }
          else {sError = sError + "e10: No hi ha element anterior." + "<br />";}
        } catch (Exception e)
        {
          sError = sError + ("Fallo en la base de datos: "+e + "<br />");
        }
            
      }
      else {sError = sError + "e8: No hi ha cerca en curs." + "<br />";}
    }
    
    // Carrega la Via en el objecte que la cridat.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public void darVia(int CDG_VIAaux, String NVIAaux)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
        sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
        sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DVI.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DVI.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( DVI.NVIA ='"+ NVIAaux +"' or ");
        sbSql.append(   "'"+NVIAaux           +"' = '') and");
        sbSql.append("  ( VHD.CDG_VIA ='"+ CDG_VIAaux +"' or ");
        sbSql.append(   "'"+CDG_VIAaux          +"' = '-1') and");
        sbSql.append("  VHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
        sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
        sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
        sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e25: La Via no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
           try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Carrega la Via en el objecte que la cridat en la Data que ens donen.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public void darVia(int CDG_VIAaux, String NVIAaux, String Data)
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      sbSql = null;
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
        sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
        sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DVI.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DVI.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( DVI.NVIA ='"+ NVIAaux +"' or ");
        sbSql.append(   "'"+NVIAaux           +"' = '') and");
        sbSql.append("  ( VHD.CDG_VIA ='"+ CDG_VIAaux +"' or ");
        sbSql.append(   "'"+CDG_VIAaux          +"' = '-1') and");
        sbSql.append("  VHD.CVAR <> 'B' and ");
        sbSql.append("  VHD.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
        sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
        sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA and ");
        sbSql.append("    VHD.FVAR <= to_timestamp('"+ Data +"23:59:59','DD/MM/YYYY:HH24:MI:SS') and ");
        sbSql.append("    (");
        sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
        sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
         
        rSelect = stmt.executeQuery(sbSql.toString());
        
        reiniciar();
        
        if (rSelect.next())
        {
           rellenar(rSelect);
        }
        else
        {
           sError = sError + "e25: La Via no existeix." +"<br />";
        }

        } catch (Exception e)
        {
           sError = sError + ("Fallo en la base de datos:"+e + "<br />");
           try
           {con.cnPrincipal.rollback();
           }catch (Exception e2)
           {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
    }
    
    // Recopera la Via que ens han marcat a una data o ens retorna totes les d'una data si no ens han marcat cap.
    // Ho tornar en un Resulset.
    // Requereix que tenga puesta la provincia y el municipio de busqueda
    public ResultSet DarVias (String sData)
    {    
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
        sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
        sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DVI.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DVI.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  ( DVI.NVIA ='"+ NVIA +"' or ");
        sbSql.append(   "'"+NVIA           +"' = '') and");
        sbSql.append("  ( VHD.CDG_VIA ='"+ CDG_VIA +"' or ");
        sbSql.append(   "'"+CDG_VIA          +"' = '-1') and");
        sbSql.append("  VHD.CVAR <> 'B' and ");
        sbSql.append("  VHD.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
        sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
        sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA and ");
        sbSql.append("    VHD.FVAR <= to_timestamp('"+ sData +"','DD/MM/YYYY') and ");
        sbSql.append("    (");
        sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
        sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
       
        rSelect = stmt.executeQuery(sbSql.toString());
        
    } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Comprueba si la via existe.
    public boolean existeVia()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
        sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
        sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DVI.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DVI.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  VHD.CDG_VIA ='"+ CDG_VIA +"' and ");
        sbSql.append("  VHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
        sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
        sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA ");
        sbSql.append("    and ");
        sbSql.append("    ( ");
        sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
        sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
        sbSql.append("    ) ");
        sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprueba si el Nom de la via (que ve format per el nom de la via y el tipus de via) ya existeix sin tindre en compte el nostre propi DDSVIA_CVIA.
    //      (aixo es fa per evitar qie si updateixem un altre opci de la via el nom curt no ens surti que ya esta.)
    public boolean existeNvia()
    {
       boolean bResultado;
       bResultado = false;
       PDRTipusVia oTpsVia;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        oTpsVia = new PDRTipusVia(con, CDG_USR);
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
        sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
        sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DVI.CDG_PRV = '"+ CDG_PRV +"' and ");
        sbSql.append("  DVI.CDG_MNC = '"+ CDG_MNC +"' and ");
        sbSql.append("  VHD.CDG_VIA <>'"+ CDG_VIA +"' and ");
        sbSql.append("  DVI.NVIA    = '"+ NVIA    +"' and ");
        sbSql.append("  VHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
        sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
        sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA ");
        sbSql.append("    and ");
        sbSql.append("    ( ");
        sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
        sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
        sbSql.append("    ) ");
        sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            while (rs.next())
            {
              // Comprovem que el tipus de via no siguin iguals.
              oTpsVia.darTpsVia(Integer.parseInt(rs.getString("TPSVIA_CTIPVIA")), "");
              if (oTpsVia.TVIAN.compareTo(TPSVIA.TVIAN) == 0)
              {
                bResultado = true;
              }
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprueba si el Nom de la via existe, lo hace para el Insert por lo que todos cuentan.
    public boolean existeNviaInsert()
    {
       boolean bResultado;
       bResultado = false;
       PDRTipusVia oTpsVia;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        oTpsVia = new PDRTipusVia(con, CDG_USR);
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
        sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
        sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DVI.CDG_PRV = '"+ CDG_PRV +"' and ");
        sbSql.append("  DVI.CDG_MNC = '"+ CDG_MNC +"' and ");
        sbSql.append("  DVI.NVIA    = '"+ NVIA    +"' and ");
        sbSql.append("  VHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
        sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
        sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA ");
        sbSql.append("    and ");
        sbSql.append("    ( ");
        sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
        sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
        sbSql.append("    ) ");
        sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            while (rs.next())
            {
              // Comprovem que el tipus de via no siguin iguals.
              oTpsVia.darTpsVia(Integer.parseInt(rs.getString("TPSVIA_CTIPVIA")), "");
              if (oTpsVia.TVIAN.compareTo(TPSVIA.TVIAN) == 0)
              {
                bResultado = true;
              }
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprueba si el Nom curt de la via ya existeix sin tindre en compte el nostre propi DDSVIA_CVIA.
    //      (aixo es fa per evitar qie si updateixem un altre opci de la via el nom curt no ens surti que ya esta.)
    public boolean existeNviac()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
        sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
        sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DVI.CDG_PRV = '"+ CDG_PRV +"' and ");
        sbSql.append("  DVI.CDG_MNC = '"+ CDG_MNC +"' and ");
        sbSql.append("  VHD.CDG_VIA <>'"+ CDG_VIA +"' and ");
        sbSql.append("  DVI.NVIAC   = '"+ NVIAC   +"' and ");
        sbSql.append("  VHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
        sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
        sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA ");
        sbSql.append("    and ");
        sbSql.append("    ( ");
        sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
        sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
        sbSql.append("    ) ");
        sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprueba si el Nom curt de la via ya existeix teniendo en cuenta el propio es para el insert
    public boolean existeNviacInsert()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
        sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
        sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DVI.CDG_PRV = '"+ CDG_PRV +"' and ");
        sbSql.append("  DVI.CDG_MNC = '"+ CDG_MNC +"' and ");
        sbSql.append("  DVI.NVIAC   = '"+ NVIAC   +"' and ");
        sbSql.append("  VHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
        sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
        sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA ");
        sbSql.append("    and ");
        sbSql.append("    ( ");
        sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
        sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
        sbSql.append("    ) ");
        sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Comprova si existeix el codi de via.
    public boolean existeCVIA()
    {
       boolean bResultado;
       bResultado = false;
       
       // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
            sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
            sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
            sbSql.append("  ) and ");
            sbSql.append("  DVI.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DVI.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  DVI.CVIA ='"+ CVIA +"' and ");
            sbSql.append("  VHD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
            sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
            sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
            sbSql.append("    ) and "); 
            sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA ");
            sbSql.append("    and ");
            sbSql.append("    ( ");
            sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
            sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
            sbSql.append("    ) ");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    
    // Comprova si te asignat algn Habitatge.
    public boolean teTram()
    {
        boolean bResultado;
        bResultado = false;
       
        // Conexio
        Statement stmt; 
        StringBuffer sbSql;
        
        sbSql = null;
        try{
            stmt = con.cnPrincipal.createStatement();
       
            // Preparem la sentncia SQL
            sbSql  = new StringBuffer("");
            sbSql.append("Select * From ");
            sbSql.append(" PDR_TRM_has_DDSTRM THD,PDR_DDSTRM DTR");
            sbSql.append(" where ");
            sbSql.append("  ( ");
            sbSql.append("   DTR.CDG_PRV     = THD.CDG_PRV     and ");
            sbSql.append("   DTR.CDG_MNC     = THD.CDG_MNC     and ");
            sbSql.append("   DTR.DDSTRM_CTRM = THD.DDSTRM_CTRM     ");
            sbSql.append("  ) and ");
            sbSql.append("  DTR.CDG_PRV ='"+ CDG_PRV +"' and ");
            sbSql.append("  DTR.CDG_MNC ='"+ CDG_MNC +"' and ");
            sbSql.append("  DTR.CDG_VIA    ='"+ CDG_VIA +"' and ");
            sbSql.append("  THD.CVAR <> 'B' and ");
            sbSql.append("  NOT EXISTS ");
            sbSql.append("  ( ");
            sbSql.append("    Select 1 ");
            sbSql.append("    from PDR_TRM_has_DDSTRM THD2, PDR_DDSTRM DTR2 ");
            sbSql.append("    Where");
            sbSql.append("    (");
            sbSql.append("      DTR2.CDG_PRV     = THD2.CDG_PRV     and ");
            sbSql.append("      DTR2.CDG_MNC     = THD2.CDG_MNC     and ");
            sbSql.append("      DTR2.DDSTRM_CTRM = THD2.DDSTRM_CTRM ");
            sbSql.append("    ) and "); 
            sbSql.append("    THD.CDG_CTRM = THD2.CDG_CTRM ");
            sbSql.append("    and ");
            sbSql.append("    (");
            sbSql.append("    DTR.DDSTRM_CTRM < DTR2.DDSTRM_CTRM  or ");
            sbSql.append("    DTR2.DDSTRM_CTRM =  -1");
            sbSql.append("    )");
            sbSql.append("  ) ");
            
            ResultSet rs = stmt.executeQuery(sbSql.toString());
           
            if (rs.next())
            {
              bResultado = true;
            }
            stmt.close();
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(bResultado);
    }
    
    // Dona en un resulset totes les Vies que no estiguin donats de baixa.
    public ResultSet TotsVia()
    {
      // Conexio
      Statement stmt; 
      StringBuffer sbSql;
      ResultSet rSelect;
      
      rSelect = null;
      sbSql   = null;
      
      try{
          
        stmt = con.cnPrincipal.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE );

        // Preparem la sentncia SQL
        sbSql  = new StringBuffer("");
        sbSql.append("Select * From ");
        sbSql.append(" PDR_Via_has_DDSVia VHD,PDR_DDSVIA DVI");
        sbSql.append(" where ");
        sbSql.append("  ( ");
        sbSql.append("   DVI.CDG_PRV     = VHD.CDG_PRV     and ");
        sbSql.append("   DVI.CDG_MNC     = VHD.CDG_MNC     and ");
        sbSql.append("   DVI.DDSVIA_CVIA = VHD.DDSVIA_CVIA     ");
        sbSql.append("  ) and ");
        sbSql.append("  DVI.CDG_PRV ='"+ CDG_PRV +"' and ");
        sbSql.append("  DVI.CDG_MNC ='"+ CDG_MNC +"' and ");
        sbSql.append("  VHD.CVAR <> 'B' and ");
        sbSql.append("  NOT EXISTS ");
        sbSql.append("  ( ");
        sbSql.append("    Select 1 ");
        sbSql.append("    from PDR_Via_has_DDSVia VHD2, PDR_DDSVIA DVI2 ");
        sbSql.append("    Where");
        sbSql.append("    (");
        sbSql.append("      DVI2.CDG_PRV     = VHD2.CDG_PRV     and ");
        sbSql.append("      DVI2.CDG_MNC     = VHD2.CDG_MNC     and ");
        sbSql.append("      DVI2.DDSVIA_CVIA = VHD2.DDSVIA_CVIA ");
        sbSql.append("    ) and "); 
        sbSql.append("    VHD.CDG_VIA = VHD2.CDG_VIA ");
        sbSql.append("    and ");
        sbSql.append("    (");
        sbSql.append("    DVI.DDSVIA_CVIA < DVI2.DDSVIA_CVIA  or ");
        sbSql.append("    DVI2.DDSVIA_CVIA =  -1");
        sbSql.append("    )");
        sbSql.append("  ) ");
        sbSql.append("  order by NVIA ");
            
        rSelect = stmt.executeQuery(sbSql.toString());
        
     } catch (Exception e)
    {
         sError = sError + ("Fallo en la base de datos:"+e + "<br />");
         try
         {con.cnPrincipal.rollback();
         }catch (Exception e2)
         {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
    }
      return (rSelect);
    }
    
    // Ens dona un desplegable amb totes les obcions per Via.
    public String MostrarVia (int PRV, int MNC)
    {
        StringBuffer sResultat;
        ResultSet    rSelect; 
        PDRVia       oVia;
        int          i;
        
        sResultat = new StringBuffer("");
        oVia      = new PDRVia(con, CDG_USR);
        i = 0;
        
        try
        {
            // Coloquem en el objecta les Provincia y Municipi corresponent.
            oVia.CDG_PRV = PRV;
            oVia.CDG_MNC = MNC;
            
            // obtenim els Tots els Tipus de Via
            rSelect = oVia.TotsVia();
            
            sResultat.append("<SELECT NAME=\"VIA\" STYLE=\"width: 144px;\">");
            sResultat.append("<OPTION VALUE=\"\">Ninguna</OPTION>");
            // Posem tantes opcions com tipus de via hi aixin.
            while (rSelect.next())
            {      
                oVia.rellenar(rSelect);
                
                sResultat.append(" <OPTION VALUE=\""+oVia.CDG_VIA +"\"");
                if (CDG_VIA == oVia.CDG_VIA)  //(NVIA.compareTo(oVia.NVIA) == 0 )
                {
                    sResultat.append(" SELECTED ");
                }
                // Miramos si tiene que ser prefijo o sufijo
                if (oVia.POS == 0)
                {
                    sResultat.append(" >"+oVia.TPSVIA.TVIA +" "+ oVia.NVIA+"</OPTION>" );
                }
                else
                {
                    sResultat.append(" >"+ oVia.NVIA +" "+ oVia.TPSVIA.TVIA+"</OPTION>" );
                }
            }
             sResultat.append("</SELECT>");
            
            
        } catch (Exception e)
        {
             sError = sError + ("Fallo en la base de datos:"+e + "<br />");
             try
             {con.cnPrincipal.rollback();
             }catch (Exception e2)
             {sError = sError + ("Fallo en la base de datos al hacer un rollback:"+ e2 + "<br />");}
        }
       return(sResultat.toString());
    }
    
    // Comprova si la via es correcta per inserir-la.
    public void comprobacionInsert()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (TPSVIA.TVIA.compareTo("")==0)// Problema 37
      {
          sResultado = sResultado + "e37: Falta posar el nom del Tipus de Via. <br /> " ;
      }
      
      if (! TPSVIA.existeTipusVia())// Problema 27
      {
          sResultado = sResultado + "e27: El tipus de Via no existeix. <br /> " ;
      }
      
      if (POS == -1)// Problema 20
      {
          sResultado = sResultado + "e20: Falta posar la posici de la via. <br /> " ;
      }
      
      if (POS != 0 && POS != 1 )// Problema 21
      {
          sResultado = sResultado + "e21: La posici de la Via es incorrecta. <br /> " ;
      }
      
      if (NVIA.compareTo("")==0)// Problema 22
      {
          sResultado = sResultado + "e22: Faltar posar el nom de la Via. <br /> " ;
      }
      
      if (NVIAC.compareTo("")==0)// Problema 23
      {
          sResultado = sResultado + "e23: Falta posar el nom curt de la Via. <br /> " ;
      }
      if (existeNviaInsert())// Problema 34
      {
          sResultado = sResultado + "e34: El nom de la via ja existeix. <br /> " ;
      }
      if (existeNviacInsert())// Problema 35
      {
          sResultado = sResultado + "e35: El nom curt de la via ja existeix. <br /> " ;
      }
      
      /*
      if (existeCVIA ())
      {
          sResultado = sResultado + "e28: El codi de la Via ja existeix. <br /> " ;
      }*/
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la Via se puede updatear
    public void comprobacionUpdate()
    {
      String sResultado;
      sResultado = "";
              
      // El nombre ens indica el problema. 
      if (CDG_VIA == -1)// Problema 16
      {
          sResultado = sResultado + "e16: El update requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      
      if (TPSVIA.TVIA.compareTo("")==0)// Problema 37
      {
          sResultado = sResultado + "e37: Falta posar el nom del Tipus de Via. <br /> " ;
      }
      
      if (! TPSVIA.existeTipusVia())// Problema 27
      {
          sResultado = sResultado + "e27: El tipus de Via no existeix. <br /> " ;
      }
      
      if (POS == -1)// Problema 20
      {
          sResultado = sResultado + "e20: Falta posar la posici de la via. <br /> " ;
      }
      
      if (POS != 0 && POS != 1 )// Problema 21
      {
          sResultado = sResultado + "e21: La posici de la Via es incorrecta. <br /> " ;
      }
      
      if (NVIA.compareTo("")==0)// Problema 22
      {
          sResultado = sResultado + "e22: Faltar posar el nom de la Via. <br /> " ;
      }
      
      if (NVIAC.compareTo("")==0)// Problema 23
      {
          sResultado = sResultado + "e23: Falta posar el nom curt de la Via. <br /> " ;
      }
      
      if (! existeVia() )// Problema 25
      {
        sResultado = sResultado + "e25: La Via no existeix. <br /> " ;
      }
      
      // Comprova si las dades se adecuan a las de la base de dades.
      if (! TPSVIA.existeTipusVia() )// Problema 24
      {
        sResultado = sResultado + "e24: El tipus de Via no existeix. <br /> " ;
      }
      
      if (existeNvia())// Problema 34
      {
          sResultado = sResultado + "e34: El nom de la via ja existeix. <br /> " ;
      }
      
      // El nombre ens indica el problema. 
      if (existeNviac())// Problema 35
      {
          sResultado = sResultado + "e35: El nom curt de la via ja existeix. <br /> " ;
      }
      
      /*
      if (existeCVIA ())
      {
          sResultado = sResultado + "e28: El codi de la Via ja existeix. <br /> " ;
      }
       */
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprueba si la provincia se puede borrar.
    public void comprobacionDelete()
    {
      String sResultado;
      sResultado = "";
      
      // El nombre ens indica el problema. 
      if (! existeVia() )// Problema 25
      {
        sResultado = sResultado + "e25: La Via no existeix. <br /> " ;
      }
      
      if (CDG_VIA == -1)// Problema 16
      {
        sResultado = sResultado + "e138: El delete requereix que s'arribi a un element mitjanant una cerca. <br /> " ;
      }
      if (teTram())// Problema 134
      {
        sResultado = sResultado + "e134: La Via esta relacionada amb un Tram. <br /> " ;
      }
      
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
    // Comprova si podem fer el select.
    public void comprobacionSelect()
    {
      String sResultado;
      sResultado = "";
      
      // No hi ha comprovacions.
      if (sResultado.compareTo("") != 0)
      {
       sError = sError + sResultado + "<br />";
      }
    }
    
}
